#INCLUDE "jabber.h"

************************************************************************************
**
** Jabber layer for VFP 7.0 and heigher
** Portions of this software based on SocketWrench, licensed from Catalyst Development Corporation
** (http://www.catalyst.com/products/socketwrench)
** Author: Martin Jindra
** E-mail: martin.jindra@egservis.cz
** Date:   2005-03-22
** 
**
**
**
************************************************************************************




**************************************************************
DEFINE CLASS _JabberLayer AS CUSTOM && Zkladn tda Jabber klienta
   Name="_JabberLayer"

   iQueue=0
   DIME aQueue(_JC_DataSystem+1,2),aShows(5,2)
   aShows(1,1)="online"
   aShows(1,2)="Online"
   aShows(2,1)="chat"
   aShows(2,2)="Chat"
   aShows(3,1)="away"
   aShows(3,2)="Away"
   aShows(4,1)="xa"
   aShows(4,2)="Extended Away"
   aShows(5,1)="dnd"
   aShows(5,2)="DND"
*   aShows(6,1)="offline"
*   aShows(6,2)="Offline"



   GlobalStatus= _JC_GS_None
   Version="0.0.0.5"
 
   Server="jabber.org"
   IP=""
   Port=5222
   User=""
   Password=""
   Resource=""
   Priority=""
   DefNick=""
   Plain=.F.

   SessionID=""
   oXML=.NULL.

   ***************************************************
   Catch=.NULL. && Pznak, e se m chyba zachytit
   ErrCount=0 &&  Hard error count
   WarnCount=0 && Warning count
   ErrStopCount=-1 && Max hard error count for cancel processing

   nErr=0 && Error number
   cErrMSG="" && Message error
   ***************************************************

   hLogFile=0
   StartTime=0

   cCollate=""
   AConf="" && Alias 
   AEVENTS="" && Alias udlostn zench ...
   ALAG="" && Alias zpoovac fronty
   ASend="" && Alias pro postupn odesln dat
   iSend=0 && Poet zpis

   iLeaveFromConf=0
   IsReconnect=.F. && Pznak optovnho pipojen (doasn)
   iReconnect=0 && Poet optovnch pipojen

   iMode=0
   ReplyFrom="" && kl from pro odpov

   StartPath=""

   ADD OBJECT tmrLag AS _tmrJCLag
   ADD OBJECT tmrto AS _tmrJCTimeOut
   ADD OBJECT tmrjc AS _tmrJC
   ADD OBJECT tmrsn AS _tmrJCSend


   PROCEDURE GlobalStatus_Assign(liVal)
       IF TYPE("liVal")#"N"
          MESSAGEBOX("Stop. GlobalStatus mismatch")
          SUSP
       ELSE
          This.GlobalStatus=liVal
       ENDIF
   ENDPROC

   PROCEDURE OpenTable(lcFile,lcAlias,lcParam,liDSID) && Oteve tabulku
      * lcFile  - Umstn a nzev DBF souboru
      * lcAlias - Alias 
      * lcParam - Parametry
      * liDSID  - Datasession ID

      LOCAL luCatch,liDSIDOld
      liDSID=IIF(PCOUNT()<4,-1,liDSID)
      luCatch=m.This.SetCatch(.T.) && Nastav zachycen chyby
      liDSIDOld=1 && m.This.DataSessionID
      IF liDSID>=0
         SET DATASESSION TO liDSID && Nastav poadovanou DS
      ENDIF
      USE (m.lcFile) ALIAS (m.lcAlias) IN 0 &lcParam.
      SET DATASESSION TO (liDSIDOld) && Nastav 
      m.This.SetCatch(m.luCatch) && Zru zachycen chyby
      RETURN m.This.nErr
   ENDPROC

   PROCEDURE WriteToFile(lcFile,lcText) && Zape do souboru
      * lcFile - nzev souboru
      * lcText - text

      LOCAL liFile,hLockFile,lii,llExist
      LOCAL ARRAY laFile(1)
      liFile=0
      hLockFile=_open( (m.lcFile+".lck"), _O_CREAT + _O_WRONLY , _S_IWRITE)
      IF m.hLockFile == -1
         RETURN ErrOther
      ENDIF

      lii=ADIR(laFile,m.lcFile,"AHRS")
      llExist=m.lii>0

      lii=0
      DO WHILE _locking( m.hLockFile, _LK_LOCK, 1 ) != 0 AND m.lii<50
         =Sleep(100)
         lii=m.lii+1
      ENDDO
      IF m.lii<=50
         liFile = _fopen( m.lcFile, ("at") ) &&  text pidvej na konec
         IF m.liFile>0
            _fprintf(m.liFile, "%s", m.lcText)
            _fclose(m.liFile )
         ENDIF
         * unlock and lock file
         _locking( m.hLockFile, _LK_UNLCK, 10 )
      ENDIF

      * unlock and close lock file
      _close( m.hLockFile )
      RETURN ErrOK
   ENDPROC

   PROCEDURE WriteToErr(m.lcText) && Zape do err souboru
      IF FILE(m.This.MainPath+"log\err"+DTOS(DATE()-1)+".log.lck")
         DELE FILE (m.This.MainPath+"log\err"+DTOS(DATE()-1)+".log.lck")
      ENDIF
      This.WriteToFile(m.This.MainPath+"log\err"+DTOS(DATE())+".log",m.lcText)
   ENDPROC


   PROCEDURE WriteToLog(m.lcText) && Zape do log souboru
      IF FILE(m.This.MainPath+"log\jb"+DTOS(DATE()-1)+".log.lck")
         DELE FILE (m.This.MainPath+"log\jb"+DTOS(DATE()-1)+".log.lck")
      ENDIF
      This.WriteToFile(m.This.MainPath+"log\jb"+DTOS(DATE())+".log",m.lcText)
   ENDPROC


   PROCEDURE Error(nError,cMethod,nLine) && Chybov rutina
      * nError  - slo chyby
      * cMethod - Nzev metody ve kter dolo k chyb
      * nLine   - slo dku na kterm dolo k chyb
      _JabberLayer::WriteToErr(PROGRAM(PROGRAM(-1)-1)+":"+cMethod+":"+LTRIM(STR(nLine,11))+" "+MESSAGE()+CRLF)
      IF ISNULL(m.This.Catch) && Pokud nen definovno
         * Pak zavi, nebo jde o chybu mimo provdn
         This.nErr=m.nError && slo chyby
         This.cErrMSG=MESSAGE() && Hlen chyby
         RETURN && A vysko ven
      ENDIF
      IF This.Catch && M ji zachytit
         This.nErr=nError && slo chyby
         This.cErrMSG=MESSAGE() && Hlen chyby
         This.WarnCount=m.This.WarnCount+1 && Inkrementuj ta chyb
      ELSE
         This.ErrCount=m.This.ErrCount+1 && Inkrementuj ta chyb
      ENDIF
   ENDPROC

   PROCEDURE SetCatch(llCatch) && Nastaven zachycen chyby
      LOCAL luCatch
      luCatch=m.This.Catch
      This.Catch=m.llCatch
      IF llCatch && Pokud m chybu zachytit
         * Pak vyresetuj nastaven chyby
         This.nErr=0 && slo chyby
         This.cErrMSG="" && Hlen chyby
      ENDIF
      RETURN m.luCatch && Vra pvodn nastaven
   ENDPROC

   PROCEDURE ClearReferences()
   ENDPROC

   PROCEDURE Destroy()
      IF USED(m.This.AConf)
         USE IN (m.This.AConf)
      ENDIF
      IF USED(m.This.AEVENTS)
         USE IN (m.This.AEVENTS)
      ENDIF
      IF USED(m.This.ALAG)
         USE IN (m.This.ALAG)
      ENDIF
      IF USED(m.This.ASEND)
         USE IN (m.This.ASEND)
      ENDIF

      IF FILE(m.This.StartPath+"log\jb"+DTOS(DATE())+".log.lck")
         DELE FILE (m.This.StartPath+"log\jb"+DTOS(DATE())+".log.lck")
      ENDIF

      IF FILE(m.This.StartPath+"log\err"+DTOS(DATE())+".log.lck")
         DELE FILE (m.This.StartPath+"log\err"+DTOS(DATE())+".log.lck")
      ENDIF
      RELEASE PROCEDURE (This.StartPath+"sha1.prg")
      RELEASE PROCEDURE (This.StartPath+"jabberprc.prg")
      RELEASE CLASSLIB (This.StartPath+"CryptPak.vcx") 

      SET COLLATE TO (m.This.cCollate)
   ENDPROC

   PROCEDURE Init()
      LOCAL lcPath
      SET TALK OFF
      SET EXCL OFF
      SET CENTURY ON
      SET ANSI OFF
      SET SAFE OFF
      SET NEAR OFF
      SET FIXED OFF
      SET REPROCES TO 1
      SET SYSFORMATS ON
      SET DATE TO GERMAN
      SET MULTILOCK ON
      SET MEMOWIDTH TO 256

      SET STEP OFF
      SET ESCAPE OFF
      SET ECHO OFF
      SET CURSOR ON
      SET STATUS OFF
      SET DEVICE TO SCREEN
      SET MESSAGE TO
      SET HELP OFF
      SET MACKEY TO
      SET TYPEAHEAD TO 100
      SET NOTIFY OFF && zaka systmov hlky
*      SET RESOURCE OFF
      CLEA MACROS
      SET TABLEVALIDATE TO 0

      lcPath=SYS(16,0)
      lcPath=SUBST(lcPath,AT(" ",lcPath,2)+1)
      This.StartPath=IIF(RAT("\",lcPath)>0,LEFT(lcPath,RAT("\",lcPath)),lcPath)

      DECLARE LONG  fopen IN msvcrt20.dll AS _fopen STRING @, STRING @
      DECLARE LONG  _wfopen IN msvcrt20.dll AS _wfopen STRING @, STRING @
      DECLARE LONG  fclose IN msvcrt20.dll AS _fclose LONG
      DECLARE LONG  fprintf IN msvcrt20.dll AS _fprintf LONG, STRING, STRING
      DECLARE LONG  fwprintf IN msvcrt20.dll AS _fwprintf LONG, STRING, STRING
      DECLARE LONG  fwrite IN msvcrt20.dll AS _fwrite STRING @, INTEGER, INTEGER,  LONG
      DECLARE LONG  _open IN msvcrt20.dll STRING @, INTEGER, INTEGER
      DECLARE LONG  _close IN msvcrt20.dll LONG
      DECLARE LONG  _locking IN msvcrt20.dll LONG, INTEGER, INTEGER
      DECLARE INTEGER MoveFile IN KERNEL32 STRING @, STRING @
      DECLARE       Sleep IN kernel32 integer

      This.cCollate=SET("COLLATE")
      SET COLLATE TO "MACHINE"
      This.AConf=SYS(2015)
      This.AEVENTS=SYS(2015)
      This.ALag=SYS(2015)
      This.ASend=SYS(2015)

      CREATE CURSOR (This.AConf) (JID M NOCPTRANS, NICK M NOCPTRANS, XX200 I, XX204 I)
      INDEX ON LEFT(JID,240) TAG XXI000 FOR !DELE()

      CREATE CURSOR (This.AEVENTS) (XX200 N(2), XX201 M NOCPTRANS, XX202 M NOCPTRANS, XX203 M NOCPTRANS, XX204 N(1))
      INDEX ON STR(XX200,2)+LEFT(XX201,200) TAG XXI000
      INDEX ON STR(XX200,2)+LEFT(XX203,200) TAG XXI001

      CREATE CURSOR (This.ALag) (XX302 N(1), XX300 T, XX301 M NOCPTRANS, XX303 I)
      INDEX ON STR(XX302,1) TAG XXI000
      INDEX ON XX300        TAG XXI001

      CREATE CURSOR (This.ASend) (XX400 I, XX401 M NOCPTRANS)
      INDEX ON XX400 TAG XXI000


      SET CLASSLIB TO (This.StartPath+"CryptPak.vcx") ADDITIVE
      SET PROCEDURE TO (This.StartPath+"sha1.prg") ADDITIVE
      SET PROCEDURE TO (This.StartPath+"jabberprc.prg") ADDITIVE

      This.AddObject("SHA1","_SHA1")


      *** All work is done using CryptPak object ***
      This.AddObject("oCryptPak","CryptPak")

   ENDPROC

   PROCEDURE Quit() && Quit
      IF m.This.GlobalStatus=_JC_GS_Disconnecting_CF OR ;
         m.This.GlobalStatus=_JC_GS_Disconnecting_LC OR ;
         m.This.GlobalStatus=_JC_GS_Reconnect OR ;
         m.This.GlobalStatus=_JC_GS_Restart

         This.GlobalStatus=_JC_GS_Disconnecting
         This.Disconnected()
         RETURN TO MASTER
      ENDIF
      m.This.Disconnect()
   ENDPROC

   PROCEDURE Disconnect(liStatus) && Disconnect from jabber server
      LOCAL loWS,lii,lcAlias,llExist

      IF !INLIST(This.GlobalStatus,_JC_GS_Joined,_JC_GS_Disconnecting,_JC_GS_Reconnect)
         This.GlobalStatus=_JC_GS_Disconnecting
         This.Disconnected()
         RETURN TO MASTER
      ENDIF



      loWS=m.This.cntjc.oWS
      IF m.loWS.GetState()#sckConnected
         RETURN TO MASTER
      ENDIF


      liStatus=IIF(PCOUNT()=0 OR TYPE("liStatus")#"N",_JC_GS_Disconnecting,liStatus)

      IF PCOUNT()=1 AND INLIST(liStatus,_JC_GS_Reconnect,_JC_GS_Restart) && Udlj zlohu (restart)
         lcAlias=SYS(2015)
         =CopyCursor(This.AConf,@m.lcAlias,.T.,.T.)
         SELE (m.lcAlias)
      ENDIF
      
      * Odhla se ze vech konferenc
      SELE (m.This.AConf)
      COUNT TO This.iLeaveFromConf FOR XX200>0
      SCAN ALL FOR XX200>0
           FOR lii=1 TO XX200
               =m.This.LeaveFromConf(JID,NICK)
           NEXT
           SELE (m.This.AConf)
      ENDSCAN
      
      * A nyn zlohu pekopruj zpt do ostr tabulky (restart)
      IF PCOUNT()=1 AND INLIST(liStatus,_JC_GS_Reconnect,_JC_GS_Restart) && Udlj zlohu
         SELE (m.This.AConf)
         ZAP
         =CopyCursor(@m.lcAlias,This.AConf,.T.,.F.)
         USE IN (m.lcAlias)
      ENDIF

      This.GlobalStatus=liStatus
      This.tmrTO.Enabled=.F. && Zastavit natvrdo
      This.tmrJC.Enabled=.T.
   ENDPROC

   PROCEDURE Disconnected() && Udlost
      This.tmrSN.Enabled=.F.
      IF This.GlobalStatus=_JC_GS_Disconnecting
         This.GlobalStatus= _JC_GS_None
      ENDIF
      =IIF(PEMSTATUS(This,"cntJC",5),This.RemoveObject("cntJC"),.T.)
      This.tmrLag.Enabled=.F.
      This.tmrJC.Enabled=.F.
      STORE .NULL. TO This.aQueue
   ENDPROC

   PROCEDURE Connect(lcServer,liPort,lcUser,lcPWD) && Connect to jabber server
      =This.WriteToLog("SYSTEM: Start connect..."+CRLF)
      This.oXML=m.This.GetXMLDOM()
      _vfp.AutoYield=.F.
      This.AddObject("cntJC","_cntjcWS")
      
      ZAP IN (m.This.ASend)
      INSERT INTO (This.ASend) (XX400) VALUES (_ID_Max)

      IF PCOUNT()=4
         This.Server=m.lcServer
         This.Port=m.liPort
         This.User=m.lcUser
         This.Password=m.lcPWD
         IF EMPTY(m.This.DefNick)
            m.This.DefNick=m.lcUser
         ENDIF
      ENDIF

      STORE .NULL. TO This.aQueue
      This.GlobalStatus=_JC_GS_None
      This.ReplyFrom=This.User+"@"+This.Server+"/"+This.Resource
      IF PCOUNT()=0
         This.cntjc.oWS.VFPConnect(m.This.Server,m.This.Port)
      ELSE
         This.cntjc.oWS.VFPConnect(m.lcServer,m.liPort)
      ENDIF

   ENDPROC

   PROCEDURE StartComponent(lcServer,liPort,lcComponent,lcSecret) && Start component
      =This.WriteToLog("SYSTEM: Start connect..."+CRLF)
      This.oXML=m.This.GetXMLDOM()
      _vfp.AutoYield=.F.
      This.AddObject("cntJC","_cntjcWS")
      
      ZAP IN (m.This.ASend)
      INSERT INTO (This.ASend) (XX400) VALUES (_ID_Max)

      IF PCOUNT()=4
         This.Server=m.lcServer
         This.Port=m.liPort
         This.User=m.lcComponent
         This.Password=m.lcSecret
      ENDIF

      STORE .NULL. TO This.aQueue
*      This.ReplyFrom=This.User+"."+This.Server
      This.GlobalStatus=_JC_GS_None
      IF PCOUNT()=0
         This.cntjc.oWS.StartComponent(m.This.Server,m.This.Port)
      ELSE
         This.cntjc.oWS.StartComponent(m.lcServer,m.liPort)
      ENDIF
   ENDPROC


   PROCEDURE StartService(lcServer,liPort) && Start service
*      =This.WriteToLog("SYSTEM: Start connect..."+CRLF)
      This.oXML=m.This.GetXMLDOM()
      _vfp.AutoYield=.F.
      This.AddObject("cntJC","_cntjcWS")
      
*!*	      ZAP IN (m.This.ASend)
*!*	      INSERT INTO (This.ASend) (XX400) VALUES (_ID_Max)


*!*	      STORE .NULL. TO This.aQueue
      This.GlobalStatus=_JC_GS_None
      IF PCOUNT()=0
         This.cntjc.oWS.StartService(m.This.Server,m.This.Port)
      ELSE
         This.cntjc.oWS.StartService(m.lcServer,m.liPort)
      ENDIF

*!*	      IF PCOUNT()=4
*!*	         This.Server=m.lcServer
*!*	         This.Port=m.liPort
*!*	         This.User=m.lcUser
*!*	         This.Password=m.lcPWD
*!*	         IF EMPTY(m.This.DefNick)
*!*	            m.This.DefNick=m.lcUser
*!*	         ENDIF
*!*	      ENDIF
   ENDPROC

   PROCEDURE Reconnect(liInterval) && Reconnect to jabber server
      This.IsReconnect=.T.
      This.tmrJC.Index=0
      This.tmrJC.MaxIndex=INT(liInterval/This.tmrJC.Interval)
      This.tmrJC.Reset()
      This.GlobalStatus=_JC_GS_Reconnect
      This.tmrJC.Enabled=.T.
   ENDPROC


   PROCEDURE Connected() && Dolo ke kompletnmu pihlen k JS
      LOCAL lcAlias,lii
      =This.WriteToLog("SYSTEM: Connected"+CRLF)

      * Pokud dolo k optovnmu pihlen
      IF This.IsReconnect
         This.iReconnect=This.iReconnect+1
         This.IsReconnect=.F.
      ENDIF

      * Udlj kopii pihlench konferenc
      * a pvodn soubor vyma
      * znovu pihla konference

      DO CASE
         CASE m.This.iMode=0
              IF RECC(This.AConf)>0
                 lcAlias=SYS(2015)
                 =CopyCursor(This.AConf,@m.lcAlias,.T.,.T.)

                 SELE (This.AConf)
                 ZAP

                 SELE (lcAlias)
                 SCAN ALL
                      FOR lii=1 TO XX200
                          =This.JoinToConf(JID,NICK)
                          SELE (lcAlias)
                      NEXT
                 ENDSCAN
                 USE
              ENDIF
              This.tmrTO.Enabled=.T.

         CASE m.This.iMode=1

      ENDCASE

   ENDPROC

   PROCEDURE ConnectionFailed(liStatus) && Nedolo ke kompletnmu pihlen k JS
      * liStatus - Status nephleni
      =This.WriteToLog("SYSTEM: Connection failed"+CRLF)
      debugout("Connection failed")
      LOCAL loWS
      loWS=m.This.cntjc.oWS

      This.GlobalStatus=_JC_GS_Disconnecting_CF
      =m.loWS.VFPDisconnect() 
      m.This.oXML=.NULL.
      =m.This.Disconnected()
   ENDPROC

   PROCEDURE LostConnection(liStatus) && Spojen ztraceno
      * liStatus - Status spojen - Winsock
      =This.WriteToLog("SYSTEM: Lost connection"+CRLF)
      debugout("Lost connection")
      LOCAL loWS
      loWS=m.This.cntjc.oWS

      lcAlias=SYS(2015)
      =CopyCursor(This.AConf,@m.lcAlias,.T.,.T.)
      SELECT (This.AConf)
      ZAP
      SELE (m.lcAlias)
      SET FILT TO XX204=1
      =CopyCursor(@m.lcAlias,This.AConf,.T.,.F.)
      USE IN (m.lcAlias)
      This.GlobalStatus=_JC_GS_Disconnecting_LC
      =m.loWS.VFPDisconnect() 
      m.This.oXML=.NULL.
      =m.This.Disconnected()
   ENDPROC

   PROCEDURE Restart()
      This.Disconnect(_JC_GS_Restart)
   ENDPROC

   PROCEDURE AddToQueue(liIndex,lcData) && Add request to queue
      * lcData - XML data
      * Convert XML data TO XML hierarchy
      m.This.oXML.LoadXML(m.lcData)
      m.This.aQueue(m.liIndex,1)=m.This.oXML.CloneNode(.T.)
   ENDPROC

   PROCEDURE AddDataToQueue(liIndex,lcData) && Find Data into queue
      * lcData - XML data
      * Convert XML data TO XML hierarchy
      lcData=STRTRAN(STRTRAN(m.lcData,"/XML/","/XXX/"),":xml",":xxx")
      debugout "RECEIV: "+STRCONV(m.lcData,11)
      IF !m.This.oXML.LoadXML(m.lcData)
         debugout "LXMLF: "+STRCONV(m.lcData,11)
         This.WriteToLog("LXMLF: "+m.lcData+CRLF)
      ELSE
         m.This.aQueue(IIF(m.liIndex=_JC_DataNext,_JC_DataSystem+1,m.liIndex),2)=m.This.oXML.CloneNode(.T.)
         =m.This._DataArrival(m.This.aQueue(IIF(m.liIndex=_JC_DataNext,_JC_DataSystem+1,m.liIndex),2))
      ENDIF
   ENDPROC

   PROCEDURE GetDataFromQueue(liIndex) && Get returned Data from queue
      * lcData - XML data
      * Convert XML data TO XML hierarchy
      RETURN m.This.aQueue(m.liIndex,2)
   ENDPROC

   PROCEDURE _DataArrival(loXML) && Internal Event
      This.DataArrival(m.loXML) && Event
   ENDPROC


   PROCEDURE DataArrival(loXML) && Event
      LOCAL lcID,llSeek,liSele,liRet,loJCP,llSec,liType

      loJCP=CREATEOBJECT("_jc_process")
      loJCP.oXML=m.loXML

      IF m.loXML.documentElement.nodename=="presence"
         lcType=m.loXML.documentElement.GetAttribute("type")
         IF lcType="error"
            STORE m.loXML.documentElement.GetAttribute("id") TO lcID,loJCP.ID
            IF !ISNULL(m.lcID)
               loJCP.Key=This.GetKeyFromID(@m.lcID)
            ELSE
               loJCP.Key=""
               llSec=.T.
               STORE m.loXML.documentElement.GetAttribute("from") TO loJCP.ID,lcID 
            ENDIF
         ELSE
            llSec=.T.
            STORE m.loXML.documentElement.GetAttribute("from") TO loJCP.ID,lcID 
            loJCP.Key=IIF(ISNULL(lcType),"JC",IIF(lcType="unavailable","LC",""))
         ENDIF
      ELSE
         IF m.loXML.documentElement.nodename=="handshake"
            llSec=.T.
            STORE "handshake" TO loJCP.ID,lcID 
            loJCP.Key=""
         ELSE
            STORE m.loXML.documentElement.GetAttribute("id") TO loJCP.ID,lcID 
            IF !ISNULL(m.lcID)
               loJCP.Key=This.GetKeyFromID(@m.lcID)
            ELSE
               loJCP.Key=""
               llSec=.T.
               STORE m.loXML.documentElement.GetAttribute("from") TO loJCP.ID,lcID 
            ENDIF
         ENDIF
      ENDIF

      liType=IIF(m.loXML.documentElement.nodename=="iq",_JC_E_iq,;
             IIF(m.loXML.documentElement.nodename=="presence",_JC_E_pr,;
             IIF(m.loXML.documentElement.nodename=="message",_JC_E_msg,;
             IIF(m.loXML.documentElement.nodename=="handshake",_JC_E_handshake,;
             IIF(m.loXML.documentElement.nodename=="stream:stream",_JC_E_stream,-1)))))

      liSele=SELE()
      SELE (m.This.AEVENTS)
      SET ORDER TO (IIF(llSec,"XXI001","XXI000"))
      IF LEN(m.lcID)+2>240
         SET KEY TO (STR(liType,2)+m.lcID)
         LOCATE FOR XX201==m.lcID
         llSeek=FOUND()
         SET KEY TO
      ELSE
         llSeek=SEEK(STR(liType,2)+m.lcID)
      ENDIF
      IF llSeek && Ano, je to sledovan
         loJCP.oTracklyXML=m.This.GetXMLDOM()
         liRet=IIF(m.loJCP.oTracklyXML.LoadXML(XX202),_JC_P_Trackly,_JC_P_Failed)
         REPL XX200 WITH -1
         SCATTER NAME loJCP.ERam MEMO
      ELSE
         liRet=_JC_P_Free
      ENDIF
      m.loJCP.Status=liRet
      SELE (m.liSele)

      * Info/query
      IF m.loXML.documentElement.nodename=="iq"
         m.This._GetIQ(m.loJCP)
         RETURN
      ENDIF

      * Presence
      IF m.loXML.documentElement.nodename=="presence"
         m.This._GetPresence(m.loJCP)
         RETURN
      ENDIF

      * Jde o zprvu (message/chat/chatgroup)
      IF m.loXML.documentElement.nodename=="message"
         m.This._GetMessage(m.loJCP)
         RETURN
      ENDIF

      * Jde o handshake
      IF m.loXML.documentElement.nodename=="handshake"
         m.This._GetHandshake(m.loJCP)
         RETURN
      ENDIF

      IF m.loXML.documentElement.nodename=="stream:stream"
         m.This._GetStream(m.loJCP)
         RETURN
      ENDIF

   ENDPROC

   PROCEDURE GetKeyFromID(lcID) && Vrt kl z ID
       LOCAL liStart
       liStart=AT("_",m.lcID,1)
       RETURN SUBST(m.lcID,m.liStart+1,AT("_",m.lcID,2)-m.liStart-1)
   ENDPROC

   PROCEDURE AddEvent(liXX200,lcXX201,lcXX202,lcXX203, lnXX204) && Zalo udlost
      * liXX200 - Typ udlosti (presence/iq)
      * lcXX201 - ID udlosti 
      * lcXX202 - vygenerovan pkaz v XML
      * lcXX203 - Sekundrn ID (pro presenci brna/nick)
      * lnXX204 - Sekundrn ID (pro presenci brna/nick)

      LOCAL liSele
      liSele=SELE()
      SELE (m.This.AEVENTS)
      * Najdi voln flek
      IF SEEK("-1")
         REPL XX200 WITH m.liXX200, XX201 WITH m.lcXX201, XX202 WITH m.lcXX202,;
              XX203 WITH IIF(EMPTY(m.lcXX203),"",m.lcXX203), XX204 WITH IIF(EMPTY(m.lnXX204),0,m.lnXX204)
      ELSE
         INSERT INTO (This.AEVENTS) (XX200,XX201,XX202,XX203,XX204) VALUES;
                (m.liXX200,m.lcXX201,m.lcXX202,IIF(EMPTY(m.lcXX203),"",m.lcXX203),IIF(EMPTY(m.lnXX204),0,m.lnXX204))
      ENDIF
      SELE (m.liSele)
      RETURN .T.
   ENDPROC

   PROCEDURE GetXMLDOM() && Vrt XML DOM
      LOCAL loXML
      loXML=CREATEOBJECT("Microsoft.XMLDOM")
      loXML.async=.F.
      loXML.SetProperty("SelectionLanguage","XPath")
      RETURN m.loXML
   ENDPROC


   PROCEDURE GetMessage(loJCP) && Pijmut zprvy
      * loJCP - Jabber client process
   ENDPROC

   PROCEDURE GetPresence(loJCP) && Pijmut presence
      * loJCP - Jabber client process
      LOCAL lcFrom,lcConf,lcID,lcData,liSele,liIDJID,lcKey,loXML,lcNick,lcType,loTXML,lii,loXXX

      liSele=SELE()
      loXML=m.loJCP.oXML
      lcID=m.loJCP.id
      lcFrom=m.loXML.documentElement.GetAttribute("from")
      lcKey=m.loJCP.Key

      lcType=m.loXML.documentElement.GetAttribute("type")

      IF AT("/",lcFrom)>0 && Je to od nkoho z konfery
         lcConf=LEFT(m.lcFrom,AT("/",m.lcFrom)-1)
         lcNick=SUBST(m.lcFrom,AT("/",m.lcFrom)+1)
      ELSE
         lcConf=m.lcFrom && Posl to samotn konfera
         lcNick=""
      ENDIF

      DO CASE
         * iq sledovan udlosti
         CASE m.This.GlobalStatus=_JC_GS_Presence
              =m.This.WriteToLog("SYSTEM: Connection block complete..."+CRLF)
              m.This.GlobalStatus=_JC_GS_Joined
              FOR lii=1 TO _JC_DataSystem
                  STORE .NULL. TO m.loJC.aQueue(m.lii,1),m.loJC.aQueue(m.lii,2)
              NEXT
              liRet=_JC_P_Processed
                      

         CASE m.loJCP.Status=_JC_P_Trackly AND m.lcKey="JC" && Pihlen do konfery
              This.JoinedToConf(@m.loJCP,@m.lcConf,@m.lcNick)
              liRet=_JC_P_Processed
              IF lcType="error"

              ELSE
                 =This.AddRemoConf(-1,"",@m.lcConf,@m.lcNick,1,loJCP.ERam.XX204)
                 lcID="FoxBot_jabber:iq:browse_"+SYS(2015)
                 lcData=[<iq type="get" to="]+m.lcConf+[" id="]+m.lcID+["><query xmlns="jabber:iq:browse"/></iq>]
                 This.AddEvent(_JC_E_iq,lcID,@m.lcData)
                 This.SendData(@m.lcData,0)
              ENDIF


         * iq sledovan udlosti
         CASE m.loJCP.Status=_JC_P_Trackly AND m.lcKey="LC" && Odhlen do konfery
              This.LeavedFromConf(@m.loJCP,@m.lcConf,@m.lcNick)
              IF This.AddRemoConf(-1,"",@m.lcConf,@m.lcNick,-1)=0
                 This.iLeaveFromConf=This.iLeaveFromConf-1
              ENDIF
              debugout This.iLeaveFromConf
              liRet=_JC_P_Processed
              IF lcType="error"
*RECEIV: <presence from='#vfp.cz@ircnet.jabber.bnet.pl/FoxBot' to='FoxBot@njs.netlab.cz' type='error' id='FoxBot_LC__19I0WWIGA'><error code='502'>Internal Timeout</error></presence>

              ENDIF

         * iq kick/ban atd
         CASE !ISNULL(lcType) AND lcType="unavailable" AND lcNick==loJC.DefNick && 
              This.LeavedFromConf(@m.loJCP,@m.lcConf,@m.lcNick)
              =This.AddRemoConf(-1,"",@m.lcConf,@m.lcNick,0)
              This.iLeaveFromConf=This.iLeaveFromConf-1
              debugout This.iLeaveFromConf
              liRet=_JC_P_Processed
              IF lcType="error"
*RECEIV: <presence from='#vfp.cz@ircnet.jabber.bnet.pl/FoxBot' to='FoxBot@njs.netlab.cz' type='error' id='FoxBot_LC__19I0WWIGA'><error code='502'>Internal Timeout</error></presence>

              ENDIF


         CASE !ISNULL(lcType) AND lcType="subscribe" && Subscribe
              lcData=[<presence to="]+m.lcFrom+[" type="subscribed"/>]
              This.SendData(@m.lcData,0)
              liRet=_JC_P_Processed

*         CASE loJCP.Status=_JC_P_Trackly

         CASE !ISNULL(lcType) AND lcType="unsubscribe" && Unsubscribe
*SEND: <presence to="gorila@dione.zcu.cz" type="unsubscribe"/>
*RECV: <iq type='set'><query xmlns='jabber:iq:roster'><item ask='unsubscribe' subscription='to' jid='gorila@dione.zcu.cz' name='gorila'/></query></iq>
*RECV: <presence from='gorila@dione.zcu.cz' to='FoxBot@njs.netlab.cz' type='unsubscribed'><status>Autoreply</status></presence>
*RECV: <iq type='set'><query xmlns='jabber:iq:roster'><item subscription='none' jid='gorila@dione.zcu.cz' name='gorila'/></query></iq>

*              lcID="FoxBot_jabber:iq:roster_"+SYS(2015)
*              lcData=[<iq type="set"><query xmlns='jabber:iq:roster'><item ask='unsubscribe' subscription='to' jid=']+m.lcFrom+;
*                     ["' name=']+m.This.User+['></query></iq>]
*              This.SendData(@m.lcData,0)

*              lcData=[<presence from=']+m.This.User+"@"+m.This.Server+[' to=']+m.lcFrom+[' type='unsubscribed'><status>Autoreply</status></presence>]
*              This.SendData(@m.lcData,0)

*              lcData=[<iq type="set"><query xmlns='jabber:iq:roster'><item subscription='none' jid=']+m.lcFrom+;
*                     ["' name=']+m.This.User+['></query></iq>]
*              This.SendData(@m.lcData,0)
              liRet=_JC_P_Processed


         CASE m.loJCP.Status=_JC_P_Free AND ISNULL(lcType) && Log On
              loXXX=m.loXML.documentElement.selectNodes("*[local-name()='status']")
              liRet=_JC_P_Free
              IF m.loXXX.length=0 && Pokud je to logon
                 lcData=[<presence from="]+m.This.ReplyFrom+;
                        [" to="]+m.lcFrom+["><status>Online</status></presence>]
                 This.SendData(@m.lcData,0)
                 liRet=_JC_P_Processed
              ENDIF

*!*	              lcData=[<iq type="set"><query xmlns="jabber:iq:roster"><item jid="]+m.lcFrom+;
*!*	                     [" subscription="to" name="]+m.lcFrom+["/></query></iq>]
*!*	              This.SendData(@m.lcData,0)

         CASE m.loJCP.Status=_JC_P_Free AND !ISNULL(lcType) AND lcType="probe" && probe
              lcData=[<presence from="]+m.This.ReplyFrom+;
                     [" to="]+m.lcFrom+["><status>Online</status></presence>]
              This.SendData(@m.lcData,0)
              liRet=_JC_P_Processed

         CASE m.loJCP.Status=_JC_P_Free AND !ISNULL(lcType) AND lcType="unavailable" && Log out
              lii=m.This.AddRemoConf(-1,m.This.AConf,m.lcConf,m.This.DefNick,.NULL.)
              liRet=_JC_P_Free
              IF ISNULL(lii) OR lii=0
                 lcData=[<presence from="]+m.This.ReplyFrom+;
                        [" to="]+lcFrom+[" type="unavailable" />]
                 This.SendData(@m.lcData,0)

*!*	              lcData=[<iq type="set"><query xmlns="jabber:iq:roster"><item jid="]+m.lcFrom+;
*!*	                     [" subscription="remove" name="]+m.lcFrom+["/></query></iq>]
*!*	              This.SendData(@m.lcData,0)
                 liRet=_JC_P_Processed
              ENDIF

        OTHERWISE
              liRet=_JC_P_Free
      ENDCASE
      RETURN m.liRet
   ENDPROC

   PROCEDURE GetIQ(loJCP) && Pijmut Info/query
      * loJCP - Jabber client process
      LOCAL lcID,lcType,lcFrom,loXML,lcQuery,lcData,liRet,lcKey
      lcQuery=m.loJCP.xmlns
      lcID=m.loJCP.ID
      lcKey=m.loJCP.Key

      loXML=m.loJCP.oXML
      lcFrom=m.loXML.documentElement.GetAttribute("from")
      lcType=m.loXML.documentElement.GetAttribute("type")

      DO CASE
         * iq sledovan udlosti
         CASE m.loJCP.Status=_JC_P_Trackly
              liRet=_JC_P_Free
              DO CASE
                 CASE m.lcKey=="TimeOut"
                      This.tmrTO.Reset()
                      This.tmrTO.Enabled=.T.
                      m.This.tmrJC.Index=-1
                      liRet=_JC_P_Processed


                 CASE This.GlobalStatus=_JC_GS_Authorisation
                      IF lcType=="error"
                         m.This.ConnectionFailed()
                         RETURN _JC_P_Processed
                      ENDIF
                      This.GlobalStatus=_JC_GS_Join

                      m.This.StartTime=DATETIME()

                      lcID="FoxBot_jabber:iq:filter_"+SYS(2015)
                      lcData=[<iq type="set" id="]+m.lcID+["><query xmlns="jabber:iq:filter"/></iq>]
                      m.This.SendData(@m.lcData,0)

                      lcID="FoxBot_jabber:iq:browse_"+SYS(2015)
                      lcData=[<iq type="get" to="]+m.This.Server+[" id="]+m.lcID+["><query xmlns="jabber:iq:browse"/></iq>]
                      m.This.AddEvent(_JC_E_iq,@m.lcID,@m.lcData)
                      m.This.SendData(@m.lcData,0)

                      lcID="FoxBot_jabber:iq:roster_"+SYS(2015)
                      lcData=[<iq type="get" to="]+m.This.Server+[" id="]+m.lcID+["><query xmlns="jabber:iq:roster"/></iq>]
                      m.This.AddEvent(_JC_E_iq,lcID,@m.lcData)
                      m.This.SendData(@m.lcData,0)

                      lcID="FoxBot_pr_"+SYS(2015)
                      lcData=[<presence id="]+m.lcID+[">]+;
                             [<status>Online</status>]+;
                             [<priority>]+m.This.Priority+[</priority>]+;
                             [</presence>]

                      =m.This.WriteToLog("SYSTEM: Presence sending..."+CRLF)
                      m.This.GlobalStatus=_JC_GS_Presence
                      m.This.AddToQueue(_JC_GS_Presence,@m.lcData)
                      m.This.AddEvent(_JC_E_pr,lcID,@m.lcData)
                      m.This.SendData(@m.lcData,0)
                      m.This.Connected()

                      liRet=_JC_P_Processed

                 CASE m.lcKey=="jabber:iq:browse"
                      This.BrowseResult(m.loJCP)
                      liRet=_JC_P_Processed

                 CASE m.lcKey=="jabber:iq:roster"
                      This.RosterResult(m.loJCP)
                      liRet=_JC_P_Processed

                 CASE m.lcKey=="jabber:iq:filter"
                      This.FilterResult(m.loJCP)
                      liRet=_JC_P_Processed

              ENDCASE


         * Last Time
         CASE m.lcType=="get" AND m.lcQuery=="jabber:iq:last"
              lcData=[<iq type="result" to="]+m.lcFrom+[" from="]+m.This.ReplyFrom+[" id="]+m.lcID+[">]+;
                     [<query xmlns='jabber:iq:last' seconds=']+LTRIM(STR(DATETIME()-m.This.StartTime,11))+['/>]+;
                     [</iq>]
              This.SendData(@m.lcData,0)
              liRet=_JC_P_Processed

         * Client version
         CASE m.lcType=="get" AND m.lcQuery=="jabber:iq:version"
              lcData=[<iq type="result" to="]+m.lcFrom+[" from="]+m.This.ReplyFrom+[" id="]+m.lcID+[">]+;
                     [<query xmlns="jabber:iq:version">]+;
                     [<name>Fox Bot/]+VERSION()+[</name>]+;
                     [<version>]+m.This.Version+[</version>]+;
                     [<os>]+OS()+[</os>]+;
                     [</query>]+;
                     [</iq>]
 
              This.SendData(@m.lcData,0)
              liRet=_JC_P_Processed
  
         * Client Time
         CASE m.lcType=="get" AND m.lcQuery=="jabber:iq:time"
              lcPom=DATETIME()
              lcData=[<iq type="result" to="]+m.lcFrom+[" from="]+m.This.ReplyFrom+[" id="]+m.lcID+[">]+;
                     [<query xmlns="jabber:iq:time">]+;
                     [<utc>]+DT2Stamp(m.lcPom)+[</utc>]+;
                     [<display>]+TTOC(m.lcPom)+[</display>]+;
                     [</query>]+;
                     [</iq>]

              This.SendData(@m.lcData,0)
              liRet=_JC_P_Processed

         * Browse
         CASE m.lcType=="get" AND m.lcQuery=="jabber:iq:browse"
              lcData=[<iq type="result" to="]+m.lcFrom+[" from="]+m.This.ReplyFrom+[" id="]+m.lcID+[">]+;
                     [<query xmlns="jabber:iq:browse" ]

              IF This.iMode=0
                 lcData=lcData+;
                        [category="user" ]+;
                        [jid="]+m.This.ReplyFrom+[" ]+;
                        [type="client">]+;
                        [<ns>jabber:client</ns>]+;
                        [<ns>jabber:x:roster</ns>]
              ELSE
                 lcData=lcData+;
                        [category="service" ]+;
                        [jid="]+m.This.ReplyFrom+[" ]+;
                        [type="x-foxbot">]

              ENDIF

              lcData=lcData+;
                     [<ns>jabber:iq:browse</ns>]+;
                     [<ns>jabber:iq:last</ns>]+;
                     [<ns>jabber:iq:time</ns>]+;
                     [<ns>jabber:iq:version</ns>]+;
                     [</query>]+;
                     [</iq>]

              This.SendData(@m.lcData,0)
              liRet=_JC_P_Processed


*!*	SEND: <iq type="get" to="private.jabber.org" id="j8"><query xmlns="http://jabber.org/protocol/disco#items"/></iq>
*!*	RECV: <iq from='private.jabber.org' id='j8' to='gorila@dione.zcu.cz/Just another jabber client' type='result'>
*!*	<query xmlns='http://jabber.org/protocol/disco#items'>
*!*	<item jid='mooh@private.jabber.org' name='mooh'/></query></iq>

*!*	SEND: <iq type="get" to="private.jabber.org" id="j9"><query xmlns="http://jabber.org/protocol/disco#info"/></iq>
*!*	RECV: <iq from='private.jabber.org' id='j9' to='gorila@dione.zcu.cz/Just another jabber client' type='result'>
*!*	<query xmlns='http://jabber.org/protocol/disco#info'>
*!*	<identity category='conference' name='Private Chatrooms' type='text'/>
*!*	<feature var='http://jabber.org/protocol/muc'/>
*!*	<feature var='http://jabber.org/protocol/disco'/>
*!*	<feature var='jabber:iq:browse'/>
*!*	<feature var='jabber:iq:version'/>
*!*	<feature var='jabber:iq:time'/>
*!*	<feature var='jabber:iq:last'/>
*!*	<feature var='vcard-temp'/>
*!*	</query></iq>


*<iq type='result' to='gorila@dione.zcu.cz/Just another jabber client' id='j38' from='conf.netlab.cz'>
*<query xmlns='http://jabber.org/protocol/disco#items'>
*<item jid='hauz@conf.netlab.cz' name='hauz'/>
*<item jid='lopatka@conf.netlab.cz' name='lopatka'/>
*<item jid='e-sports.sk@conf.netlab.cz' name='e-sports.sk'/>
*<item jid='mercury@conf.netlab.cz' name='mercury'/>
*<item jid='lesaci@conf.netlab.cz' name='lesaci z IW'/>
*<item jid='vfp@conf.netlab.cz' name='vfp'/>
*<item jid='linux@conf.netlab.cz' name='linux'/>
*<item jid='hudba@conf.netlab.cz' name='hudba'/>
*<item jid='internet%irc.megik.ru@conf.netlab.cz' name='My Internet!'/>
*<item jid='moruse@conf.netlab.cz' name='moruse'/>
*<item jid='insect@conf.netlab.cz' name='insect'/>
*<item jid='x@conf.netlab.cz' name='x'/>
*<item jid='iks@conf.netlab.cz' name='iks'/>
*<item jid='fun4mobiles@conf.netlab.cz' name='fun4mobiles'/>
*</query></iq>

*!*	*<iq from='rss.jabber.ru' to='gorila@dione.zcu.cz/Just another jabber client' type='result' id='j65'>
*!*	*<query xmlns='http://jabber.org/protocol/disco#items'>
*!*	*<item jid='rss.jabber.ru' node='notify' name='New RSS Feed Notification Setup'/><item jid='compulenta@rss.jabber.ru' name='www.compulenta.ru (ru)'/><item jid='xmppworld@rss.jabber.ru' name='XMPP World News (en)'/><item jid='slashdot@rss.jabber.ru' name='/. (en)'/><item jid='palmq@rss.jabber.ru' name='PalmQ Online (ru)'/><item jid='lor@rss.jabber.ru' name='??????? ?????????? ?? ?? Linux (ru)'/><item jid='kde@rss.jabber.ru' name='KDE Dot News (en)'/><item jid='freshmeat@rss.jabber.ru' name='www.freshmeat.net (en)'/><item jid='cpan@rss.jabber.ru' name='The CPAN Search Site (en)'/><item jid='gnome@rss.jabber.ru' name='FootNotes - gnomedesktop.org (en)'/><item jid='mozilla@rss.jabber.ru' name='Mozilla (en)'/><item jid='prefnews@rss.jabber.ru' name='Prefnews.ru (ru)'/><item jid='raymondc@rss.jabber.ru' name='Raymond Chen - Win fun issues *(en)'/><item jid='bbcsports@rss.jabber.ru' name='BBC Sports (en)'/><item jid='gazeta.ru@rss.jabber.ru' name='?????????? ????????-?????? (ru)'/><item *!*	jid='caml-humps@rss.jabber.ru' name='Caml Humps (en)'/><item jid='cwn@rss.jabber.ru' name='Caml Weekly News (en)'/><item jid='aspforum@rss.jabber.ru' name='????????? ?? ?????? ASP Community (ru)'/><item jid='jj@rss.jabber.ru' name='Jabber journal (jabber.org) (en)'/><item jid='securitylab@rss.jabber.ru' name='SecurityLab (ru)'/><item jid='rsdn@rss.jabber.ru' name='????????? ???? ??????? RSDN (ru)'/><item jid='eye@rss.jabber.ru' name='[(o)] EyE.moof.ru (ru)'/><item jid='msdn@rss.jabber.ru' name='MSDN Just Published (en)'/><item jid='aif@rss.jabber.ru' name='????????? ? ????? (ru)'/><item jid='java@rss.jabber.ru' name='Information about the Java platform (en)'/><item jid='debian.ru@rss.jabber.ru' name='??????? Debian (ru)'/><item jid='artgnome@rss.jabber.ru' name='art.gnome.org releases (en)'/><item jid='linuxworld.kiev@rss.jabber.ru' *name='???? ??????????? Linux ?????????? (ru)'/><item jid='eweek@rss.jabber.ru' name='eWEEK Technology News (en)'/><item 



*!*	         * Disko Items
*!*	         CASE m.lcType=="get" AND m.lcQuery=="http://jabber.org/protocol/disco#items"
*!*	              lcData=[<iq from=']+m.This.User+"@"+m.This.Server+[' id=']+m.lcID+[' to=']+m.lcFrom+[' type='result'>]+;
*!*	                     [<query xmlns='http://jabber.org/protocol/disco#info'>]+;
*!*	                     [<item category='service' name='Universal FoxBot' type='x-foxbot'/>]+;
*!*	                     [</query></iq>]

*!*	              This.SendData(@m.lcData,0)
*!*	              liRet=_JC_P_Processed

         * Disko Info
         CASE m.lcType=="get" AND m.lcQuery=="http://jabber.org/protocol/disco#info"
              lcData=[<iq from=']+m.This.ReplyFrom+[' id=']+m.lcID+[' to=']+m.lcFrom+[' type='result'>]+;
                     [<query xmlns='http://jabber.org/protocol/disco#info'>]+;
                     [<identity category='service' name='Universal FoxBot' type='x-foxbot'/>]+;
                     [<feature var='http://jabber.org/protocol/disco'/>]+;
                     [<feature var='jabber:iq:browse'/>]+;
                     [<feature var='jabber:iq:version'/>]+;
                     [<feature var='jabber:iq:time'/>]+;
                     [<feature var='jabber:iq:last'/>]+;
                     [<feature var='vcard-temp'/>]+;
                     [</query></iq>]

              This.SendData(@m.lcData,0)
              liRet=_JC_P_Processed

         * Other
         OTHERWISE
              liRet=_JC_P_Free

      ENDCASE
      RETURN m.liRet && Vra nvratov kd
   ENDPROC


   PROCEDURE GetHandshake(loJCP) && Pijmut Handshake
      * loJCP - Jabber client process
      LOCAL lcID,lcType,lcFrom,loXML,lcQuery,lcData,liRet,lcKey
      lcQuery=m.loJCP.xmlns
      lcID=m.loJCP.id
      lcKey=m.loJCP.Key

      loXML=m.loJCP.oXML
      lcFrom=m.loXML.documentElement.GetAttribute("from")
      lcType=m.loXML.documentElement.GetAttribute("type")

      DO CASE
         * iq sledovan udlosti
         CASE m.loJCP.Status=_JC_P_Trackly
              liRet=_JC_P_Free
              DO CASE
                 CASE This.GlobalStatus=_JC_GS_Handshake
                      IF lcType=="error"
                         m.This.ConnectionFailed()
                         RETURN _JC_P_Processed
                      ENDIF
                      m.This.StartTime=DATETIME()

                      lcID="FoxBot_pr_"+SYS(2015)
                      lcData=[<presence id="]+m.lcID+[">]+;
                             [<status>Online</status>]+;
                             [<priority>]+m.This.Priority+[</priority>]+;
                             [</presence>]

                      =m.This.WriteToLog("SYSTEM: Presence sending..."+CRLF)
                      This.GlobalStatus=_JC_GS_Joined
                      m.This.SendData(@m.lcData,0)

                      m.This.Connected()
                      liRet=_JC_P_Processed
              ENDCASE


         * Other
         OTHERWISE
              liRet=_JC_P_Free

      ENDCASE
      RETURN m.liRet && Vra nvratov kd
   ENDPROC

   PROCEDURE _GetMessage(loJCP) && Pijmut zprvy - intern metoda
      * loJCP - Jabber process object
      LOCAL lcID,lcFrom,lcNick,lcType,loXML,loXX
      m.loXML=m.loJCP.oXML
      IF m.loXML.documentElement.NodeName=="stream:error"
         This.Reconnect()
         RETURN _JC_P_Processed
      ENDIF

      * Nyn otestuj zda jsem v konferenci (obas to zstane viset)
      lcType=NVL(m.loXML.documentElement.GetAttribute("type"),"")
      IF m.lcType=="groupchat"
         loXX=m.loXML.documentElement.selectNodes("*[local-name()='subject']")
         lcFrom=NVL(loXML.documentElement.GetAttribute("from"),"")
         IF m.loXX.length=0 OR LEN(m.loXX.Item(0).Text)=0 AND !EMPTY(lcFrom)
            lcFrom=IIF(AT("/",m.lcFrom)>0,LEFT(m.lcFrom,AT("/",m.lcFrom)-1),lcFrom)
            IF ISNULL(m.This.AddRemoConf(-1,m.This.AConf,m.lcFrom,m.This.DefNick,.NULL.))
               m.This.AddRemoConf(-1,m.This.AConf,m.lcFrom,m.This.DefNick,1)
            ENDIF
         ENDIF
      ENDIF

      liRet=m.This.GetMessage(m.loJCP)

      RETURN m.liRet
   ENDPROC

   PROCEDURE _GetPresence(loJCP) && Pijmut presence - intern metoda
      * loJCP - Jabber process object
      LOCAL lcID,lcData,liSele,liRet,loXML

      loXML=m.loJCP.oXML
      lcID=loJCP.ID
      liRet=loJCP.Status

      liSele=SELE()
      IF m.liRet=_JC_P_Failed
         lcData=[<presence type="error" to="]+m.loXML.documentElement.GetAttribute("from")+;
                [" from="]+m.This.ReplyFrom+[" id="]+m.loJCP.id+[">]+;
                [<error code="502">Bad Request</error></presence>]
         This.SendData(@m.lcData,0)
      ELSE
         loJCP.Status=m.liRet
         liRet=m.This.GetPresence(m.loJCP)
         IF m.liRet=_JC_P_Free && iq se nepodailo zpracovat
*!*	            lcData=[<presence type="error" to="]+loXML.documentElement.GetAttribute("from")+[" from="]+This.User+"@"+This.Server+[" id="]+lcID+[">]+;
*!*	                   [<error code="501">Not Implemented</error></presence>]
*!*	            This.SendData(@lcData,0)
         ENDIF
      ENDIF
      SELE (m.liSele)

      RETURN liRet && Vra nvratov kd
   ENDPROC

   PROCEDURE _GetIQ(loJCP) && Pijmut Info/query - intern metoda
      * loJCP - Jabber process object
      LOCAL lcID,loXXX,loXX,lcData,liRet,liSele,lcFrom,loXML
      m.loXML=m.loJCP.oXML
      liSele=SELE()
      lcID=m.loJCP.ID

      loXXX=m.loXML.documentElement.selectNodes("*[local-name()='query']")
      IF m.loXXX.length>0 && Pokud to bylo query
         STORE m.loXXX.Item(0).GetAttribute("xmlns") TO loJCP.xmlns
      ENDIF

*!*	      loXXX=.NULL.
*!*	      FOR lii=0 TO m.loXML.documentElement.ChildNodes.Length-1
*!*	          loXX=m.loXML.documentElement.ChildNodes(m.lii)
*!*	          IF m.loXX.NodeName=="query"
*!*	             loXXX=m.loXX
*!*	             EXIT
*!*	          ENDIF
*!*	      NEXT
         
*!*	      IF !ISNULL(m.loXXX) && Pokud to bylo query
*!*	         STORE m.loXXX.GetAttribute("xmlns") TO loJCP.xmlns
*!*	      ENDIF

      liRet=loJCP.Status

      DO CASE
         CASE liRet=_JC_P_Failed
              lcData=[<iq type="error" to="]+m.loXML.documentElement.GetAttribute("from")+;
                     [" from="]+m.This.ReplyFrom+[" id="]+m.loJCP.ID+[">]+;
                     [<error code="502">Bad Request</error></iq>]
              =This.SendData(@m.lcData,0)

         OTHERWISE
              loJCP.Status=m.liRet
              liRet=m.This.GetIQ(m.loJCP)
              IF !ISNULL(m.loXXX) AND liRet=_JC_P_Free
                 DO CASE
                    CASE m.loXML.documentElement.GetAttribute("type")=="error" && vrtila se chyba

                    CASE m.loXML.documentElement.GetAttribute("type")=="get" && iq se nepodailo zpracovat
                         lcFrom=m.loXML.documentElement.GetAttribute("from")
                         lcFrom=IIF(ISNULL(lcFrom),m.loXML.documentElement.GetAttribute("jid"),lcFrom)


                         IF !ISNULL(lcFrom)
                            lcData=[<iq type="error" to="]+lcFrom+[" from="]+m.This.ReplyFrom+[" id="]+m.lcID+[">]+;
                                   [<error code="501">Not Implemented</error></iq>]
                            =This.SendData(@m.lcData,0)
                         ENDIF
                    ENDCASE
              ENDIF
      ENDCASE

      SELE (m.liSele)
      RETURN m.liRet && Vra nvratov kd
   ENDPROC


   PROCEDURE _GetStream(loJCP) && Pijmut streamu - intern metoda
      * loJCP - Jabber process object

      LOCAL lii,loXX,lcPom,lcpwd,lcData,loXML
      loXML=m.loJCP.oXML
      IF m.loXML.documentElement.GetAttribute("type")=="error"
         =m.This.ConnectionFailed()
         RETURN TO MASTER
      ENDIF

      loXXX=m.loXML.documentElement.selectNodes("*/*[local-name()='stream:error']")
      IF m.loXXX.length>0 &&
         =m.This.ConnectionFailed()
         RETURN TO MASTER
      ENDIF


*!*	      FOR lii=0 TO m.loXML.documentElement.ChildNodes.Length-1
*!*	          loXX=m.loXML.documentElement.ChildNodes(m.lii)
*!*	          IF m.loXX.NodeName=="stream:error"
*!*	             =m.This.ConnectionFailed()
*!*	             RETURN TO MASTER
*!*	          ENDIF
*!*	      NEXT

      STORE loXML.documentElement.GetAttribute("id") TO This.SessionID,lcID

      DO CASE
         CASE m.This.iMode=0
              IF m.This.Plain
              ELSE
*                 lcPom=This.oCryptPak.SHA1(m.lcID+m.This.Password)
                 lcPom=This.SHA1.SHA1(m.lcID+m.This.Password)
 
                 lcpwd=""
                 FOR lii=1 TO LEN(m.lcPom)
                     lcpwd=m.lcpwd+LOWER(RIGHT(TRANSFORM(ASC(SUBST(m.lcPom,m.lii,1)),"@0"),2))
                 NEXT
              ENDIF

              lcData=[<iq type="set" id="]+m.lcID+[">]+;
                     [<query xmlns="jabber:iq:auth">]+;
                     [<username>]+m.This.User+[</username>]+;
                     IIF(m.This.Plain,;
                         [<password>]+m.This.Password+[</password>],;
                         [<digest>]+m.lcpwd+[</digest>])+;
                     [<resource>]+m.This.Resource+[</resource>]+;
                     [</query>]+;
                     [</iq>]

              =m.This.WriteToLog("SYSTEM: Authorization sending..."+CRLF)
              m.This.GlobalStatus=_JC_GS_Authorisation
              m.This.AddEvent(_JC_E_iq,lcID,@m.lcData)
              m.This.AddToQueue(_JC_GS_Authorisation,@m.lcData)
              m.This.SendData(@m.lcData,0)

         CASE m.This.iMode=1
              
              This.ReplyFrom=loXML.documentElement.GetAttribute("from")
*              lcPom=This.oCryptPak.SHA1(m.lcID+This.Password)
              lcPom=This.SHA1.SHA1(m.lcID+m.This.Password)

              lcpwd=""
              FOR lii=1 TO LEN(m.lcPom)
                  lcpwd=m.lcpwd+LOWER(RIGHT(TRANSFORM(ASC(SUBST(m.lcPom,m.lii,1)),"@0"),2))
              NEXT

              lcData=[<handshake id="]+m.lcID+[">]+;
                     m.lcpwd+;
                     [</handshake>]

              =m.This.WriteToLog("SYSTEM: Hanshake sending..."+CRLF)
              m.This.GlobalStatus=_JC_GS_Handshake
              m.This.AddEvent(_JC_E_handshake,lcID,@m.lcData,"handshake")
              m.This.AddToQueue(_JC_GS_Handshake,@m.lcData)
              m.This.SendData(@m.lcData,0)
      ENDCASE

      RETURN _JC_P_Free && Vra nvratov kd
   ENDPROC


   PROCEDURE _GetHandshake(loJCP) && Pijmut Handshake - intern metoda
      * loJCP - Jabber process object
      LOCAL lcID,loXXX,loXX,lcData,liRet,liSele,lcFrom,loXML
      m.loXML=m.loJCP.oXML
      liSele=SELE()
      lcID=m.loJCP.ID

      IF m.loXML.documentElement.GetAttribute("type")=="error"
         =m.This.ConnectionFailed()
         RETURN TO MASTER
      ENDIF


      liRet=loJCP.Status

      IF liRet=_JC_P_Failed
         lcData=[<handshake type="error" to="]+m.loXML.documentElement.GetAttribute("from")+;
                [" from="]+m.This.ReplyFrom+[" id="]+m.loJCP.ID+[">]+;
                [<error code="502">Bad Request</error></handshake>]
         =This.SendData(@m.lcData,0)
      ELSE
         loJCP.Status=m.liRet
         liRet=m.This.GetHandshake(m.loJCP)
         IF liRet=_JC_P_Free
            lcFrom=m.loXXX.GetAttribute("from")
            lcFrom=IIF(ISNULL(lcFrom),m.loXXX.GetAttribute("jid"),lcFrom)
            IF !ISNULL(lcFrom)
               lcData=[<handshake type="error" to="]+lcFrom+[" from="]+m.This.ReplyFrom+[" id="]+m.lcID+[">]+;
                      [<error code="501">Not Implemented</error></handshake>]
               =This.SendData(@m.lcData,0)
            ENDIF
         ENDIF
      ENDIF
      SELE (m.liSele)
      RETURN m.liRet && Vra nvratov kd
   ENDPROC


   PROCEDURE SendMessage(loMSG,liType,liInterval) && Odesln zprvy
      * loMSG      - Objekt zprvy
      * liType     - Typ zprvy
      * liInterval - Interval pro odesln
      IF EMPTY(m.loMSG.From)
         m.loMSG.From=IIF(liType#_jbm_GroupChat,m.This.ReplyFrom,"") && +IIF(liType#_jbm_GroupChat,"/"+m.This.Resource,"")
      ENDIF
      This.SendData(m.loMSG.CreateXML(liType),IIF(EMPTY(m.liInterval),0,m.liInterval))
   ENDPROC

   PROCEDURE SetStatus(loPre) && Nastaven statusu /presence
      * loPre      - Objekt presence
      m.loPre.From=m.This.ReplyFrom && +IIF(liType#_jbm_GroupChat,"/"+m.This.Resource,"")
      This.SendData(m.loPre.CreateXML(),0)
   ENDPROC

   PROCEDURE JoinToConf(lcTo,lcNick,liInterval,liUSR) && Pihlen do konference
      * lcTo       - JID mstnosti
      * lcNick     - Pezdvka
      * liInterval - Interval pro odesln
      * llUSR      - Pznak uivatelskho pihlen
      LOCAL lcData,lcID,liCount
      lcID="FoxBot_JC_"+SYS(2015)
      liCount=m.This.AddRemoConf(-1,"",m.lcTo,m.lcNick,.NULL.)
      IF ISNULL(m.liCount) OR m.liCount=0
         lcData=[<presence id="]+m.lcID+[" from="]+m.This.ReplyFrom+[" to="]+m.lcTo+"/"+m.lcNick+[">]+;
                [<status>Online</status><x xmlns="http://jabber.org/protocol/muc"/></presence>]
         This.AddEvent(_JC_E_pr,@lcID,@m.lcData,m.lcTo+"/"+m.lcNick,IIF(EMPTY(m.liUSR),0,m.liUsr))
         This.SendData(@m.lcData,IIF(EMPTY(m.liInterval),0,m.liInterval))
      ELSE
         =m.This.AddRemoConf(-1,"",m.lcTo,m.lcNick,1)
      ENDIF
      RETURN lcID
   ENDPROC

   PROCEDURE LeaveFromConf(lcTo,lcNick,liInterval) && Odhlen z konference
      * lcTo       - JID mstnosti
      * lcNick     - Pezdvka
      * liInterval - Interval pro odesln
      LOCAL lcData,lcID
      IF m.This.AddRemoConf(-1,"",m.lcTo,m.lcNick,.NULL.)=1
         lcID="FoxBot_LC_"+SYS(2015)
         lcData=[<presence from="]+m.This.ReplyFrom+;
                [" to="]+m.lcTo+"/"+m.lcNick+[" type="unavailable" ]+;
                IIF(EMPTY(lcID),"",[ id="]+lcID+["])+[ />]
         This.AddEvent(_JC_E_pr,@lcID,@m.lcData,m.lcTo+"/"+m.lcNick)
         This.SendData(@m.lcData,IIF(EMPTY(m.liInterval),0,m.liInterval))
      ELSE
         =m.This.AddRemoConf(-1,"",m.lcTo,m.lcNick,-1)
      ENDIF
      RETURN .T.
   ENDPROC


   PROCEDURE AddRemoConf(liDS,lcAlias,lcJID,lcNick,liAddRem,liUSR) && Pid/odstran zznam o konferenci
      * liDS      - DataSession ID
      * lcAlias   - Alias kurzoru
      * lcJID     - JID konference
      * lcNick    - Nick
      * liAddRem  - 1 pidat, -1 odebrat, 0 odebrat ve, .NULL. test
      * liUSR     - 1 Interaktivn, 0 automatick
      LOCAL liSele,llSeek,liCount
      lcAlias=IIF(EMPTY(m.lcAlias),m.This.AConf,m.lcAlias)
      liSele=SELE()

      IF liDS>-1
         SET DATASESSION TO (liDS)
      ENDIF

      SELE (m.lcAlias)

      IF LEN(m.lcJID)>240
         SET KEY TO (LEFT(m.lcJID,120))
         LOCATE FOR JID==m.lcJID && Najdi prvn vtu odpovdajc
*!*	         IF FOUND()
*!*	            LOCATE WHILE JID==m.lcJID FOR NICK==m.lcNick
*!*	         ENDIF
         llSeek=FOUND()
      ELSE
         IF SEEK(m.lcJID)
            LOCATE WHILE JID=m.lcJID FOR JID==m.lcJID &&  FOR NICK==m.lcNick
         ENDIF
         llSeek=FOUND()
      ENDIF
      liCount=XX200

      IF !ISNULL(m.liAddRem) AND m.liAddRem=1
         IF !m.llSeek
            INSERT INTO (m.lcAlias) (JID,NICK,XX200) VALUES (m.lcJID,m.lcNick,1)
            liCount=1
         ELSE
            REPL XX200 WITH XX200+1,NICK WITH m.lcNick
            liCount=XX200
         ENDIF
      ENDIF

      IF !ISNULL(m.liAddRem) AND INLIST(m.liAddRem,-1,0) AND m.llSeek
         REPL XX200 WITH IIF(m.liAddRem=-1,XX200-1,0)
         liCount=XX200
      ENDIF
      IF liDS>-1
         SET DATASESSION TO 0
      ENDIF

      SELE (m.liSele)
      RETURN IIF(llSeek,m.liCount,.NULL.)
   ENDPROC


*!*	   PROCEDURE IsConf(lcJID) && Vrt, zda je to konference
*!*	      * lcJID     - JID konference
*!*	      LOCAL liSele,llSeek
*!*	      liSele=SELE()
*!*	      SELE (m.This.AConf)
*!*	      IF LEN(m.lcJID)>240
*!*	         SET KEY TO (m.lcJID)
*!*	         LOCATE FOR JID==m.lcJID && Najdi prvn vtu odpovdajc
*!*	         llSeek=FOUND()
*!*	      ELSE
*!*	         llSeek=SEEK(m.lcJID)
*!*	      ENDIF
*!*	      RETURN m.llSeek
*!*	   ENDPROC

   PROCEDURE JoinedToConf(loJCP,lcConf,lcNick) && Pihlen do konference - potvrzeno
   ENDPROC

   PROCEDURE LeavedFromConf(loJCP,lcConf,lcNick) && Odhlen z konference - potvrzeno
   ENDPROC

   PROCEDURE BrowseResult(m.loJCP)
   ENDPROC

   PROCEDURE RosterResult(m.loJCP)
   ENDPROC

   PROCEDURE FilterResult(m.loJCP)
   ENDPROC



   PROCEDURE SendData(lcData,liInterval) && Odesln dat pes WinSock
      * lcData     - XML Data
      * liInterval - Interval pro zpoovac frontu
      LOCAL loWS

      IF m.liInterval=0
         m.This._SendData(@m.lcData) 
      ELSE
         SELE (m.This.ALag)
         SET ORDER TO "XXI000"
         * Najdi voln msto
         IF SEEK("0")
            REPL XX302 WITH 1, XX301 WITH m.lcData, XX303 WITH liInterval, XX300 WITH DATETIME()
         ELSE
            INSER INTO (m.This.ALag) (XX302, XX300, XX301, XX303) ;
                   VALUES (1, DATETIME(),m.lcData, liInterval)
         ENDIF
         m.This.tmrLag.Enabled=.T.
      ENDIF
   ENDPROC

   PROCEDURE _SendData(lcData) && Intern metoda na odesln dat pes WinSock
      * lcData     - XML Data
      LOCAL loWS,lcBuffer,liSize,liXX400,llNew,lc_Data
      IF !PEMSTATUS(This,"CNTJC",5)
         This.PrintCallStack()
         RETURN
      ENDIF
      loWS=This.cntjc.oWS
      IF m.loWS.GetState()#sckConnected
         IF This.GlobalStatus=_JC_GS_Disconnecting
            loJC.Disconnected()
            RETURN
         ELSE
            m.This.LostConnection()
            RETURN TO MASTER
         ENDIF
      ENDIF

      SELE (m.This.ASend)
      liSize=m.This.cntJC.oWS.Object.BufferSize
      lc_Data=m.lcData
      DO WHILE LEN(m.lc_Data)>0
         lcBuffer=LEFT(m.lc_Data,m.liSize)
         lc_Data=SUBST(m.lc_Data,m.liSize+1)

         GO BOTTOM
         liXX400=XX400+1

         GO TOP
         llNew=XX400=_ID_Max && Zalo novou vtu

         IF llNew
            INSERT INTO (This.ASend) (XX400,XX401) VALUES (liXX400,lcBuffer)
         ELSE
            REPL XX400 WITH liXX400,XX401 WITH lcBuffer
         ENDIF
         This.iSend=m.This.iSend+1
         IF m.This.iSend>=100
            PACK MEMO
            m.This.iSend=0
         ENDIF
         
      ENDDO
      This.tmrSN.Enabled=.T.
      
      

*!*	      IF !m.loWS.SendData(m.lcData)
*!*	         debugout "LC: Internal send data"
*!*	         m.loJC.LostConnection() && Peru spojen - nsleduje restart
*!*	         RETURN TO MASTER
*!*	      ELSE
*!*	         m.This.tmrJC.Enabled=.T.
*!*	      ENDIF
*!*	      This.WriteToLog("SEND: "+m.lcData+CRLF)
*!*	      DEBUGOUT "SEND: "+m.lcData
   ENDPROC

   PROCEDURE PrintCallStack()
      LOCAL lii
      FOR lii=1 TO PROGRAM(-1)
          DEBUGOUT PROGRAM(lii)
      NEXT
   ENDPROC

ENDDEFINE

*********************************************
DEFINE CLASS _jc_process AS custom
   id="" && ID info/query
   key="" && Kl
   oXML=.NULL. && XML DOM pchozho elementu 
   oTracklyXML=.NULL. && XML DOM pvodnho elementu kter se sleduje
*   iTrackly=0 && Vsledek naten 
   xmlns=""
   Status=_JC_P_Failed
   ERam=.NULL. && kopie vty Udlost 

   nError=0 && Pznak chyby
   Invite=0 && Pznak pozvn do konfery
ENDDEFINE


*********************************************
DEFINE CLASS _cntjcWS AS container
   PROCEDURE Error(nError,cMethod,nLine) && Chybov rutina
      * nError  - slo chyby
      * cMethod - Nzev metody ve kter dolo k chyb
      * nLine   - slo dku na kterm dolo k chyb

       DEBUGOUT This.Class+":: "+PROGRAM(PROGRAM(-1)-1)+":"+cMethod+":"+LTRIM(STR(nLine,11))+" "+MESSAGE()
       =EVALUATE(This.Parent.Class+"::Error(nError,cMethod,nLine)")
   ENDPROC


   ADD OBJECT oWS AS _jabberclientWS2
ENDDEFINE


*********************************************
DEFINE CLASS _jabtimer AS timer
   Name="_jabtimer"

   PROCEDURE Error(nError,cMethod,nLine) && Chybov rutina
      * nError  - slo chyby
      * cMethod - Nzev metody ve kter dolo k chyb
      * nLine   - slo dku na kterm dolo k chyb

       DEBUGOUT This.Class+":: "+PROGRAM(PROGRAM(-1)-1)+":"+cMethod+":"+LTRIM(STR(nLine,11))+" "+MESSAGE()
       =EVALUATE(This.Parent.Class+"::Error(nError,cMethod,nLine)")
   ENDPROC
ENDDEFINE

*********************************************
DEFINE CLASS _tmrjcLag AS _jabtimer
   Name="_tmrjcLag"
   Enabled=.F.
   Interval=1000

   PROCEDURE Timer()
      This.Enabled=.F.
      LOCAL loJC
      loJC=m.This.Parent
      
      SELE (m.loJC.ALag)
      SET ORDER TO "XXI001"
      SCAN FOR XX300+XX303<DATETIME() AND XX302=1
           m.loJC._SendData(XX301)
           SELE (m.loJC.ALag)
           REPL XX302 WITH 0
      ENDSCAN
      =m.This.ED_Timer()
   ENDPROC

   PROCEDURE ED_Timer()
      This.Enabled=INDEXSEEK("1",.F.,m.This.Parent.ALag,"XXI000")
   ENDPROC
ENDDEFINE

*********************************************
DEFINE CLASS _tmrjcTimeOut AS _jabtimer
   Name="_tmrjcTimeOut"
   Interval=60000*5
   Enabled=.F.

   PROCEDURE Timer()
      This.Enabled=.F.
      LOCAL loJC
      loJC=m.This.Parent
      lcID="FoxBot_TimeOut_"+SYS(2015)
      lcData=[<iq type='get' to=']+m.loJC.Server+[' id=']+m.lcID+['><query xmlns='jabber:iq:last'/></iq>]
      loJC.AddEvent(_JC_E_iq,lcID,@m.lcData)
      m.loJC.SendData(@m.lcData,0)
      m.loJC.tmrJC.Index=0
      m.loJC.tmrJC.Enabled=.T.
   ENDPROC
ENDDEFINE


*********************************************
DEFINE CLASS _tmrjcSend AS _jabtimer
   Name="_tmrjcSend"
   Interval=250
   Enabled=.F.

   PROCEDURE Timer()
      This.Enabled=.F.
      LOCAL loJC,lii,liRet,liSele
      liSele=SELE()
      loJC=m.This.Parent
      SELE (m.loJC.ASend)
      FOR lii=1 TO 1
          =SEEK(_ID_Max)
          SKIP 1
          IF !EOF()
             liRet=m.loJC.cntJC.oWS.SendData(XX401)
             SELE (m.loJC.ASend)
             IF liRet=-1
                debugout "LC: Internal send data"
                m.loJC.LostConnection() && Peru spojen - nsleduje restart
                RETURN TO MASTER
             ELSE
                IF liRet>=0
                   debugout "SEND: "+XX401
                   m.loJC.WriteToLog("SEND: "+XX401+CRLF)
                   m.loJC.tmrJC.Enabled=.T.
                   REPL XX400 WITH _ID_Max-1
                ENDIF
             ENDIF
          ELSE
             EXIT
          ENDIF
      NEXT

      IF SEEK(_ID_Max)
         SKIP 1
         This.Enabled= !EOF() AND XX400>_ID_Max
      ENDIF
      SELE (liSele)
   ENDPROC
ENDDEFINE


*********************************************
DEFINE CLASS _tmrjc AS _jabtimer
   Name="_tmrjc"
   Enabled=.F.
   Interval=250
   Index=-1
   MaxIndex=-1

   PROCEDURE Timer()
      This.Enabled=.F.

      LOCAL loJC,liGS,lcData,lcID,lcPom,lii,lcpwd,loXML,lcID,loWS,loXX
      loJC=This.Parent
      liGS=loJC.GlobalStatus

      DO CASE
         CASE liGS=_JC_GS_Connect && U se nakonektil, tak piprav spojen
              * Pihlen k serveru

              DEBUGOUT "Conect..."
              DO CASE
                 CASE m.loJC.iMode=0
                      lcData=[<?xml version="1.0" encoding="UTF-8" ?>]+;
                             [<stream:stream to="]+m.loJC.Server+[" ]+;
                             [ xmlns="jabber:client"]+;
                             [ xmlns:stream="http://etherx.jabber.org/streams">]

                      =loJC.WriteToLog("SYSTEM: Stream sending..."+CRLF)
                      loJC.GlobalStatus=_JC_GS_Establish
                      loJC.AddToQueue(_JC_GS_Establish,lcData)
                      loJC.AddEvent(_JC_E_stream,"",@m.lcData)
                      loJC.SendData(@m.lcData,0)
                      This.Enabled=.T.

                 CASE m.loJC.iMode=1
                      lcData=[<?xml version="1.0" encoding="UTF-8" ?>]+;
                             [<stream:stream to="]+m.loJC.Server+[" ]+;
                             [ xmlns="jabber:component:accept"]+;
                             [ xmlns:stream="http://etherx.jabber.org/streams">]

                      =loJC.WriteToLog("SYSTEM: Stream sending..."+CRLF)
                      loJC.GlobalStatus=_JC_GS_Establish
                      loJC.AddToQueue(_JC_GS_Establish,lcData)
                      loJC.AddEvent(_JC_E_stream,"",@m.lcData)
                      loJC.SendData(@m.lcData,0)
                      This.Enabled=.T.
              ENDCASE                  

         CASE liGS=_JC_GS_Establish && Nastaveno spojen
              * Pevezmi ID z vrcench data
              loWS=m.loJC.cntjc.oWS
              DEBUGOUT "Establish..."+STR(m.loJC.cntjc.oWS.getstate() )
              IF m.loWS.GetState()#sckConnected
                 =m.loJC.LostConnection()
                 RETURN TO MASTER
              ELSE
                 This.Enabled=.T.
              ENDIF

         CASE liGS=_JC_GS_Authorisation && Nastaveno spojen
              DEBUGOUT "Authorisation..."
              loWS=m.loJC.cntjc.oWS
              IF m.loWS.GetState()#sckConnected
                 =m.loJC.LostConnection()
                 RETURN TO MASTER
              ELSE
                 This.Enabled=.T.
              ENDIF

         CASE liGS=_JC_GS_Join && Pihlen - nastav status
              loWS=m.loJC.cntjc.oWS
              DEBUGOUT "Join..."

              IF m.loWS.GetState()#sckConnected
                 loJC.LostConnection()
                 RETURN TO MASTER
              ELSE
                 This.Enabled=.T.
              ENDIF
               
         CASE liGS=_JC_GS_Presence && Nastavena presence
              loWS=m.loJC.cntjc.oWS
              DEBUGOUT "Presence..."

              IF m.loWS.GetState()#sckConnected
                 loJC.LostConnection()
                 RETURN TO MASTER
              ELSE
                 This.Enabled=.T.
              ENDIF


         CASE liGS=_JC_GS_Joined && Pipojeno k JS
              loWS=m.loJC.cntjc.oWS
              IF m.loWS.GetState()#sckConnected
                 debugout "LC: Timer, after send data "+LTRIM(STR(m.loWS.GetState(),11))
                 debugout " state "+LTRIM(STR(m.loWS.state,11))
                 debugout " action "+LTRIM(STR(m.loWS.action,11))
                 m.loJC.LostConnection()
                 RETURN TO MASTER
              ENDIF
              IF m.This.Index>=0
                 IF m.This.Index<240
                    m.This.Index=m.This.Index+1
                    This.Enabled=.T.
                 ELSE
                    m.loJC.LostConnection()
                    RETURN TO MASTER
                 ENDIF
              ENDIF

         CASE liGS=_JC_GS_Error && Njak chyba - pro MS WinSock
              m.loJC.LostConnection()
              RETURN TO MASTER

         CASE liGS=_JC_GS_Disconnecting OR liGS=_JC_GS_Restart && Ukonen
              loWS=m.loJC.cntjc.oWS
              DEBUGOUT "Ukonovn... "+STR(m.loJC.iLeaveFromConf,11)


              IF m.loJC.iLeaveFromConf>=0
                 SELECT (m.loJC.AConf)
                 SUM XX200 TO lii
                 DEBUGOUT "            "+STR(lii,11)

                 IF m.loJC.iLeaveFromConf>=0 OR m.lii=0
                    lcData=[<presence>]+;
                           [<status>Offline</status>]+;
                           [<priority>]+m.loJC.Priority+[</priority>]+;
                           [</presence>]

                    =m.loJC.SendData(@m.lcData,0)
                    loJC.iLeaveFromConf=-1
                 ENDIF
                 This.Enabled=.T.
              ELSE
                 IF m.loJC.iLeaveFromConf<=0
                    =m.loJC.SendData("</stream:stream>",0)
                    =m.loWS.VFPDisconnect() 
                    m.loJC.oXML=.NULL.
                    loJC.Disconnected()
                 ELSE
                    This.Enabled=.T.
                 ENDIF
              ENDIF

         CASE liGS=_JC_GS_Reconnect
              IF m.This.Index>=0
                 IF m.This.Index<m.This.MaxIndex
                    m.This.Index=m.This.Index+1
                    This.Enabled=.T.
                 ELSE
                    m.This.Index=-1
                    IF m.loJC.iMode=0
                       loJC.Connect()
                    ENDIF
                    IF m.loJC.iMode=1
                       loJC.StartComponent()
                    ENDIF
                 ENDIF
              ENDIF

         OTHERWISE
      ENDCASE
   ENDPROC
ENDDEFINE





DEFINE CLASS _jabberclientWS2 AS OLECONTROL
   Name="_jabberclientWS2"

   OLEClass="Catalyst.SocketCtrl.1"
   _Buffer=""
   Buffer=""
   Locked=.F. && Pznak zmku


   PROCEDURE Init()
      This.Object.AddressFamily = 2
      This.Object.Protocol = 0
      This.Object.SocketType = 1
      This.Object.Binary = 1
      This.Object.Blocking = .F.
      This.Object.BufferSize = 16384 && 2048
   ENDPROC


   PROCEDURE StartService(lcServer,liPort)
*!*	    If the server is listening for connections, then
*!*	    effectively pause the server by closing the listening
*!*	    socket; no further connections will be accepted on
*!*	    the specified port, although existing client connections
*!*	    will be unaffected.
*!*	    
      IF This.Object.Listening
         This.Object.Disconnect
         RETURN
      ENDIF

*!*	    
*!*	    Valid port numbers are 1 through 65535, however, since
*!*	    the control's LocalPort property is an signed integer,
*!*	    we need to convert ports above 32767 to a negative value
*!*	    so that it doesn't overflow
*!*	    
      * If nLocalPort > 32767 Then nLocalPort = nLocalPort - 65536

      This.Object.AutoResolve = .F.
      This.Object.BindAddress = "127.0.0.1"
      This.Object.Blocking = .F.
      This.Object.LocalPort = 8888
      =This.Object.Startup()

*susp    
      lii=This.Object.Listen()
      IF lii>0
         DO CASE        
            CASE This.Object.LastError=WSAEADDRINUSE
*!*	            
*!*	            This error occurs when another application is listening on
*!*	            the same local IP address and port number.
*!*	            MsgBox "Another application is already listening on this port", vbExclamation, App.Title

            OTHERWISE
*               MsgBox "An unexpected error occurred (Error " & sockServer(0).LastError & ")"

         ENDCASE
      ENDIF
      DEBUGOUT lii

   ENDPROC

   PROCEDURE Accept(liIndex, liSocketId)

     debugout liIndex
     debugout liSocketId
     debugout This.Object.PeerAddress
     debugout This.Object.PeerName
     debugout "------------------------"
     This.Object.Accept=liIndex
     debugout "------------------------"

*!*	    For nClient = 1 To g_nLastClient
*!*	        If sockServer(nClient).Connected = False Then
*!*	            sockServer(nClient).Accept = SocketId
*!*	            ResetPageStat (nClient)
*!*	            Exit Sub
*!*	        End If
*!*	    Next

*!*	    g_nLastClient = g_nLastClient + 1
*!*	    
*!*	    ReDim Preserve PageStats(g_nLastClient)
*!*	    
*!*	    Load sockServer(g_nLastClient)
*!*	    sockServer(g_nLastClient).AutoResolve = False
*!*	    sockServer(g_nLastClient).Blocking = False
*!*	    sockServer(g_nLastClient).Accept = SocketId


   ENDPROC

   PROCEDURE VFPConnect(m.lcServer,m.liPort)
      IF LEN(CHRTRAN(m.lcServer,".0123456789",""))>0
         This.HostName=m.lcServer
         This.HostAddress=""
      ELSE
         This.HostName=""
         This.HostAddress=m.lcServer
      ENDIF
      This.RemotePort= LTRIM(STR(m.liPort,11))
      This.Parent.Parent.iMode=0
      =This.Object.Startup()
      =This.Object.Connect()
      =This.Connected()
   ENDPROC

   PROCEDURE StartComponent(m.lcServer,m.liPort)
      IF LEN(CHRTRAN(m.lcServer,".0123456789",""))>0
         This.HostName=m.lcServer
         This.HostAddress=""
      ELSE
         This.HostName=""
         This.HostAddress=m.lcServer
      ENDIF
      This.RemotePort= LTRIM(STR(m.liPort,11))
      This.Parent.Parent.iMode=1

*this.object.tracefile="d:\temp\___catalyst.log"
*this.object.trace=.t.
      
      =This.Object.Startup()
      =This.Object.Connect()
      =This.Connected()
   ENDPROC

   PROCEDURE VFPDisconnect()
      This.Object.Cleanup()
   ENDPROC

   PROCEDURE SendData(lcData)
      *@lcData - Data na odesln
      LOCAL lcBuffer,lii,loobj
      loobj=m.This.Object
      lii=0
      debugout "writing _"+IIF(m.loobj.IsBlocked,"Block ","NoBlock ")+IIF(m.loobj.IsWritable,"Write ","Read ")

      IF m.loobj.IsWritable
         lii=m.loobj.Write(@m.lcData,LEN(m.lcData))
         debugout "writing "+str(m.lii,11)
      ELSE
*         =m.loobj.Flush()
         lii=-2
      ENDIF
      RETURN m.lii
   ENDPROC

   PROCEDURE Connected()
      debugout "Connected to server..."

*susp
      WITH This.Parent.Parent
      .IP= This.Object.HostAddress
      .GlobalStatus=_JC_GS_Connect
      .WriteToLog("SYSTEM: Connect to server..."+CRLF)
      .tmrJC.Enabled=.T. && Globln timer
      .tmrLag.ED_Timer() && Zpoovac fronta

*!*	if empty(set("coverage"))
*!*	set coverage to "d:\temp\____test.log"
*!*	endif
      ENDWITH
   ENDPROC


   PROCEDURE Read(datalength, isurgent)
      *** Udlosti ovldacch prvk ActiveX ***
      LOCAL lcData,lcPom,loObj
      lcData=""
      loObj=This.Object

      lcPom=SPACE(datalength)
      loObj.Read(@lcPom,datalength)
      lcData=lcPom

      DO WHILE loObj.RecvNext>0
         lcPom=SPACE(loObj.RecvNext)
         loObj.Read(@lcPom,loObj.RecvNext)
         lcData=lcData+lcPom
      ENDDO
      This.DataArrival(@lcData)
*      debugout "read data: "+lcData
   ENDPROC

   PROCEDURE DataArrival(lcData)
      LOCAL lcBuffer,lcTag,lii,loJC,lcPom,llSimple,liTag,liiS1,liiS2
      loJC=This.Parent.Parent
      =loJC.WriteToLog("RECEIV: "+m.lcData+CRLF)

      IF EMPTY(m.lcData)
         RETURN
      ENDIF

      * pidej data do bufferu
      This.Buffer=m.This.Buffer+m.lcData

      IF m.This.Locked
         RETURN
      ENDIF

      This.Locked=.T.
      m.loJC.tmrJC.Enabled=.F. 

*!*    IF atc("<query xmlns='jabber:iq:roster'>",lcBuffer)>0
*!*    SUSPEND
*!*    endif

** to to je patn
*!*	RECEIV: <stream:error></stream:error>
*!*	LXMLF: <stream:error></stream:error>
*!*	RECEIV: <connection-timeout xmlns='urn:ietf:params:xxx:ns:xmpp-streams'/>
*!*	RECEIV: <text xmlns='urn:ietf:params:xxx:ns:xmpp-streams'>You have not authenticated in time</text>
*!*	RECEIV: </stream:error>
*!*	LXMLF: </stream:error>
*!*	RECEIV: </stream:stream>
*!*	LXMLF: </stream:stream>

** nebo sem dostal
*!*	RECEIV: <stream:error>
*!*	RECEIV: <connection-timeout xmlns='urn:ietf:params:xxx:ns:xmpp-streams'/>
*!*	RECEIV: <text xmlns='urn:ietf:params:xxx:ns:xmpp-streams'>You have not authenticated in time</text>
*!*	RECEIV: </stream:error>
*!*	RECEIV: </stream:stream>

      * prove kontrolu sprvnosti
      DO WHILE .T.
         lcBuffer=m.This.Buffer
         IF LEFT(m.lcBuffer,1)="<"
            * Je tam njak XML element
            liiS1=AT(" ",m.lcBuffer) && Najdi mezeru
            liiS2=AT(">",m.lcBuffer) && Pokud ji nenael, pak najdi ukonovac znak
            lii=IIF(liiS1=0,liiS2,;
                IIF(liiS2=0,liiS1,MIN(liiS1,liiS2)))

            IF SUBST(m.lcBuffer,2,m.lii-2)=="?xml"
               lcBuffer=SUBST(m.lcBuffer,AT("<",m.lcBuffer,2))
               m.This.Buffer=SUBST(m.This.Buffer,AT("<",m.This.Buffer,2))

               liiS1=AT(" ",m.lcBuffer) && Najdi mezeru
               liiS2=AT(">",m.lcBuffer) && Pokud ji nenael, pak najdi ukonovac znak
               lii=IIF(liiS1=0,liiS2,;
                   IIF(liiS2=0,liiS1,MIN(liiS1,liiS2)))
            ENDIF

            IF m.lii>0
               lcTag=SUBST(m.lcBuffer,2,m.lii-2)

               liTag=0
               IF m.lcTag=="stream:stream"
                  lcBuffer=m.lcBuffer+"</stream:stream>"
                  liTag=LEN("</stream:stream>")
               ENDIF

               IF m.lcTag=="stream:error" AND RIGHT(m.lcBuffer,LEN("</stream:error>"))#"</stream:error>"
                  DEBUGOUT "stream:error - waiting to end"
                  EXIT && Vysko upln ven, aby se naet i ten zbytek
               ENDIF

               IF m.lcTag=="stream:error" AND RIGHT(m.lcBuffer,LEN("</stream:error>"))=="</stream:error>"
                  liTag=LEN("</stream:error>")
                  lcBuffer=m.lcBuffer
                  DEBUGOUT "stream:error"
               ENDIF

               * Nejdve zkontroluj zda to nen jednoduch tag
               lii=AT(">",m.lcBuffer,1)
               lcPom=LEFT(m.lcBuffer,lii)

               llSimple=.T.
               IF RFindMDSC(@m.lcPom,"/",LEN(m.lcPom),1)=0
                  lii=ATC("</"+m.lcTag,m.lcBuffer,1)-1
                  llSimple=.F.
               ENDIF


               IF m.lii>0 && Nael Tag
                  lcData=LEFT(m.lcBuffer,m.lii)

                  lcBuffer=SUBST(m.lcBuffer,LEN(m.lcData)+1)
                  IF !m.llSimple
                     lii=AT(">",m.lcBuffer)
                     lcData=m.lcData+LEFT(m.lcBuffer,m.lii)
                  ENDIF
                  This.Buffer=SUBST(m.This.Buffer,LEN(m.lcData)-liTag+1)

                  loJC.AddDataToQueue(IIF(loJC.GlobalStatus=_JC_GS_Joined,_JC_DataNext,loJC.GlobalStatus),@m.lcData)
                  LOOP
               ENDIF
            ENDIF
         ELSE
            IF !EMPTY(m.lcBuffer) && lost data in buffer, remove it
               lii=MIN(ATC("<presence",m.lcBuffer,1),;
                       ATC("<message ",m.lcBuffer,1),;
                       ATC("<iq ",m.lcBuffer,1))

               IF m.lii>0
                  lcPom=LEFT(m.lcBuffer,m.lii)
                  This.Buffer=SUBST(m.This.Buffer,m.lii+1)
               ELSE
                  lcPom=m.This.Buffer
                  This.Buffer=""
               ENDIF
               debugout "LD: "+STRCONV(m.lcPom,11)
               =loJC.WriteToLog("LD: "+m.lcPom+CRLF)
               loJC.AddDataToQueue(IIF(loJC.GlobalStatus=_JC_GS_Joined,_JC_DataNext,loJC.GlobalStatus),@m.lcData)
            ENDIF
         ENDIF
         EXIT
      ENDDO
      This.Locked=.F.
      m.loJC.tmrJC.Enabled=.T. 
   ENDPROC

   PROCEDURE Write()
      debugout "SendComplete"
      IF m.This.Parent.Parent.GlobalStatus#_JC_GS_Joined
         m.This.Parent.Parent.tmrJC.Enabled=.T. 
      ENDIF
   ENDPROC

   PROCEDURE Error(nError, cMethod, nLine)
      * nError
      * cMethod
      * nLine
      debugout "WS Error: "+LTRIM(STR(m.nError,11))+" "+m.cMethod+" "+LTRIM(STR(m.nLine,11))
   ENDPROC

   PROCEDURE GetState()
      RETURN IIF(This.Object.IsClosed, sckClosed,IIF(This.Object.Connected, sckConnected,sckError))
   ENDPROC

ENDDEFINE


********************************************************
DEFINE CLASS _jbmessage AS CUSTOM && Tda pro vytvoen XML elementu <message>
   From="" && Sender
   To="" && Recipient
   CC="" && Carbon Copy
   Subject="" && Subject message
   Body="" && Body message
   HTML="" && HTML body message
   Extra="" && Extra information
   ID="" && ID of message
   Thread="" && ID Thread of message
   Offline=.T. && Offline message?
   nError=0
   cError=""


   PROCEDURE CreateXML(liType) && Vrt XML
      * liType - Type message
      LOCAL lcData,lcEnvelop,lcSubject

      This.ID=IIF(LEN(m.This.ID)=0,"FoxBot_message_"+SYS(2015),m.This.ID)
      lcEnvelop=""
      lcSubject=IIF(LEN(m.This.Subject)>0,StrTranHTMLString(m.This.Subject),"")
      IF liType=_jbm_Normal
         lcData=[<message from="]+m.This.From+["]+;
                [ to="]+m.This.BuildRecipient(m.This.To,m.This.CC,@m.lcEnvelop)+["]+;
                [ id="]+m.This.ID+["]+;
                [ xmlns='jabber:client'>]+IIF(m.This.Offline,[<offline />],"")+;
                IIF(EMPTY(m.lcSubject),"",[<subject>]+m.lcSubject+[</subject>])+;
                IIF(EMPTY(m.This.HTML),"",[<html xmlns="http://www.w3.org/TR/xhtml-basic"><body>]+m.This.HTML+[</body></html>])+;
                [<body>]+StrTranHTMLString(m.This.Body)+[</body>]+;
                IIF(EMPTY(m.This.Extra),"",m.This.Extra)+m.lcEnvelop+;
                IIF(m.This.nError>0,[<error code=']+LTRIM(STR(m.This.nError,11))+['>']+m.This.cError+['</error>],"")+[</message>]
      ENDIF

      IF liType=_jbm_Chat
         lcData=[<message from="]+m.This.From+["]+; 
                [ to="]+m.This.BuildRecipient(m.This.To,m.This.CC,@lcEnvelop)+;
                [" type="chat"]+;
                [ id="]+m.This.ID+["]+;
                [ xmlns='jabber:client'>]+;
                [<thread>]+IIF(EMPTY(m.This.Thread),SYS(2015)+"-"+SYS(2015)+"-"+SYS(2015),m.This.Thread)+[</thread>]+;
                IIF(EMPTY(m.This.HTML),"",[<html xmlns="http://www.w3.org/TR/xhtml-basic"><body>]+m.This.HTML+[</body></html>])+;
                [<body>]+StrTranHTMLString(m.This.Body)+[</body>]+;
                IIF(EMPTY(m.This.Extra),"",m.This.Extra)+m.lcEnvelop+;
                IIF(m.This.nError>0,[<error code=']+LTRIM(STR(m.This.nError,11))+['>']+m.This.cError+['</error>],"")+[</message>]
      ENDIF

      IF liType=_jbm_GroupChat
         lcData=[<message from="]+m.This.From+["]+;
                [ to="]+m.This.BuildRecipient(m.This.To,m.This.CC,@m.lcEnvelop)+;
                [" type="groupchat"]+;
                [ id="]+m.This.ID+["]+;
                [ xmlns='jabber:client'>]+;
                IIF(EMPTY(m.lcSubject),"",[<subject>]+m.lcSubject+[</subject>])+;
                IIF(EMPTY(m.This.HTML),"",[<html xmlns="http://www.w3.org/TR/xhtml-basic"><body>]+m.This.HTML+[</body></html>])+;
                [<body>]+StrTranHTMLString(m.This.Body)+[</body>]+;
                IIF(EMPTY(m.This.Extra),"",m.This.Extra)+m.lcEnvelop+;
                IIF(m.This.nError>0,[<error code=']+LTRIM(STR(m.This.nError,11))+['>']+m.This.cError+['</error>],"")+[</message>]
      ENDIF
      RETURN m.lcData
   ENDPROC

   PROCEDURE BuildRecipient(lcTo,lcCC,lcExtra) && Pjmce a kopie pjemce
      * lcTo    - Seznam pjemc
      * lcCC    - Seznam kopie
      *@lcExtra - Extra data
      LOCAL liCount,lcPom,lcPom2

      liCount=GETWORDCOUNT(m.lcTo,";")
      lcExtra=""
      IF m.liCount>0
         lcPom=GETWORDNUM(m.lcTo,1,";")
         FOR lii=2 TO m.liCount
             lcPom2=GETWORDNUM(m.lcTo,m.lii,";")
             lcExtra=m.lcExtra+[<to jid=']+m.lcPom2+['>]+m.lcPom2+[</to>]
         NEXT
      ENDIF

      liCount=GETWORDCOUNT(m.lcCC,";")
      FOR lii=1 TO m.liCount
          lcPom2=GETWORDNUM(m.lcCC,m.lii,";")
          lcExtra=m.lcExtra+[<cc jid=']+m.lcPom2+['>]+m.lcPom2+[</cc>]
      NEXT
      IF !EMPTY(m.lcExtra)
         lcExtra=[<x xmlns='jabber:x:envelope'>]+m.lcExtra+[</x>]
      ENDIF
      RETURN m.lcPom && Vra hlavnho pjemce
   ENDPROC

   PROCEDURE CloneMessage()
      LOCAL loClon
      loClon=CREATEOBJECT("_jbmessage")
      loClon.To=This.To
      loClon.CC=This.CC
      loClon.Subject=This.Subject
      loClon.Extra=This.Extra
      loClon.ID=This.ID && ID of message
      loClon.Thread=This.Thread
      loClon.Offline=This.Offline
      RETURN loClon
   ENDPROC
ENDDEFINE

********************************************************
DEFINE CLASS _jbpresence AS CUSTOM && Tda pro vytvoen XML elementu <presence>
   To="" && Recipient
   From="" && Sender
   ID="" && ID of presence
   Show=""
   Status=""
   Extra="" && Extra information

   PROCEDURE CreateXML() && Vrt XML
      LOCAL lcData
      This.ID=IIF(LEN(m.This.ID)=0,"FoxBot_presence_"+SYS(2015),m.This.ID)

      lcData=[<presence ]+;
             IIF(EMPTY(m.This.To),"",[ to="]+m.This.To+["])+;
             [>]+;
             [<show>]+m.This.Show+[</show>]+;
             [<status>]+m.This.Status+[</status>]+;
             IIF(EMPTY(m.This.Extra),"",m.This.Extra)+[</presence>]

      RETURN m.lcData
   ENDPROC
ENDDEFINE


***
* postupn zpis

*!*	data se zapisuj do pracovnho kurzoru o struktue XX000 I, XX001 M
*!*	kde voln vty jsou identifikovny xx000=-2000000001 - 1
*!*	a 0. vta xx000=-2000000001
*!*	 vty, ketr se maj zapsat maj xx000>-2000000001
*!*	 
*!*	 vta kter je poslna pes winsock dostane xx000=-2000000001 - 1
*!*	 v dob prbhu timeru se zapisuj 5-10 vt

*!*	 pi zpisu 100-200x do praocnvho kurzoru dojde ke zpakovn memo pole 
*!*	 pokud zapsan hodnota  je del ne velikost bufferu, budou data rozdla dle velikosti bufferu

*!*	 xx000 pro novou vtu se odvozuje od posledn hodnoty xx000 + 1





***************************************************

*****************
* HTML email
*!*	RECEIV: <message to='FoxBot@njs.netlab.cz' from='lucie.hlavova%jelinek.cz@smtp-t.netlab.cz'><subject/><body>

*!*	This is a multi-part message in MIME format.

*!*	------=_NextPart_000_0067_01C43E7E.855E07B0
*!*	Content-Type: text/plain;
*!*		charset="iso-8859-2"
*!*	Content-Transfer-Encoding: quoted-printable

*!*	!joke cs
*!*	=20


*!*	---
*!*	Odchoz=ED zpr=E1va neobsahuje viry.
*!*	Zkontrolov=E1no antivirov=FDm syst=E9mem AVG (http://www.grisoft.cz).
*!*	Verze: 6.0.688 / Virov=E1 b=E1ze: 449 - datum vyd=E1n=ED: 18.5.2004
*!*	=20

*!*	------=_NextPart_000_0067_01C43E7E.855E07B0
*!*	Content-Type: text/html;
*!*		charset="iso-8859-2"
*!*	Content-Transfer-Encoding: quoted-printable

*!*	&lt;!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
*!*	&lt;HTML>&lt;HEAD>
*!*	&lt;META HTTP-EQUIV=3D"Content-Type" CONTENT=3D"text/html; =
*!*	charset=3Diso-8859-2">
*!*	&lt;TITLE>Zpr=E1va&lt;/TITLE>

*!*	&lt;META content=3D"MSHTML 6.00.2800.1400" name=3DGENERATOR>&lt;/HEAD>
*!*	&lt;BODY style=3D"COLOR: #000000; FONT-FAMILY: Arial" =
*!*	hb_focus_attach=3D"true">
*!*	&lt;DIV>&lt;FONT size=3D2>!joke cs&lt;/FONT>&lt;/DIV>
*!*	&lt;DIV>&amp;nbsp;&lt;/DIV>
*!*	&lt;P>&lt;/P>&lt;/BODY>&lt;/HTML>
*!*	&lt;BR>

*!*	&lt;P>&lt;FONT SIZE=3D2>---&lt;BR>
*!*	Odchoz=ED zpr=E1va neobsahuje viry.&lt;BR>
*!*	Zkontrolov=E1no antivirov=FDm syst=E9mem AVG =
*!*	(http://www.grisoft.cz).&lt;BR>
*!*	Verze: 6.0.688 / Virov=E1 b=E1ze: 449 - datum vyd=E1n=ED: 18.5.2004&lt;BR>
*!*	&lt;/FONT> &lt;/P>

*!*	------=_NextPart_000_0067_01C43E7E.855E07B0--
*!*	</body></message>


****************************
* pidn kontaktu
* foxbot pidv gorilu
*SEND: <iq type="set" id="j2"><query xmlns="jabber:iq:roster"><item jid="gorila@dione.zcu.cz" name="Gorila"><group>Unfiled</group><x xmlns="jajc:x:adv"><autoauth>true</autoauth></x></item></query></iq>
*SEND: <presence to="gorila@dione.zcu.cz" type="subscribe"><status>Standard subscription request</status></presence>
*RECV: <iq type='set'><query xmlns='jabber:iq:roster'><item subscription='none' jid='gorila@dione.zcu.cz' name='Gorila'><group>Unfiled</group><x xmlns='jajc:x:adv'><autoauth>true</autoauth></x></item></query></iq>
*RECV: <iq to='FoxBot@njs.netlab.cz/Just another jabber client' from='FoxBot@njs.netlab.cz/Just another jabber client' type='result' id='j2'/>
*RECV: <iq type='set'><query xmlns='jabber:iq:roster'><item ask='subscribe' subscription='none' jid='gorila@dione.zcu.cz' name='Gorila'><group>Unfiled</group><x xmlns='jajc:x:adv'><autoauth>true</autoauth></x></item></query></iq>
* gorila dostala
*RECV: <presence type='subscribe' to='gorila@dione.zcu.cz' from='FoxBot@njs.netlab.cz'><status>Standard subscription request</status></presence>
*RECV: <presence to='gorila@dione.zcu.cz' from='96485226@icq.dione.zcu.cz'><show>away</show></presence>

* foxbot posla presenci
*<presence to="gorila@dione.zcu.cz"/>
* gorila dostala:
*<presence to='gorila@dione.zcu.cz' from='FoxBot@njs.netlab.cz/Just another jabber client'/>

* foxbot posla subscribe
*SEND: <presence to="gorila@dione.zcu.cz" type="subscribe"><status>Standard subscription request</status></presence>
*RECV: <iq type='set'><query xmlns='jabber:iq:roster'><item ask='subscribe' subscription='none' jid='gorila@dione.zcu.cz' name='Gorila'><group>Unfiled</group><x xmlns='jajc:x:adv'><autoauth>true</autoauth></x></item></query></iq>
* gorila dostala
*RECV: <presence type='subscribe' to='gorila@dione.zcu.cz' from='FoxBot@njs.netlab.cz'><status>Standard subscription request</status></presence>


*****
* a pesn opan: gorila
*SEND: <iq type="set" id="j6"><query xml:lang="1250" xmlns="jabber:iq:roster"><item jid="FoxBot@njs.netlab.cz" name="Fox Bot"><group>hauz</group><x xmlns="jajc:x:adv"><autoauth>true</autoauth></x></item></query></iq>
*SEND: <presence to="FoxBot@njs.netlab.cz" type="subscribe"><status>Standardn dotaz na autorizaci</status></presence>
*RECV: <iq type='set'><query xmlns='jabber:iq:roster'><item jid='FoxBot@njs.netlab.cz' name='Fox Bot' subscription='none'><group>hauz</group><x xmlns='jajc:x:adv'><autoauth>true</autoauth></x></item></query></iq>
*RECV: <iq type='result' id='j6' from='gorila@dione.zcu.cz/Just another jabber client' to='gorila@dione.zcu.cz/Just another jabber client'/><iq type='set'><query xmlns='jabber:iq:roster'><item jid='FoxBot@njs.netlab.cz' name='Fox Bot' subscription='none' ask='subscribe'><group>hauz</group><x xmlns='jajc:x:adv'><autoauth>true</autoauth></x></item></query></iq>
*RECV: <presence type='subscribed' to='gorila@dione.zcu.cz' from='FoxBot@njs.netlab.cz'/><iq type='set'><query xmlns='jabber:iq:roster'><item jid='FoxBot@njs.netlab.cz' name='Fox Bot' subscription='to'><group>hauz</group><x xmlns='jajc:x:adv'><autoauth>true</autoauth></x></item></query></iq><presence from='FoxBot@njs.netlab.cz/Just another jabber client' to='gorila@dione.zcu.cz'><x xmlns='jabber:x:delay' from='FoxBot@njs.netlab.cz/Just another jabber client' stamp='20040512T11:48:15'/><x xmlns='jabber:x:delay' from='FoxBot@njs.netlab.cz/Just another jabber client' stamp='20040512T11:48:15'/></presence>

* foxbot
*RECV: <presence from='gorila@dione.zcu.cz' type='subscribe' to='FoxBot@njs.netlab.cz'><status>Standardn dotaz na autorizaci</status></presence>
*SEND: <presence to="gorila@dione.zcu.cz" type="subscribed"/>
*RECV: <iq type='set'><query xmlns='jabber:iq:roster'><item ask='subscribe' subscription='from' jid='gorila@dione.zcu.cz' name='Gorila'><group>Unfiled</group><x xmlns='jajc:x:adv'><autoauth>true</autoauth></x></item></query></iq>

****************************************************
* pidn autorizace
* foxbot da o autorizace gorilu
*<presence to="gorila@dione.zcu.cz" type="subscribe"><status>Standard subscription request</status></presence>
*RECV: <iq type='set'><query xmlns='jabber:iq:roster'><item ask='subscribe' subscription='from' jid='gorila@dione.zcu.cz' name='Gorila'><group>Unfiled</group><x xmlns='jajc:x:adv'><autoauth>true</autoauth></x></item></query></iq>
*RECV: <presence from='gorila@dione.zcu.cz' type='subscribed' to='FoxBot@njs.netlab.cz'/>
*RECV: <iq type='set'><query xmlns='jabber:iq:roster'><item subscription='both' jid='gorila@dione.zcu.cz' name='Gorila'><group>Unfiled</group><x xmlns='jajc:x:adv'><autoauth>true</autoauth></x></item></query></iq>
*RECV: <presence to='FoxBot@njs.netlab.cz' from='gorila@dione.zcu.cz/Just another jabber client'><priority>1</priority><x xmlns='jabber:x:avatar'><hash>7d07537b70f2f31c2364bc11d615cc60dc8fa8c0</hash></x><show>chat</show><status>Ukecan</status><x stamp='20040512T11:58:13' from='gorila@dione.zcu.cz/Just another jabber client' xmlns='jabber:x:delay'/></presence>
* a gorila...
*RECV: <presence type='subscribe' to='gorila@dione.zcu.cz' from='FoxBot@njs.netlab.cz'><status>Standard subscription request</status></presence>
*SEND: <presence to="FoxBot@njs.netlab.cz" type="subscribed"/>
*RECV: <iq type='set'><query xmlns='jabber:iq:roster'><item jid='FoxBot@njs.netlab.cz' name='Fox Bot' subscription='both'><group>hauz</group><x xmlns='jajc:x:adv'><autoauth>true</autoauth></x></item></query></iq>




****************************************************
* zruen autorizace
* foxbot ru gorilu
*SEND: <presence to="gorila@dione.zcu.cz" type="unsubscribe"/>
*RECV: <iq type='set'><query xmlns='jabber:iq:roster'><item ask='unsubscribe' subscription='both' jid='gorila@dione.zcu.cz' name='Gorila'><group>Unfiled</group><x xmlns='jajc:x:adv'><autoauth>true</autoauth></x></item></query></iq>
*RECV: <presence from='gorila@dione.zcu.cz' to='FoxBot@njs.netlab.cz' type='unsubscribed'><status>Autoreply</status></presence>
*RECV: <iq type='set'><query xmlns='jabber:iq:roster'><item subscription='from' jid='gorila@dione.zcu.cz' name='Gorila'><group>Unfiled</group><x xmlns='jajc:x:adv'><autoauth>true</autoauth></x></item></query></iq>
* a gorila na to
*RECV: <presence type='unsubscribe' to='gorila@dione.zcu.cz' from='FoxBot@njs.netlab.cz'/>
*RECV: <iq type='set'><query xmlns='jabber:iq:roster'><item jid='FoxBot@njs.netlab.cz' name='Fox Bot' subscription='to'><group>hauz</group><x xmlns='jajc:x:adv'><autoauth>true</autoauth></x></item></query></iq>



*********