#INCLUDE "..\..\jabber.h"
#INCLUDE "..\..\vfpbot.h"
#INCLUDE "autojoin.h"

PROCEDURE GetInterface(loInterface)
loInterface=CREATEOBJECT("_autojoin_service")
RETURN .T.


**************************************************
DEFINE CLASS _autojoin_service AS _service
   Name="_autojoin_service"

   AJoin=SYS(2015)


   PROCEDURE AfterInit(loJC)
      =loJC.AddCommand(_cmd_AUTOJOIN_ENABLE,"AUTOJOIN ENABLE","Enable JID for autojoin")
      =loJC.AddCommand(_cmd_AUTOJOIN_DISABLE,"AUTOJOIN DISABLE","Disable JID for autojoin")
      =loJC.AddCommand(_cmd_AUTOJOIN_REMOVE,"AUTOJOIN REMOVE","Remove JID for autojoin")
      =loJC.AddCommand(_cmd_AUTOJOIN_LIST,"AUTOJOIN LIST","List all JIDs for autojoin")
      =loJC.AddCommand(_cmd_AUTOJOIN_SET,"AUTOJOIN SET","Set JID for autojoin")

      =loJC.AddCommand(_cmd_HELP_AUTOJOIN_ENABLE,"HELP AUTOJOIN ENABLE","")
      =loJC.AddCommand(_cmd_HELP_AUTOJOIN_DISABLE,"HELP_AUTOJOIN DISABLE","")
      =loJC.AddCommand(_cmd_HELP_AUTOJOIN_REMOVE,"HELP_AUTOJOIN REMOVE","")
      =loJC.AddCommand(_cmd_HELP_AUTOJOIN_LIST,"HELP AUTOJOIN LIST","")
      =loJC.AddCommand(_cmd_HELP_AUTOJOIN_SET,"HELP AUTOJOIN SET","")
   ENDPROC

   PROCEDURE OpenSources(loJC)
      * loJC - Object reference to jabber object
      IF loJC.OpenTable(m.This.MainPath+"jbjoin.dbf",This.AJoin,"AGAIN",m.This.DataSessionID)#ErrOK
         RETURN .F.
      ENDIF
      SET ORDER TO "XXI000" IN (This.AJoin)
   ENDPROC

   PROCEDURE CloseSources(loJC)
      * loJC - Object reference to jabber object
      IF USED(This.AJoin)
         USE IN (This.AJoin)
      ENDIF
   ENDPROC

   PROCEDURE GetMessage(loSP)
      * Test na chybu
      IF m.loSP.oJCP.nError>0
         RETURN _Serv_Run_Next
      ENDIF
      IF !m.loSP.ParseCommand()
         RETURN _Serv_Run_Next
      ENDIF

      LOCAL lcPom,liXID,llFind,liy,loMsg,liMax,liXX400I
      LOCAL ARRAY laJID(1)

      * AUTOJOIN REMOVE
      * AUTOJOIN DISABLE
      * AUTOJOIN ENABLE
      * AUTOJOIN LIST
      * AUTOJOIN SET

      DO CASE
         CASE m.loSP.iWords=2 AND m.loSP.aUWords(1)=="AUTOJOIN" AND m.loSP.aUWords(2)=="LIST"
              m.loSP.oJC.AddSpy(@loSP,_cmd_AUTOJOIN_LIST,0,"","")
              STORE "" TO lcData
              SELE (m.This.AJoin)

              DIME laJID(RECC())
              STORE 0 TO liy,liMax
              SCAN FOR IDJID>-1
                   liy=m.liy+1
                   laJID(RECNO())=m.loSP.oJC.GetJID(IDJID,.F.)
                   liMax=MAX(m.liMax,LEN(laJID(RECNO())))
              ENDSCAN

              SCAN FOR IDJID>-1
                   lcData=m.lcData+;
                          PADR(laJID(RECNO()),m.liMax)+" "+;
                          IIF(XX100=0,"Disabled","Enabled")+CRLF
              ENDSCAN

              IF m.liy=0
                 lcData="Autojoin not found"
              ELSE
                 lcPom=PADR("JID",m.liMax)+" "+;
                       PADR("State",8)+CRLF
                 lcData=m.lcPom+REPL("-",LEN(m.lcPom)-2)+CRLF+m.lcData
              ENDIF

              loMsg=CREATEOBJECT("_jbmessage")
              loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
              loMsg.To=m.loSP.ReplyTo && Pjemce
              loMsg.From=m.loSP.ReplyFrom && odeslatel

              loMsg.Body=lcData
              loMsg.HTML=[<span style='font-family: Courier New;'>]+;
                         STRTRAN(m.lcData,CRLF,"<br />")+[</span>]
              m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
              RETURN _Serv_Run_Processed

         CASE m.loSP.iWords>=3 AND m.loSP.aUWords(1)=="AUTOJOIN"

              * 2. DISABLE, ENABLE, REMOVE, SET, LIST
              * 3. kanl
              * 4. text (nen poteba)

              liXID=m.loSP.oJC.GetIDJID(m.loSP.aWords(3))

              DO CASE
                 CASE m.loSP.aUWords(2)=="REMOVE"
                      This.EDJoin(m.liXID,-1)
                      liXX400I=_cmd_AUTOJOIN_REMOVE

                 CASE m.loSP.aUWords(2)=="ENABLE"
                      This.EDJoin(m.liXID,1)
                      liXX400I=_cmd_AUTOJOIN_ENABLE

                 CASE m.loSP.aUWords(2)=="DISABLE"
                      This.EDJoin(m.liXID,0)
                      liXX400I=_cmd_AUTOJOIN_DISABLE

                 CASE m.loSP.aUWords(2)=="SET"
                      liXX400I=_cmd_AUTOJOIN_SET

                 OTHERWISE
                      RETURN _Serv_Run_Free

              ENDCASE

              m.loSP.oJC.AddSpy(@loSP,m.liXX400I,0,m.loSP.aWords(3),"")
              IF !m.loSP.aUWords(2)=="SET"
                 RETURN _Serv_Run_Processed
              ENDIF

              SELE (m.This.AJoin)
              llFind=SEEK(BINTOC(m.liXID))
              IF !m.llFind
                 * Najdi voln msto
                 m.llFind=SEEK(BINTOC(-1))
              ENDIF

              IF m.llFind
                 REPL IDJID WITH m.liXID
              ELSE
                 INSERT INTO (This.AJoin) (IDJID) ;
                             VALUES (m.liXID)
              ENDIF
              This.EDJoin(m.liXID,1)
              RETURN _Serv_Run_Processed

         CASE INLIST(m.loSP.iWords,2,3) AND m.loSP.aUWords(1)=="HELP"
              DO CASE
                 CASE m.loSP.iWords=3 AND m.loSP.aUWords(2)=="AUTOJOIN" AND m.loSP.aUWords(3)=="SET"
                      liXX400I=_cmd_HELP_WELCOME_SET
                      lcData=[JID for autojoin]+CRLF+;
                             [!AUTOJOIN SET jid]+CRLF+;
                             [ jid  - JID]+CRLF+CRLF+;
                             [ Examples:]+CRLF+;
                             [ !autojoin set hauz@conf.netlab.cz]

                      lcHTML=[<span style="font-weight: bold;">JID for autojoin<br />]+;
                             [!AUTOJOIN SET jid</span><br />]+;
                             [ jid  - JID<br /><br />]+;
                             [ <span style="font-style: italic;">Examples:</span><br />]+;
                             [ !autojoin set hauz@conf.netlab.cz]
    

                 CASE m.loSP.iWords=3 AND m.loSP.aUWords(2)=="AUTOJOIN" AND m.loSP.aUWords(3)=="DISABLE"
                      liXX400I=_cmd_HELP_AUTOJOIN_DISABLE
                      lcData=[Disable JID for autojoin]+CRLF+;
                             [!AUTOJOIN DISABLE jid]+CRLF+CRLF+;
                             [ jid - JID]+CRLF+;
                             [ Examples:]+CRLF+;
                             [ !welcome disable hauz@conf.netlab.cz]

                      lcHTML=[<span style="font-weight: bold;">Disable JID for autojoin<br />]+;
                             [!AUTOJOIN DISABLE jid</span><br />]+;
                             [ jid - JID<br />]+;
                             [ <span style="font-style: italic;">Examples:</span><br />]+;
                             [ !welcome disable hauz@conf.netlab.cz]

                 CASE m.loSP.iWords=3 AND m.loSP.aUWords(2)=="AUTOJOIN" AND m.loSP.aUWords(3)=="ENABLE"
                      liXX400I=_cmd_HELP_AUTOJOIN_ENABLE
                      lcData=[Enable JID for autojoin]+CRLF+;
                             [!AUTOJOIN ENABLE jid]+CRLF+CRLF+;
                             [ jid - JID]+CRLF+;
                             [ Examples:]+CRLF+;
                             [ !welcome enable hauz@conf.netlab.cz]

                      lcHTML=[<span style="font-weight: bold;">Enable JID for autojoin<br />]+;
                             [!AUTOJOIN ENABLE jid</span><br />]+;
                             [ jid - JID<br />]+;
                             [ <span style="font-style: italic;">Examples:</span><br />]+;
                             [ !welcome enable hauz@conf.netlab.cz]

                 CASE m.loSP.iWords=3 AND m.loSP.aUWords(2)=="AUTOJOIN" AND m.loSP.aUWords(3)=="REMOVE"
                      liXX400I=_cmd_HELP_AUTOJOIN_REMOVE
                      lcData=[Remove JID for autojoin]+CRLF+;
                             [!AUTOJOIN REMOVE jid]+CRLF+CRLF+;
                             [ jid - JID]+CRLF+;
                             [ Examples:]+CRLF+;
                             [ !welcome remove hauz@conf.netlab.cz]

                      lcHTML=[<span style="font-weight: bold;">Remove JID for autojoin<br />]+;
                             [!AUTOJOIN REMOVE jid</span><br />]+;
                             [ jid - JID<br />]+;
                             [ <span style="font-style: italic;">Examples:</span><br />]+;
                             [ !welcome remove hauz@conf.netlab.cz]

                 CASE m.loSP.iWords=3 AND m.loSP.aUWords(2)=="AUTOJOIN" AND m.loSP.aUWords(3)=="LIST"
                      liXX400I=_cmd_HELP_WELCOME_LIST
                      lcData=[List all JIDs for autojoin]+CRLF+;
                             [!AUTOJOIN LIST]+CRLF+CRLF+;
                             [ Examples:]+CRLF+;
                             [ !welcome list]

                      lcHTML=[<span style="font-weight: bold;">List all JIDs for autojoin<br />]+;
                             [!AUTOJOIN LIST</span><br /><br />]+;
                             [ <span style="font-style: italic;">Examples:</span><br />]+;
                             [ !welcome list]
                 
                 OTHERWISE
                     RETURN _Serv_Run_Free

              ENDCASE

              m.loSp.oJC.AddSpy(@loSP,m.liXX400I,0,"","")
              loMsg=CREATEOBJECT("_jbmessage")
              loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
              loMsg.To=m.loSP.ReplyTo && Pjemce
              loMsg.From=m.loSP.ReplyFrom && Odeslatel
              loMsg.Body=lcData
              loMsg.HTML=lcHTML
              m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
              RETURN _Serv_Run_Processed


         OTHERWISE
              RETURN _Serv_Run_Free
      ENDCASE
   ENDPROC

   PROCEDURE Connected(loSP)
      LOCAL lcJID
      SELE (m.This.AJoin)
      SCAN FOR XX100=1
           lcJID=m.loSP.oJC.GetJID(IDJID)
           =IIF(m.This.oSP.oJC.IsConf(m.lcJID),;
                m.This.oSP.oJC.JoinToConf(m.lcJID,m.This.oSP.oJC.DefNick),.T.) && Odkud
      ENDSCAN
   ENDPROC

   PROCEDURE EDJoin(liXID,liEnab)
      SELE (m.This.AJoin)
      IF SEEK(BINTOC(m.liXID))
         IF m.liEnab=-1
            REPL XX100 WITH liEnab, IDJID WITH -1
         ELSE
            REPL XX100 WITH liEnab
         ENDIF
      ENDIF
   ENDPROC

ENDDEFINE
