#INCLUDE "..\..\jabber.h"
#INCLUDE "..\..\vfpbot.h"
#INCLUDE "faq.h"

PROCEDURE GetInterface(loInterface)
loInterface=CREATEOBJECT("_faq_service")
RETURN .T.


**************************************************
DEFINE CLASS _faq_service AS _service
   Name="_faq_service"

   AFaq=SYS(2015)


   PROCEDURE AfterInit(loJC)
      =loJC.AddCommand(_cmd_FAQ_ID,"FAQ #","Return FAQ")

      =loJC.AddCommand(_cmd_HELP_FAQ_ID,"HELP FAQ","")
   ENDPROC

   PROCEDURE OpenSources(loJC) && open sources for service (table, etc)
      * loJC - Object reference to jabber object

      * In this method you can open all needly sources
      IF loJC.OpenTable(m.This.MainPath+"FAQ.dbf",This.AFAQ,"AGAIN",m.This.DataSessionID)#ErrOK
         RETURN .F.
      ENDIF
*      SET ORDER TO "XXI000" IN (This.AJoin)
   ENDPROC

   PROCEDURE CloseSources(loJC)
      * loJC - Object reference to jabber object

      * In this method you must close all opened sources
      IF USED(This.AFAQ)
         USE IN (This.AFAQ)
      ENDIF
   ENDPROC

   PROCEDURE GetMessage(loSP)
      * This method can process message packet

      IF m.loSP.oJCP.nError>0 && Any error
         RETURN _Serv_Run_Next
      ENDIF
      IF !m.loSP.ParseCommand() && message not contain command
         RETURN _Serv_Run_Next
      ENDIF

      LOCAL lcPom,liXID,llFind,liy,loMsg,liMax,liXX400I
      LOCAL ARRAY laJID(1)

      * faq commands

      * Object loSP is special object for passing parameters between vfpbot and services
      * member oJC is reference to vfpbot object
      * member array aUWORDS contain command splitted by words - upper case
      * member array aWORDS contain command splitted by words - original text

      * ATTENTIONS all strings are in UTF-8,...

      * How to send 

      DO CASE
         CASE m.loSP.iWords=2 AND m.loSP.aUWords(1)=="FAQ" AND LEFT(m.loSP.aUWords(2),1)=="#"
              m.loSP.oJC.AddSpy(@loSP,_cmd_FAQ_ID,0,"","") && Add command to history

              STORE "" TO lcData
              SELE (m.This.AFAQ)

              * Seek faq

              * Generate message and send it

              loMsg=CREATEOBJECT("_jbmessage") && Create jabber message
              *******************************
              * Don't remove these rows
              loMsg.ID=m.loSP.oJCP.ID && Message ID
              loMsg.To=m.loSP.ReplyTo && Recipient
              loMsg.From=m.loSP.ReplyFrom && Sender
              * Don't remove these rows
              *******************************

               
              * You can fill property Body or HTML
              * ATTENTIONS all strings are in UTF-8,...
              * You can put into property HTML only valid xhtml, but, please, use only elements <span></span> and <br />
              * (look at services\lamer\lamer.prg)
              
              loMsg.Body="FAQ "+m.loSP.aWords(2)+CRLF+;
                         "Welcome to FAQ"


*!*	              loMsg.HTML=[<span style='font-weight: bold;'>]+;
*!*	                         "FAQ "+m.loSP.aWords(2)+[</span><br />]+;
*!*	                         [<span style='font-weight: normal;'>]+;
*!*	                         "Welcome to FAQ"+[</span>]

              * Send message
              * ATTENTIONS Don't remove second parameter
              * Third parameter, is timeout in seconds for later sending, 0 - send message now
              m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)

              *******************************
              * Don't remove this row
              RETURN _Serv_Run_Processed
              * Don't remove this row
              *******************************

*!*	         CASE INLIST(m.loSP.iWords,2,3) AND m.loSP.aUWords(1)=="HELP"
*!*	              DO CASE
*!*	                 CASE m.loSP.iWords=2 AND m.loSP.aUWords(2)=="FAQ"
*!*	                      liXX400I=_cmd_HELP_WELCOME_SET
*!*	                      lcData=[JID for faq]+CRLF+;
*!*	                             [!faq SET jid]+CRLF+;
*!*	                             [ jid  - JID]+CRLF+CRLF+;
*!*	                             [ Examples:]+CRLF+;
*!*	                             [ !faq set hauz@conf.netlab.cz]

*!*	                      lcHTML=[<span style="font-weight: bold;">JID for faq<br />]+;
*!*	                             [!faq SET jid</span><br />]+;
*!*	                             [ jid  - JID<br /><br />]+;
*!*	                             [ <span style="font-style: italic;">Examples:</span><br />]+;
*!*	                             [ !faq set hauz@conf.netlab.cz]
*!*	    

*!*	                 CASE m.loSP.iWords=3 AND m.loSP.aUWords(2)=="faq" AND m.loSP.aUWords(3)=="DISABLE"
*!*	                      liXX400I=_cmd_HELP_faq_DISABLE
*!*	                      lcData=[Disable JID for faq]+CRLF+;
*!*	                             [!faq DISABLE jid]+CRLF+CRLF+;
*!*	                             [ jid - JID]+CRLF+;
*!*	                             [ Examples:]+CRLF+;
*!*	                             [ !welcome disable hauz@conf.netlab.cz]

*!*	                      lcHTML=[<span style="font-weight: bold;">Disable JID for faq<br />]+;
*!*	                             [!faq DISABLE jid</span><br />]+;
*!*	                             [ jid - JID<br />]+;
*!*	                             [ <span style="font-style: italic;">Examples:</span><br />]+;
*!*	                             [ !welcome disable hauz@conf.netlab.cz]

*!*	                 CASE m.loSP.iWords=3 AND m.loSP.aUWords(2)=="faq" AND m.loSP.aUWords(3)=="ENABLE"
*!*	                      liXX400I=_cmd_HELP_faq_ENABLE
*!*	                      lcData=[Enable JID for faq]+CRLF+;
*!*	                             [!faq ENABLE jid]+CRLF+CRLF+;
*!*	                             [ jid - JID]+CRLF+;
*!*	                             [ Examples:]+CRLF+;
*!*	                             [ !welcome enable hauz@conf.netlab.cz]

*!*	                      lcHTML=[<span style="font-weight: bold;">Enable JID for faq<br />]+;
*!*	                             [!faq ENABLE jid</span><br />]+;
*!*	                             [ jid - JID<br />]+;
*!*	                             [ <span style="font-style: italic;">Examples:</span><br />]+;
*!*	                             [ !welcome enable hauz@conf.netlab.cz]

*!*	                 CASE m.loSP.iWords=3 AND m.loSP.aUWords(2)=="faq" AND m.loSP.aUWords(3)=="REMOVE"
*!*	                      liXX400I=_cmd_HELP_faq_REMOVE
*!*	                      lcData=[Remove JID for faq]+CRLF+;
*!*	                             [!faq REMOVE jid]+CRLF+CRLF+;
*!*	                             [ jid - JID]+CRLF+;
*!*	                             [ Examples:]+CRLF+;
*!*	                             [ !welcome remove hauz@conf.netlab.cz]

*!*	                      lcHTML=[<span style="font-weight: bold;">Remove JID for faq<br />]+;
*!*	                             [!faq REMOVE jid</span><br />]+;
*!*	                             [ jid - JID<br />]+;
*!*	                             [ <span style="font-style: italic;">Examples:</span><br />]+;
*!*	                             [ !welcome remove hauz@conf.netlab.cz]

*!*	                 CASE m.loSP.iWords=3 AND m.loSP.aUWords(2)=="faq" AND m.loSP.aUWords(3)=="LIST"
*!*	                      liXX400I=_cmd_HELP_WELCOME_LIST
*!*	                      lcData=[List all JIDs for faq]+CRLF+;
*!*	                             [!faq LIST]+CRLF+CRLF+;
*!*	                             [ Examples:]+CRLF+;
*!*	                             [ !welcome list]

*!*	                      lcHTML=[<span style="font-weight: bold;">List all JIDs for faq<br />]+;
*!*	                             [!faq LIST</span><br /><br />]+;
*!*	                             [ <span style="font-style: italic;">Examples:</span><br />]+;
*!*	                             [ !welcome list]
*!*	                 
*!*	                 OTHERWISE
*!*	                     RETURN _Serv_Run_Free

*!*	              ENDCASE

*!*	              m.loSp.oJC.AddSpy(@loSP,m.liXX400I,0,"","")
*!*	              loMsg=CREATEOBJECT("_jbmessage")
*!*	              loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
*!*	              loMsg.To=m.loSP.ReplyTo && Pjemce
*!*	              loMsg.From=m.loSP.ReplyFrom && Odeslatel
*!*	              loMsg.Body=lcData
*!*	              loMsg.HTML=lcHTML
*!*	              m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
*!*	              RETURN _Serv_Run_Processed


         OTHERWISE
              RETURN _Serv_Run_Free
      ENDCASE
   ENDPROC

ENDDEFINE
