#INCLUDE "jabber.h"
#INCLUDE "smtp.h"
#INCLUDE "threads.h"



************************************************************************************
**
** Jabber layer for VFP 7.0 and heigher
** Portions of this software based on SocketWrench, licensed from Catalyst Development Corporation
** (http://www.catalyst.com/products/socketwrench)
** Author: Martin Jindra
** E-mail: martin.jindra@egservis.cz
** Date:   2005-03-22
** 
**
**
**
************************************************************************************

*!*	SET PROCEDURE TO x:\jabber\jabber

*!*	loo=CREATEOBJECT("_SMTPLayer")
*!*	loo.Connect()
*!*	susp

*!*	SET PROCEDURE TO

**************************************************************
DEFINE CLASS _SMTPLayer AS CUSTOM && Zkladn tda Jabber klienta
   Name="_SMTPLayer"

   iQueue=0
   DIME aQueue(_JC_DataSystem+1,2)

   GlobalStatus= _SMTP_GS_None
   Version="0.0.0.0"
 
   Server="smtpserv.egservis.cz"

   IP=""
   Port=25
   User=""
   Password=""
   Method=""


   InnerStatus=0  && (0 free, 1 header, 2 body)

   iMessages=0  && ta zprv
   oThread=.NULL. && odkaz na probhajc thread

   IsReconnect=.F.

   cCollate=""
   ASend="" && Alias pro postupn odesln dat
   AEVENTS="" && Alias udlostn zench ...
   iSend=0 && Poet zpis

   Body=""

   iQuit=0

   StartPath=""
   ADD OBJECT tmrjc AS _tmrSMTP
   ADD OBJECT tmrsn AS _tmrSMTPSend


   PROCEDURE GlobalStatus_Assign(liVal)
       IF TYPE("liVal")#"N"
          MESSAGEBOX("Stop. GlobalStatus mismatch")
          SUSP
       ELSE
          This.GlobalStatus=liVal
       ENDIF
   ENDPROC

   PROCEDURE Error(nError,cMethod,nLine) && Chybov rutina
      * nError  - slo chyby
      * cMethod - Nzev metody ve kter dolo k chyb
      * nLine   - slo dku na kterm dolo k chyb
      DEBUGOUT PROGRAM(PROGRAM(-1)-1)+":"+cMethod+":"+LTRIM(STR(nLine,11))+" "+MESSAGE()

*      _SMPTLayer::WriteToErr(PROGRAM(PROGRAM(-1)-1)+":"+cMethod+":"+LTRIM(STR(nLine,11))+" "+MESSAGE()+CRLF)

   ENDPROC




   PROCEDURE SendMessage(lcHeader,lcData)
      This.Body=lcData
      =This.SendData(lcHeader,0)
      =This.SendData(CRLF,0)
      This.InnerStatus=_SMTP_IS_Header
   ENDPROC


   PROCEDURE Destroy()
      IF USED(m.This.ASEND)
         USE IN (m.This.ASEND)
      ENDIF
      IF USED(m.This.AEVENTS)
         USE IN (m.This.AEVENTS)
      ENDIF
   ENDPROC

   PROCEDURE Init()
      LOCAL lcPath
      lcPath=SYS(16,0)
      lcPath=SUBST(lcPath,AT(" ",lcPath,2)+1)
      This.StartPath=IIF(RAT("\",lcPath)>0,LEFT(lcPath,RAT("\",lcPath)),lcPath)

      This.cCollate=SET("COLLATE")
      SET COLLATE TO "MACHINE"
      This.ASend=SYS(2015)
      This.AEVENTS=SYS(2015)

      CREATE CURSOR (This.ASend) (XX400 I, XX401 M NOCPTRANS)
      INDEX ON XX400 TAG XXI000

      CREATE CURSOR (This.AEVENTS) (XX200 N(2), XX201 M NOCPTRANS, XX202 M NOCPTRANS, XX203 M NOCPTRANS, XX204 N(1))
      INDEX ON STR(XX200,2)+LEFT(XX201,200) TAG XXI000
      INDEX ON STR(XX200,2)+LEFT(XX203,200) TAG XXI001

   ENDPROC


   PROCEDURE Disconnect(liStatus) && Disconnect from jabber server
      LOCAL loWS,lii,lcAlias,llExist

      IF !INLIST(This.GlobalStatus,_SMTP_GS_Joined,_SMTP_GS_Disconnecting,_SMTP_GS_Reconnect)
         This.GlobalStatus=_SMTP_GS_Disconnecting
         This.Disconnected()
         RETURN &&  TO MASTER
      ENDIF

      loWS=m.This.cntjc.oWS
      IF m.loWS.GetState()#sckConnected
         RETURN &&  TO MASTER
      ENDIF

      liStatus=IIF(PCOUNT()=0 OR TYPE("liStatus")#"N",_SMTP_GS_Disconnecting,liStatus)

      This.GlobalStatus=liStatus
      This.tmrJC.Enabled=.T.
   ENDPROC

   PROCEDURE Disconnected() && Udlost
      This.tmrSN.Enabled=.F.
      IF This.GlobalStatus=_SMTP_GS_Disconnecting
         This.GlobalStatus= _SMTP_GS_None
      ENDIF
      =IIF(PEMSTATUS(This,"cntJC",5),This.RemoveObject("cntJC"),.T.)
      This.tmrJC.Enabled=.F.
      STORE .NULL. TO This.aQueue
   ENDPROC

   PROCEDURE Connect(lcServer,liPort,lcUser,lcPWD) && Connect to jabber server
*      =This.WriteToLog("SYSTEM: Start connect..."+CRLF)
      _vfp.AutoYield=.F.
      This.AddObject("cntJC","_cntjcWS")
      
      ZAP IN (m.This.ASend)
      INSERT INTO (This.ASend) (XX400) VALUES (_ID_Max)

      IF PCOUNT()=4
         This.Server=m.lcServer
         This.Port=m.liPort
         This.User=m.lcUser
         This.Password=m.lcPWD
         IF EMPTY(m.This.DefNick)
            m.This.DefNick=m.lcUser
         ENDIF
      ENDIF

*This.cntjc.oWS.object.tracefile="d:\temp\catalyst.log"
*This.cntjc.oWS.object.trace=.t.


      STORE .NULL. TO This.aQueue
      This.GlobalStatus=_SMTP_GS_None
      This.InnerStatus=_SMTP_IS_None
      This.iQuit=0
      IF PCOUNT()=0
         This.cntjc.oWS.VFPConnect(m.This.Server,m.This.Port)
      ELSE
         This.cntjc.oWS.VFPConnect(m.lcServer,m.liPort)
      ENDIF

   ENDPROC


   PROCEDURE Reconnect(liInterval) && Reconnect to jabber server
      This.IsReconnect=.T.
      This.tmrJC.Index=0
      This.tmrJC.MaxIndex=INT(liInterval/This.tmrJC.Interval)
      This.tmrJC.Reset()
      This.GlobalStatus=_SMTP_GS_Reconnect
      This.tmrJC.Enabled=.T.
   ENDPROC


   PROCEDURE Connected() && Dolo ke kompletnmu pihlen k JS
      LOCAL lcAlias,lii
*      =This.WriteToLog("SYSTEM: Connected"+CRLF)

      * Pokud dolo k optovnmu pihlen
      IF This.IsReconnect
         This.iReconnect=This.iReconnect+1
         This.IsReconnect=.F.
      ENDIF

   ENDPROC

   PROCEDURE ConnectionFailed(liStatus) && Nedolo ke kompletnmu pihlen k JS
      * liStatus - Status nephleni
*      =This.WriteToLog("SYSTEM: Connection failed"+CRLF)
      debugout("Connection failed")
      LOCAL loWS
      loWS=m.This.cntjc.oWS

      This.GlobalStatus=_SMTP_GS_Disconnecting_CF
      =m.loWS.VFPDisconnect() 
      =m.This.Disconnected()
   ENDPROC

   PROCEDURE LostConnection(liStatus) && Spojen ztraceno
      * liStatus - Status spojen - Winsock
*      =This.WriteToLog("SYSTEM: Lost connection"+CRLF)
      debugout("Lost connection")
      LOCAL loWS
      loWS=m.This.cntjc.oWS

      This.GlobalStatus=_SMTP_GS_Disconnecting_LC
      This.oThread.SMTPFailed=.T.
      =m.loWS.VFPDisconnect() 
      =m.This.Disconnected()
   ENDPROC

   PROCEDURE Restart()
      This.Disconnect(_SMTP_GS_Restart)
   ENDPROC

   PROCEDURE AddEvent(liXX200,lcXX201,lcXX202,lcXX203, lnXX204) && Zalo udlost
      * liXX200 - Typ udlosti (presence/iq)
      * lcXX201 - ID udlosti 
      * lcXX202 - vygenerovan pkaz v XML
      * lcXX203 - Sekundrn ID (pro presenci brna/nick)
      * lnXX204 - Sekundrn ID (pro presenci brna/nick)

      LOCAL liSele
      liSele=SELE()
      SELE (m.This.AEVENTS)
      * Najdi voln flek
      IF SEEK("-1")
         REPL XX200 WITH m.liXX200, XX201 WITH m.lcXX201, XX202 WITH m.lcXX202,;
              XX203 WITH IIF(EMPTY(m.lcXX203),"",m.lcXX203), XX204 WITH IIF(EMPTY(m.lnXX204),0,m.lnXX204)
      ELSE
         INSERT INTO (This.AEVENTS) (XX200,XX201,XX202,XX203,XX204) VALUES;
                (m.liXX200,m.lcXX201,m.lcXX202,IIF(EMPTY(m.lcXX203),"",m.lcXX203),IIF(EMPTY(m.lnXX204),0,m.lnXX204))
      ENDIF
      SELE (m.liSele)
      RETURN .T.
   ENDPROC

   PROCEDURE AddToQueue(liIndex,lcData) && Add request to queue
      * lcData - Data
      m.This.aQueue(m.liIndex,1)=m.lcData
   ENDPROC

   PROCEDURE AddDataToQueue(liIndex,lcData) && Find Data into queue
      * lcData - Data
      debugout "RECEIV: "+STRCONV(m.lcData,11)

      m.This.aQueue(IIF(m.liIndex=_JC_DataNext,_JC_DataSystem+1,m.liIndex),2)=lcData
      =m.This._DataArrival(m.This.aQueue(IIF(m.liIndex=_JC_DataNext,_JC_DataSystem+1,m.liIndex),2))
   ENDPROC

   PROCEDURE GetDataFromQueue(liIndex) && Get returned Data from queue
      * lcData - XML data
      * Convert XML data TO XML hierarchy
      RETURN m.This.aQueue(m.liIndex,2)
   ENDPROC

   PROCEDURE _DataArrival(lcData) && Internal Event
      This.DataArrival(lcData) && Event
   ENDPROC


   PROCEDURE DataArrival(lcData) && Event

      liGS=This.GlobalStatus

      DO CASE

         CASE liGS=_SMTP_GS_Connect && Nastaveno spojen
              IF LEFT(ALLTRIM(lcData),3)="220"
                 This.GlobalStatus=_SMTP_GS_Establish
              ENDIF


         CASE liGS=_SMTP_GS_Helo && Pozdrav
              IF LEFT(ALLTRIM(lcData),3)="250"
                 This.GlobalStatus=_SMTP_GS_Joined
              ENDIF


         CASE liGS=_SMTP_GS_Disconnecting OR liGS=_SMTP_GS_Restart && Ukonen
              IF LEFT(ALLTRIM(lcData),3)="220"
                 =m.loWS.VFPDisconnect() 
                 loJC.Disconnected()
              ENDIF

              IF This.iQuit=1 AND LEFT(ALLTRIM(lcData),3)="221"
                 This.iQuit=2
              ENDIF


         CASE liGS=_SMTP_GS_Joined AND This.InnerStatus=_SMTP_IS_Header
              IF LEFT(ALLTRIM(lcData),3)="354"
                 This.InnerStatus=_SMTP_IS_Body
                 This.SendData(This.Body,0)
              ENDIF

         CASE liGS=_SMTP_GS_Joined AND This.InnerStatus=_SMTP_IS_Body
              IF LEFT(ALLTRIM(lcData),3)="250"
                 This.InnerStatus=_SMTP_IS_End
                 This.oThread.MessageSent=.T.
              ENDIF

      ENDCASE

   ENDPROC



   PROCEDURE SendData(lcData,liInterval) && Odesln dat pes WinSock
      * lcData     - XML Data
      * liInterval - Interval pro zpoovac frontu
      LOCAL loWS

      IF m.liInterval=0
         m.This._SendData(@m.lcData) 
      ELSE
         SELE (m.This.ALag)
         SET ORDER TO "XXI000"
         * Najdi voln msto
         IF SEEK("0")
            REPL XX302 WITH 1, XX301 WITH m.lcData, XX303 WITH liInterval, XX300 WITH DATETIME()
         ELSE
            INSER INTO (m.This.ALag) (XX302, XX300, XX301, XX303) ;
                   VALUES (1, DATETIME(),m.lcData, liInterval)
         ENDIF
      ENDIF
   ENDPROC

   PROCEDURE _SendData(lcData) && Intern metoda na odesln dat pes WinSock
      * lcData     - XML Data
      LOCAL loWS,lcBuffer,liSize,liXX400,llNew,lc_Data


      IF !PEMSTATUS(This,"CNTJC",5)
         This.PrintCallStack()
         RETURN
      ENDIF
      loWS=This.cntjc.oWS
      IF m.loWS.GetState()#sckConnected
         IF This.GlobalStatus=_SMTP_GS_Disconnecting
            loJC.Disconnected()
            RETURN
         ELSE
            m.This.LostConnection()
            RETURN  && TO MASTER
         ENDIF
      ENDIF

      SELE (m.This.ASend)
      liSize=m.This.cntJC.oWS.Object.BufferSize
      lc_Data=m.lcData
      DO WHILE LEN(m.lc_Data)>0
         lcBuffer=LEFT(m.lc_Data,m.liSize)
         lc_Data=SUBST(m.lc_Data,m.liSize+1)

         GO BOTTOM
         liXX400=XX400+1

         GO TOP
         llNew=XX400=_ID_Max && Zalo novou vtu

         IF llNew
            INSERT INTO (This.ASend) (XX400,XX401) VALUES (liXX400,lcBuffer)
         ELSE
            REPL XX400 WITH liXX400,XX401 WITH lcBuffer
         ENDIF

         This.iSend=m.This.iSend+1
         IF m.This.iSend>=100
            PACK MEMO
            m.This.iSend=0
         ENDIF
         
      ENDDO
      This.tmrSN.Enabled=.T.
   ENDPROC

   PROCEDURE PrintCallStack()
      LOCAL lii
      FOR lii=1 TO PROGRAM(-1)
          DEBUGOUT PROGRAM(lii)
      NEXT
   ENDPROC

ENDDEFINE



*********************************************
DEFINE CLASS _cntjcWS AS container
   PROCEDURE Error(nError,cMethod,nLine) && Chybov rutina
      * nError  - slo chyby
      * cMethod - Nzev metody ve kter dolo k chyb
      * nLine   - slo dku na kterm dolo k chyb

       DEBUGOUT This.Class+":: "+PROGRAM(PROGRAM(-1)-1)+":"+cMethod+":"+LTRIM(STR(nLine,11))+" "+MESSAGE()
       =EVALUATE(This.Parent.Class+"::Error(nError,cMethod,nLine)")
   ENDPROC


   ADD OBJECT oWS AS _SMTPclientWS2
ENDDEFINE



*********************************************
DEFINE CLASS _tmrSMTPSend AS _jabtimer
   Name="_tmrSMTPSend"
   Interval=250
   Enabled=.F.

   PROCEDURE Timer()
      This.Enabled=.F.
      LOCAL loJC,lii,liRet,liSele
      liSele=SELE()
      loJC=m.This.Parent

      SELE (m.loJC.ASend)
      FOR lii=1 TO 1
          =SEEK(_ID_Max)
          SKIP 1
          IF !EOF()

*!*	IF XX400<_ID_Max OR lojc.GlobalStatus=5 AND ATC("HELO",XX401)>0
*!*	MESSAGEBOX("STOP")
*!*	SUSPEND
*!*	ENDIF

             liRet=m.loJC.cntJC.oWS.SendData(XX401)
             SELE (m.loJC.ASend)
             IF liRet=-1
                debugout "LC: Internal send data"
                m.loJC.LostConnection() && Peru spojen - nsleduje restart
                RETURN TO MASTER
             ELSE
                IF liRet>=0
                   debugout "SEND: "+XX401
*                   m.loJC.WriteToLog("SEND: "+XX401+CRLF)
                   REPL XX400 WITH _ID_Max-1 IN (m.loJC.ASend)
                   m.loJC.tmrJC.Enabled=.T.
                ENDIF
             ENDIF
          ELSE
             EXIT
          ENDIF
      NEXT

      IF SEEK(_ID_Max)
         SKIP 1
         This.Enabled= !EOF() AND XX400>_ID_Max
      ENDIF
      SELE (liSele)
   ENDPROC
ENDDEFINE


*********************************************
DEFINE CLASS _tmrSMTP AS _jabtimer
   Name="_tmrSMTP"
   Enabled=.F.
   Interval=250
   Index=-1
   MaxIndex=-1

   t1=0

   PROCEDURE Timer()
      This.Enabled=.F.

      LOCAL loJC,liGS,lcData,lcID,lcPom,lii,lcpwd,lcID,loWS,loXX
      loJC=This.Parent
      liGS=loJC.GlobalStatus

      DO CASE
         CASE liGS=_SMTP_GS_Connect && U se nakonektil, tak piprav spojen
              * Pihlen k serveru
       
              IF m.This.T1=0
                 m.This.T1=SECONDS()
              ELSE
                 loWS=m.loJC.cntjc.oWS
                 IF SECONDS()-m.This.T1>30000 OR m.loWS.GetState()#sckConnected
                    =m.loJC.LostConnection()
                    RETURN  && TO MASTER
                 ENDIF
              ENDIF
              DEBUGOUT "Conect..."
              This.Enabled=.T.

         CASE liGS=_SMTP_GS_Establish && Nastaveno spojen a pila odpov
              lcData=[HELO ]+m.loJC.Server && pozdrav server

*              =loJC.WriteToLog("SYSTEM: Helo sending..."+CRLF)
              loJC.GlobalStatus=_SMTP_GS_Helo
              loJC.AddToQueue(_SMTP_GS_Helo,lcData)
              loJC.AddEvent(_JC_E_stream,"",@m.lcData)
              loJC.SendData(@m.lcData,0)
              loJC.SendData(CRLF,0)
              m.This.T1=0
              This.Enabled=.T.


         CASE liGS=_SMTP_GS_Helo && Nastaveno spojen
              * Pevezmi ID z vrcench data
              loWS=m.loJC.cntjc.oWS
              DEBUGOUT "Helo/hell..."+STR(m.loJC.cntjc.oWS.getstate() )


              IF m.This.T1=0
                 m.This.T1=SECONDS()
              ELSE
                 IF SECONDS()-m.This.T1>30000 OR m.loWS.GetState()#sckConnected
                    =m.loJC.LostConnection()
                    RETURN  && TO MASTER
                 ENDIF
              ENDIF
              This.Enabled=.T.

         CASE liGS=_SMTP_GS_Authorisation && Nastaveno spojen
              DEBUGOUT "Authorisation..."
              loWS=m.loJC.cntjc.oWS
              IF m.loWS.GetState()#sckConnected
                 =m.loJC.LostConnection()
                 RETURN &&  TO MASTER
              ELSE
                 This.Enabled=.T.
              ENDIF

         CASE liGS=_SMTP_GS_Join && Pihlen - nastav status
              loWS=m.loJC.cntjc.oWS
              DEBUGOUT "Join..."

              IF m.loWS.GetState()#sckConnected
                 loJC.LostConnection()
                 RETURN &&  TO MASTER
              ELSE
                 This.Enabled=.T.
              ENDIF
               

         CASE liGS=_SMTP_GS_Joined && Pipojeno k JS
              loWS=m.loJC.cntjc.oWS
              IF m.loWS.GetState()#sckConnected
                 debugout "LC: Timer, after send data "+LTRIM(STR(m.loWS.GetState(),11))
                 debugout " state "+LTRIM(STR(m.loWS.state,11))
                 debugout " action "+LTRIM(STR(m.loWS.action,11))
                 m.loJC.LostConnection()
                 RETURN &&  TO MASTER
              ENDIF
              IF m.This.Index>=0
                 IF m.This.Index<240
                    m.This.Index=m.This.Index+1
                    This.Enabled=.T.
                 ELSE
                    m.loJC.LostConnection()
                    RETURN &&  TO MASTER
                 ENDIF
              ENDIF

         CASE liGS=_SMTP_GS_Error && Njak chyba - pro MS WinSock
              m.loJC.LostConnection()
              RETURN &&  TO MASTER

         CASE (liGS=_SMTP_GS_Disconnecting OR liGS=_SMTP_GS_Restart)  && Ukonen
              loWS=m.loJC.cntjc.oWS
              DEBUGOUT "Ukonovn... "

              DO CASE
                 CASE loJC.iQuit=0
                      =m.loJC.SendData(CRLF,0)
                      lcData=[QUIT]+CRLF
                      loJC.iQuit=1
                      =m.loJC.SendData(@m.lcData,0)
                      This.Enabled=.T.

                 CASE loJC.iQuit=2
                      =m.loWS.VFPDisconnect() 
                       loJC.Disconnected()
      
              ENDCASE    

         CASE liGS=_SMTP_GS_Reconnect
              IF m.This.Index>=0
                 IF m.This.Index<m.This.MaxIndex
                    m.This.Index=m.This.Index+1
                    This.Enabled=.T.
                 ELSE
                    m.This.Index=-1
                    loJC.Connect()
                 ENDIF
              ENDIF

         OTHERWISE
      ENDCASE
   ENDPROC
ENDDEFINE





DEFINE CLASS _SMTPclientWS2 AS OLECONTROL
   Name="_SMTPclientWS2"

   OLEClass="Catalyst.SocketCtrl.1"
   _Buffer=""
   Buffer=""
   Locked=.F. && Pznak zmku


   PROCEDURE Init()
      This.Object.AddressFamily = 2
      This.Object.Protocol = 0
      This.Object.SocketType = 1
      This.Object.Binary = 1
      This.Object.Blocking = .F.
      This.Object.BufferSize = 1024 && 16384 && 2048
      This.Object.Timeout = 30000
   ENDPROC



   PROCEDURE VFPConnect(m.lcServer,m.liPort)
      IF LEN(CHRTRAN(m.lcServer,".0123456789",""))>0
         This.HostName=m.lcServer
         This.HostAddress=""
      ELSE
         This.HostName=""
         This.HostAddress=m.lcServer
      ENDIF
      This.RemotePort= LTRIM(STR(m.liPort,11))
      =This.Object.Startup()
      =This.Object.Connect()
      =This.Connected()
   ENDPROC

   PROCEDURE VFPDisconnect()
      This.Object.Cleanup()
   ENDPROC

   PROCEDURE SendData(lcData)
      *@lcData - Data na odesln
      LOCAL lcBuffer,lii,loobj
      loobj=m.This.Object
      lii=0
      debugout "writing _"+IIF(m.loobj.IsBlocked,"Block ","NoBlock ")+IIF(m.loobj.IsWritable,"Write ","Read ")


      IF m.loobj.IsWritable
         lii=m.loobj.Write(@m.lcData,LEN(m.lcData))
         debugout "writing "+str(m.lii,11)
      ELSE
*         =m.loobj.Flush()
         lii=-2
      ENDIF
      RETURN m.lii
   ENDPROC

   PROCEDURE Connected()
      debugout "Connected to server..."

      WITH This.Parent.Parent
      .IP= This.Object.HostAddress
      .GlobalStatus=_SMTP_GS_Connect
*      .WriteToLog("SYSTEM: Connect to server..."+CRLF)
      .tmrJC.Enabled=.T. && Globln timer

*!*	if empty(set("coverage"))
*!*	set coverage to "d:\temp\____test.log"
*!*	endif
      ENDWITH
   ENDPROC


   PROCEDURE Read(datalength, isurgent)
      *** Udlosti ovldacch prvk ActiveX ***
      LOCAL lcData,lcPom,loObj
      lcData=""
      loObj=This.Object

      lcPom=SPACE(datalength)
      loObj.Read(@lcPom,datalength)
      lcData=lcPom

      DO WHILE loObj.RecvNext>0
         lcPom=SPACE(loObj.RecvNext)
         loObj.Read(@lcPom,loObj.RecvNext)
         lcData=lcData+lcPom
      ENDDO
      This.DataArrival(@lcData)
*      debugout "read data: "+lcData
   ENDPROC

   PROCEDURE DataArrival(lcData)
      LOCAL lcBuffer,lcTag,lii,loJC,lcPom,llSimple,liTag,liiS1,liiS2
      loJC=This.Parent.Parent
*      =loJC.WriteToLog("RECEIV: "+m.lcData+CRLF)

      IF EMPTY(m.lcData)
         RETURN
      ENDIF

      * pidej data do bufferu
      This.Buffer=m.This.Buffer+m.lcData

      IF m.This.Locked
         RETURN
      ENDIF

      This.Locked=.T.
      m.loJC.tmrJC.Enabled=.F. 

      * prove kontrolu sprvnosti
      DO WHILE .T.
         lcBuffer=m.This.Buffer

         lii=AT(CRLF,m.lcBuffer)
         IF lii>0
            lcBuffer=LEFT(m.lcBuffer,lii+1)
            m.This.Buffer=SUBST(m.This.Buffer,lii+2)
            loJC.AddDataToQueue(IIF(loJC.GlobalStatus=_SMTP_GS_Joined,_JC_DataNext,loJC.GlobalStatus),@lcBuffer)
            LOOP
         ELSE
            IF !EMPTY(m.lcBuffer) && lost data in buffer, remove it
               debugout "LD: "+m.lcBuffer
*               =loJC.WriteToLog("LD: "+m.lcBuffer+CRLF)
               loJC.AddDataToQueue(IIF(loJC.GlobalStatus=_SMTP_GS_Joined,_JC_DataNext,loJC.GlobalStatus),@m.lcBuffer)
            ENDIF
         ENDIF
         EXIT
      ENDDO
      This.Locked=.F.
      m.loJC.tmrJC.Enabled=.T. 
   ENDPROC

   PROCEDURE Write()
      debugout "SendComplete"
   ENDPROC

   PROCEDURE Error(nError, cMethod, nLine)
      * nError
      * cMethod
      * nLine
      debugout "WS Error: "+LTRIM(STR(m.nError,11))+" "+m.cMethod+" "+LTRIM(STR(m.nLine,11))
   ENDPROC

   PROCEDURE GetState()
      RETURN IIF(This.Object.IsClosed, sckClosed,IIF(This.Object.Connected, sckConnected,sckError))
   ENDPROC

ENDDEFINE







**************************
DEFINE CLASS _thr_smtp AS _Thread
   Name="_thr_smtp"
   
   oSP=.NULL.
   _cmdFailed="cmd_Failed"
   thrdID=0

   Header=""
   Body=""
   MessageSent=.F.
   SMTPFailed=.F.

   _ReadIndex=0
   _ReadIndexMax=100
   _ReadData=0

   lFirst=.T.

   ADD OBJECT cmd_Connect AS _Command
   ADD OBJECT cmd_SendMessage AS _Command
   ADD OBJECT cmd_Close AS _Command
   ADD OBJECT cmd_Failed AS _Command WITH iFailed=1
   
   PROCEDURE Destroy()

   ENDPROC


*!*	   PROCEDURE SMTPFailed()
*!*	*      This.Parent.ReRun=This.Parent.GetCommandIndex("cmd_StartNext")
*!*	*      RETURN _cmd_ReRun
*!*	   ENDPROC

   PROCEDURE cmd_Connect.RunCommand()
      LOCAL loJC
      loJC=This.Parent.oSP.oJC

      IF This.Parent.SMTPFailed
         RETURN _cmd_Failed
      ENDIF
  
      * Otestuj stav SMTP
      IF !loJC.SMTPTest()
         loJC.SMTPCreate() && Neexistuje, vytvo jej
         RETURN _cmd_Running
      ENDIF
      
      IF INLIST(loJC.oSMTP.GlobalStatus, _SMTP_GS_None,_SMTP_GS_Disconnecting_CF,_SMTP_GS_Disconnecting_LC,_SMTP_GS_Reconnect,_SMTP_GS_Restart)
         loJC.oSMTP.oThread=This.Parent
         loJC.oSMTP.Connect() && A pipoj se
         RETURN _cmd_Running
      ENDIF

      IF loJC.oSMTP.GlobalStatus# _SMTP_GS_Joined
         RETURN _cmd_Running
      ENDIF
      IF This.Parent.lFirst
         loJC.oSMTP.iMessages=loJC.oSMTP.iMessages+1
         This.Parent.lFirst=.F.
      ENDIF

      IF loJC.oSMTP.InnerStatus#_SMTP_IS_None && Prv se pouv
         RETURN _cmd_Running
      ENDIF
      loJC.oSMTP.oThread=This.Parent
      RETURN _cmd_End
   ENDPROC

   PROCEDURE cmd_SendMessage.RunCommand()
      LOCAL liRet,loJC
      loJC=This.Parent.oSP.oJC
      loJC.oSMTP.SendMessage(This.Parent.Header,This.Parent.Body)
      RETURN _cmd_End
   ENDPROC

   PROCEDURE cmd_Close.RunCommand()
      LOCAL loSP,loJC
      loSP=This.Parent.oSP
      loJC=loSP.oJC

      IF !This.Parent.MessageSent
         RETURN _cmd_Running
      ENDIF

      IF loJC.oSMTP.InnerStatus=_SMTP_IS_End
         loJC.oSMTP.iMessages=loJC.oSMTP.iMessages-1
         loJC.oSMTP.oThread=.NULL.
         loJC.oSMTP.InnerStatus=_SMTP_IS_None
         IF loJC.oSMTP.iMessages=0
            loJC.oSMTP.Disconnect()
         ENDIF
      ENDIF
      RETURN _cmd_End
   ENDPROC

   PROCEDURE cmd_Failed.RunCommand(loCommand)
      * loCommand - Pkaz ve kterm dolo k chyb

      LOCAL loMsg,loSP
      loSP=This.Parent.oSP
      loMsg=CREATEOBJECT("_jbmessage")
*      loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
      loMsg.To=m.loSP.ReplyTo && Pjemce
      loMsg.From=m.loSP.ReplyFrom && Odeslatel

      DO CASE 

         CASE LOWER(loCommand.Name)="cmd_connect" AND This.Parent.SMTPFailed
              loMsg.Body=loSP.cBody
              loMsg.nError=501
              loMsg.cError="Internal Timeout"

         OTHERWISE
              loMsg.Body=STRCONV("lamer panic... error panic;",9)

      ENDCASE
      m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)

      RETURN _cmd_End
   ENDPROC

ENDDEFINE
