LPARAMETERS lcConfig
#INCLUDE "jabber.h"
#INCLUDE "vfpbot.h"
#INCLUDE "threads.h"

************************************************************************************
**
** VFP bot for Jabber layer
** Author: Martin Jindra
** E-mail: martin.jindra@egservis.cz
** Date:   2005-03-22
** 
**
**
**
************************************************************************************


PUBLIC loJC,jbusr
LOCAL lcPath,lcXML,lii,liCount,liS,liE,lcPom,lcCFG,;
      lcServer,liPort,lcUID,lcPWD,llPlain,lcBlock,lcIP,;
      lcResource,lcPriority,lcDefaultNick


lcPath=SYS(16)
lcPath=IIF(RAT("\",lcPath)>0,LEFT(lcPath,RAT("\",lcPath)),lcPath)

*SET

SET CLASSLIB TO (lcPath+"jbusr.vcx") ADDITIVE
SET PROCED TO (lcPath+"jabber")

SET PATH TO (lcPath)
SET DEFA TO (lcPath)


IF !EMPTY(lcConfig) AND INLIST(RIGHT(lcConfig,1),["],['],"[")
   lcConfig=SUBST(lcConfig,2,LEN(lcConfig)-2)
ENDIF

lcCFG=IIF(EMPTY(lcConfig) OR !FILE(lcConfig),lcPath+"config.xml",lcConfig)
IF !FILE(lcCFG)
   RETURN .F.
ENDIF

loJC=CREATEOBJECT("_JabberBot")
loJC.Name="loJC"
* Service
* 

loJC.xmlConfig=lcCFG

DO WHILE .T.

   IF !loJC._ReadOptions(@lcXML)
      EXIT
   ENDIF

   * Read login type 

   lcPom=STREXTRACT(lcXML,'<logintype>',"</logintype>",1)

   DO CASE
      CASE lcPom="jabberclient"
           lcBlock=STREXTRACT(lcXML,'<jabberclient>',"</jabberclient>",1)
           lcServer=STREXTRACT(lcBlock,'<server>',"</server>",1)
           lcIP=STREXTRACT(lcBlock,'<ip>',"</ip>",1)
           liPort=VAL(STREXTRACT(lcBlock,'<port>',"</port>",1))
           lcUID=STREXTRACT(lcBlock,'<user>',"</user>",1)
           lcPWD=STREXTRACT(lcBlock,'<password>',"</password>",1)
           llPlain=STREXTRACT(lcBlock,'<plain>',"</plain>",1)="1"

           lcResource=STREXTRACT(lcBlock,'<resource>',"</resource>",1)
           lcPriority=STREXTRACT(lcBlock,'<priority>',"</priority>",1)
           lcDefaultNick=STREXTRACT(lcBlock,'<defaultnick>',"</defaultnick>",1)

           loJC.Resource=lcResource
           loJC.Priority=lcPriority
           loJC.DefNick=lcDefaultNick
 
           liPort=IIF(liPort<0,5222,liPort)
           IF EMPTY(lcServer) AND EMPTY(lcIP)
              lcServer="localhost"
           ENDIF

           IF EMPTY(lcUID)
              EXIT
           ENDIF

           IF !(TYPE("jbusr")="O" AND !ISNULL(jbusr))
              DO FORM jbusr with m.loJC LINKED NAME jbusr
           ENDIF

           loJC.cGUI="jbusr"
           *set Coverage to d:\temp\___jabber.log

           IF loJC.GlobalStatus# _JC_GS_Reconnect
              loJC.Plain=llPlain
              loJC.Connect(IIF(!EMPTY(lcIP),lcIP,lcServer),liPort,lcUID,lcPWD)
 
*                 loJC.Connect("localhost",5222,"foxbot","foxbot")
*                 loJC.Plain=.T.
*                 loJC.Connect("njs.netlab.cz",5222,"FoxBot","VFPBotFoxBot")
*                 loJC.Connect("jabber.cz",5222,"gorila","Galadriel")
           ENDIF
           IF !loJC.GlobalStatus=_JC_GS_Disconnecting_CF AND ;
              !loJC.GlobalStatus=_JC_GS_Disconnecting_LC
              READ EVENTS
           ENDIF
           IF loJC.GlobalStatus= _JC_GS_None
              EXIT
           ENDIF
           IF loJC.GlobalStatus# _JC_GS_Restart
              =loJC.Reconnect(m.loJC.ReconnectInterval)
           ENDIF
           set Coverage to

      CASE lcPom="jabbercomponent"
           lcBlock=STREXTRACT(lcXML,'<jabbercomponent>',"</jabbercomponent>",1)
           lcServer=STREXTRACT(lcBlock,'<server>',"</server>",1)
           lcIP=STREXTRACT(lcBlock,'<ip>',"</ip>",1)
           liPort=VAL(STREXTRACT(lcBlock,'<port>',"</port>",1))
           lcUID=STREXTRACT(lcBlock,'<component>',"</component>",1)
           lcPWD=STREXTRACT(lcBlock,'<secret>',"</secret>",1)
 
           liPort=IIF(liPort<0,5222,liPort)
           IF EMPTY(lcServer) AND EMPTY(lcIP)
              lcServer="localhost"
           ENDIF

           IF EMPTY(lcUID)
              EXIT
           ENDIF


           DO FORM jbusr with m.loJC LINKED NAME jbusr
           loJC.cGUI="jbusr"

           IF loJC.GlobalStatus# _JC_GS_Reconnect
              loJC.StartComponent(IIF(!EMPTY(lcIP),lcIP,lcServer),liPort,lcUID,lcPWD)

*              loJC.StartComponent("localhost",8888,"vfpbot")
           ENDIF
           IF !loJC.GlobalStatus=_JC_GS_Disconnecting_CF AND ;
              !loJC.GlobalStatus=_JC_GS_Disconnecting_LC
              READ EVENTS
           ENDIF

           IF loJC.GlobalStatus= _JC_GS_None
              EXIT
           ENDIF
           IF loJC.GlobalStatus# _JC_GS_Restart
              =loJC.Reconnect(m.loJC.ReconnectInterval)
           ENDIF

      OTHERWISE
           EXIT

   ENDCASE
ENDDO


loJC.ClearReferences()

RELE jbusr,loJC
CLEAR PROGRAM EXTENDED
SET PATH TO x:\
SET DEFA TO x:\

RETURN
*****************************



******************************************************************
DEFINE CLASS _JabberBot AS _JabberLayer
   Name="_JabberBot"

   Resource="Bot"
   Priority="1"
   DefNick="FoxBot"


   iDeCS=0
   DIME aDeCS(1) && Matice IDJID
   DIME aDeCSL(1) && Matice pznaku odstrann diakritiky



   AJID="" && Alias uivatel
   ALANGC="" && Alias jazyky

   ASpy="" && Alias sledovn
   AServices="" && Alias Services
   ASilent="" && Alias Silent
   ACJID="" && Alias JID pro komponentu

   ACommands="" && Alias Pkaz


   DefLang="en"
   oXML2=.NULL.

   BotVersion="0.0.2.0"

   DChars=""
   CTFromISO=""
   CTToISO=""


   SMTP_DNSReply=""
   SMTP_From=""


   cGUI="" && Nzev Public Formu - GUI


   ADD OBJECT Services AS _services

   ReconnectInterval=1

   xmlConfig=""
   MainPath=""

   PROCEDURE OpenConfig(lcXML)
      LOCAL lii, liCount,liS,liE,luCatch

      luCatch=m.This.SetCatch(.T.) && Nastav zachycen chyby
      lcXML=FILETOSTR(m.This.xmlConfig)
      m.This.SetCatch(m.luCatch) && Zru zachycen chyby
      IF m.This.nErr>0 OR EMPTY(lcXML)
         RETURN .F.
      ENDIF

      * odstra komente
      *1234567890
      *..<- ->...
      liCount=OCCURS("<!--",lcXML)
      FOR lii=liCount TO 1 STEP -1
          liS=ATC("<!--",lcXML,lii)
          liE=ATC("-->",lcXML,lii)
          lcXML=STUFF(lcXML,liS,liE+3-liS+1,"")
      NEXT
      RETURN .T.  
   ENDPROC

   PROCEDURE _ReadOptions(lcXML,llNoAutoRead)
      IF !m.This.OpenConfig(@lcXML)
         RETURN .F.
      ENDIF
      =IIF(llNoAutoRead,.T.,This.ReadOptions(@lcXML))
      RETURN .T.
   ENDPROC

   PROCEDURE ReadOptions(lcXML,lcSection)
      LOCAL liReconnect,lcBlock,liInterval,lcServer,lcIP

      lcBlock=STREXTRACT(lcXML,'<options>',"</options>",1)

      IF EMPTY(lcSection)
         liReconnect=VAL(STREXTRACT(lcBlock,'<reconnect>',"</reconnect>",1))
         This.ReconnectInterval=IIF(liReconnect<=0,10000,liReconnect)

         liInterval=VAL(STREXTRACT(lcBlock,'<threadinterval>',"</threadinterval>",1))
         This.tmrThreads.Interval=IIF(liInterval<=0,500,liInterval)

         liInterval=VAL(STREXTRACT(lcBlock,'<laginterval>',"</laginterval>",1))
         This.tmrLag.Interval=IIF(liInterval<=0,1000,liInterval)

         liInterval=VAL(STREXTRACT(lcBlock,'<timeoutinterval>',"</timeoutinterval>",1))
         This.tmrTO.Interval=IIF(liInterval<=0,300000,liInterval)

         liInterval=VAL(STREXTRACT(lcBlock,'<sendinterval>',"</sendinterval>",1))
         This.tmrsn.Interval=IIF(liInterval<=0,250,liInterval)

         liInterval=VAL(STREXTRACT(lcBlock,'<Ininterval>',"</Ininterval>",1))
         This.tmrJC.Interval=IIF(liInterval<=0,250,liInterval)
      ENDIF

      IF (EMPTY(lcSection) OR lcSection=="smtp")
         lcBlock=STREXTRACT(lcBlock,'<smtp>',"</smtp>",1)

         IF PEMSTATUS(This,"oSMTP",5)
            lcServer=STREXTRACT(lcBlock,'<server>',"</server>",1)
            lcIP=STREXTRACT(lcBlock,'<ip>',"</ip>",1)

            This.oSMTP.Server=IIF(!EMPTY(lcIP),lcIP,lcServer)
            This.oSMTP.Port=VAL(STREXTRACT(lcBlock,'<port>',"</port>",1))
            This.oSMTP.Port=IIF(This.oSMTP.Port<=0,25,This.oSMTP.Port)
            This.oSMTP.User=STREXTRACT(lcBlock,'<user>',"</user>",1)
            This.oSMTP.Password=STREXTRACT(lcBlock,'<password>',"</password>",1)
            This.oSMTP.Method=STREXTRACT(lcBlock,'<method>',"</method>",1)
         ENDIF

         This.SMTP_DNSReply=STREXTRACT(lcBlock,'<dnsreply>',"</dnsreply>",1)
         This.SMTP_From=STREXTRACT(lcBlock,'<from>',"</from>",1)

      ENDIF

   ENDPROC


   PROCEDURE SMTPTest()
      RETURN PEMSTATUS(This,"oSMTP",5)
   ENDPROC

   PROCEDURE SMTPCreate()
      This.AddObject("oSMTP","_SMTPLayer")
      LOCAL lcXML
      IF loJC._ReadOptions(@lcXML,.T.)
         This.ReadOptions(@lcXML,"smtp")
      ENDIF
   ENDPROC

   PROCEDURE Destroy()
      IF USED(This.AJID)
         USE IN (This.AJID)
      ENDIF
      IF USED(This.ACJID)
         USE IN (This.ACJID)
      ENDIF
      IF USED(This.ALANGC)
         USE IN (This.ALANGC)
      ENDIF
      IF USED(This.ACommands)
         USE IN (This.ACommands)
      ENDIF
      IF USED(This.ASpy)
         USE IN (This.ASpy)
      ENDIF
      IF USED(This.AServices)
         USE IN (This.AServices)
      ENDIF
      IF USED(This.ASilent)
         USE IN (This.ASilent)
      ENDIF
      This.oXML2=.NULL.
      RELEASE LIBRARY (This.MainPath+"botthrd.fll")
      RELEASE PROCEDURE (This.MainPath+"threads")
      RELEASE PROCEDURE (This.MainPath+"smtp")
      =DODEFAULT() && Voln pvodn metody
   ENDPROC

   PROCEDURE Init()
      LOCAL lcXX, liy,lii,lcPath
      =DODEFAULT() && Voln pvodn metody
      This.AJID=SYS(2015)
      This.ACJID=SYS(2015)
      This.ALANGC=SYS(2015)

      This.ACommands=SYS(2015)
      This.ASpy=SYS(2015)
      This.AServices=SYS(2015)
      This.ASilent=SYS(2015)


      lcPath=SYS(16,0)
      lcPath=SUBST(lcPath,AT(" ",lcPath,2)+1)
      STORE IIF(RAT("\",lcPath)>0,LEFT(lcPath,RAT("\",lcPath)),lcPath) TO This.MainPath,lcPath


      PUBLIC aUTF8cs(1)


      IF This.OpenTable(lcPath+"data\jbjid.dbf",This.AJID,"AGAIN")#ErrOK
         RETURN .F.
      ENDIF

      IF This.OpenTable(lcPath+"data\jbcjid.dbf",This.ACJID,"AGAIN")#ErrOK
         RETURN .F.
      ENDIF

      IF This.OpenTable(lcPath+"data\langc.dbf",This.ALANGC,"AGAIN")#ErrOK
         RETURN .F.
      ENDIF

      IF This.OpenTable(lcPath+"data\jbspy.dbf",This.ASpy,"AGAIN")#ErrOK
         RETURN .F.
      ENDIF

      IF This.OpenTable(lcPath+"data\services.dbf",This.AServices,"AGAIN")#ErrOK
         RETURN .F.
      ENDIF

      IF This.OpenTable(lcPath+"data\jbsilent.dbf",This.ASilent,"AGAIN")#ErrOK
         RETURN .F.
      ENDIF

      SET PROCEDURE TO (lcPath+"threads") ADDITIVE
      SET PROCEDURE TO (lcPath+"smtp") ADDITIVE

      This.AddObject("tmrThreads","_tmrThreadsbot")

      * Intern seznam pkaz
      CREATE CURSOR (This.ACommands) (XX400I I, XX401 M NOCPTRANS, XX402 M NOCPTRANS)
      INDEX ON XX400I TAG XXI000
      INDEX ON LEFT(XX401,240) TAG XXI001

      RESTORE FROM (lcPath+"utf8cs.mem") ADDITIVE
      SET LIBRARY TO (lcPath+"botthrd.fll") ADDITIVE

      DECLARE INTEGER WinExec in kernel32 string,integer
      DECLARE         Sleep IN kernel32 integer
      DECLARE INTEGER GetTimeZoneInformation IN kernel32.dll STRING @

      SELE (This.AJID)
      SET ORDER TO "XXI000"

      SELE (This.ALANGC)
      SET ORDER TO "I02"


      lcXX=TTOC(DATETIME(),1)+LTRIM(STR(SECO(),11))
      liy=0
      FOR lii=1 TO LEN(m.lcXX)
          liy=m.liy+VAL(SUBST(m.lcXX,m.lii,1))
      NEXT
      =RAND(m.liy)


      lcXX=""
      FOR lii=1 TO 255
          IF !ISALPHA(CHR(lii)) AND !ISDIGIT(CHR(lii))
             lcXX=lcXX+CHR(lii)
          ENDIF
      NEXT

      This.DChars=STRCONV(lcXX,9)

      =GetCTISO2WIN(@lcXX)
      This.CTFromISO=lcXX

      =GetCTWIN2ISO(@lcXX)
      This.CTToISO=lcXX

   ENDPROC


   PROCEDURE AddCommand(liXX400I,lcXX401,lcXX402)
      INSERT INTO (This.ACommands) VALUES (m.liXX400I,m.lcXX401,m.lcXX402)
   ENDPROC

   PROCEDURE AddSpy(loSP,liXX400I,liXX501,lcXX502,lcXX503)
*idjid  id Jid 
*cidjid id jid conference
*xx505  datum ma as 
*xx400i id pkazu
*xx501  numerick doplnk (bad words)
*xx502  parametry pkazu
*xx503  textov parametr
      INSERT INTO (This.ASpy) VALUES (m.loSP.IDJID,m.loSP.CIDJID,DATETIME(),m.liXX400I,m.liXX501,m.lcXX502,m.lcXX503)
   ENDPROC

   PROCEDURE ClearReferences
      IF !EMPTY(This.cGUI) AND TYPE(This.cGUI+".Name")="C"
         STORE .NULL. TO (This.cGUI+".JC")
      ENDIF
   ENDPROC

   PROCEDURE Disconnect(liStatus)
      LOCAL loSP
      loSP=CREATEOBJECT("_serviceParam")
      loSP.oJC=m.This
      =This.Services.Disconnect(m.loSP)

      IF This.iMode=1 && komponenta
         SELECT (m.This.ACJID)
         SET ORDER TO "XXI002"
         SCAN ALL
              lcData=[<presence from="]+m.This.ReplyFrom+;
                     [" to="]+JID+[" type="unavailable" />]
              This.SendData(@m.lcData,0)
              SELECT (m.This.ACJID)
         ENDSCAN
      ENDIF

      DODEFAULT(liStatus)
   ENDPROC

   PROCEDURE Disconnected()
      LOCAL loSP
      loSP=CREATEOBJECT("_serviceParam")
      loSP.oJC=m.This
      This.tmrThreads.Enabled=.F.
      =This.Services.Disconnected(m.loSP)
      =This.Services.UnLoad() && UnLoad all services
      =DODEFAULT()
      IF USED(This.ACommands)
         SELECT (This.ACommands)
         ZAP
      ENDIF
      CLEAR EVENTS
   ENDPROC


   PROCEDURE SetDeCSLang(liIDJID,llDECS) && Nastav jazyk
      LOCAL lii
      lii=ASCAN(m.This.aDeCS,m.liIDJID)
      IF m.lii=0
         lii=ASCAN(m.This.aDeCS,-1) && Najdi voln lsto
         IF lii=0 && Nenael...
            STORE m.This.iDeCS+1 TO This.iDeCS,lii
            DIME This.aDeCS(m.lii),This.aDeCSL(m.lii)
         ENDIF
         This.aDeCS(m.lii)=m.liIDJID
      ENDIF
      This.aDeCSL(m.lii)=llDECS
   ENDPROC

   PROCEDURE GetDeCSLang(liIDJID) && Vrt lang
      LOCAL lii
      lii=ASCAN(m.This.aDeCS,m.liIDJID)
      RETURN IIF(m.lii>0,This.aDeCSL(m.lii),.NULL.)
   ENDPROC



   PROCEDURE NormalizeSpace(lcText) && vyhod pebyten mezery
      *@lcText 
      DO WHILE AT("  ",m.lcText)>0
         IF AT("    ",m.lcText)>0
            m.lcText=STRTRAN(m.lcText,"    "," ")
         ELSE
            IF AT("   ",m.lcText)>0
               m.lcText=STRTRAN(m.lcText,"   "," ")
            ELSE
               IF AT("  ",m.lcText)>0
                  m.lcText=STRTRAN(m.lcText,"  "," ")
               ENDIF
            ENDIF
         ENDIF
      ENDDO
   ENDPROC


   PROCEDURE GetIDJID(lcJID,llDontAdd,llNew) && Vrt intern ID dle JID
      * lcJID     - JID
      * llDontAdd - Don'nt add JID if not found
      LOCAL liSele,liidjid,llSeek
      liSele=SELE()
      SELE (m.This.AJID)
      SET ORDER TO "XXI001"
      IF LEN(m.lcJID)>240
         SET KEY TO (m.lcJID)
         LOCATE FOR JID==m.lcJID
         llSeek=FOUND()
         SET KEY TO
      ELSE
         llSeek=SEEK(m.lcJID) AND JID==m.lcJID
      ENDIF
      IF !m.llSeek
         SET ORDER TO "XXI000"
         GO BOTTOM
         liidjid=IDJID+1
         IF !llDontAdd && Pokud ho nenael, pak ho zalo
            INSERT INTO (This.AJID) (JID,IDJID) VALUES (m.lcJID,m.liidjid)
            llNew=.T. && Nastav pznak, e ho je nov
         ELSE
            liidjid=-2000000001
         ENDIF
      ELSE
         liidjid=IDJID
      ENDIF
      SELE (m.liSele)
      RETURN m.liidjid
   ENDPROC

   PROCEDURE GetJID(liIDJID,llShort) && Vrt JID dle internho ID
      * lcJID   - JID
      * llShort - 
      LOCAL lcPom,lii
      lcPom=IIF(SEEK(BINTOC(m.liIDJID),m.This.AJID,"XXI000"),EVAL(m.This.AJID+".JID"),"")
      lii=AT("/",m.lcPom)
      RETURN IIF(m.llShort AND m.lii>0,LEFT(m.lcPom,m.lii-1),m.lcPom)
   ENDPROC

   PROCEDURE InitXML() && Inicializace XML DOM
      This.oXML2=CREATEOBJECT("Microsoft.XMLDOM")
      This.oXML2.async=.F.
      This.oXML2.SetProperty("SelectionLanguage","XPath")
   ENDPROC


   PROCEDURE SendMessage(loMSG,liType,liInterval) && Odesln zprvy
      * loMSG      - Objekt zprvy
      * liType     - Typ zprvy
      * liInterval - Interval pro odesln

      * Najdi nkde zda se m odstranit diakritika
      LOCAL llDeCS,liIDJID,lii,lcConf,liTXT,liHTML,loCMSG,lcID
      LOCAL ARRAY laTXT(1),laHTML(1)
      liIDJID=This.GetIDJID(m.loMsg.To)
      IF !ISNUL(liIDJID)
         llDeCS=This.GetDeCSLang(liIDJID)
         IF !ISNULL(llDeCS) AND llDeCS
            loMsg.Subject=UTF8Tocs(@aUTF8cs,loMsg.Subject)
            loMsg.Body=UTF8Tocs(@aUTF8cs,loMsg.Body)
            loMsg.HTML=UTF8Tocs(@aUTF8cs,loMsg.HTML)
         ENDIF
      ENDIF

      * Vem konferenci z to
      * nati flag, zda je to IRC gate
      * pokud ano, vytvo kopie po dkch 
      lii=AT("/",m.loMsg.To)
      lcConf=IIF(m.lii>0,LEFT(m.loMsg.To,lii-1),m.loMsg.To)

      IF m.This.GetJIDFlag(lcConf,1)
         STORE 0 TO m.liTXT,m.liHTML
         IF LEN(loMsg.Body)>0
            liTXT=ALINES(laTXT,loMsg.Body)
         ENDIF

         IF LEN(loMsg.HTML)>0
            liHTML=ALINES(laHTML,STRTRAN(loMsg.HTML,"<br />",CRLF))
         ENDIF

         lcID=m.loMSG.ID
         loCMSG=m.loMSG.CloneMessage()
         IF m.liTXT=m.liHTML
            FOR lii=1 TO m.liTXT
                loCMsg.Body=m.laTXT(m.lii)
                loCMsg.HTML=m.laHTML(m.lii)
                IF lii>1
                   m.loCMSG.ID=lcID+"_"+LTRIM(STR(m.lii,11))
                ENDIF
                =DODEFAULT(m.loCMSG,m.liType,m.liInterval)
            NEXT
         ELSE
            loCMsg.HTML=""
            FOR lii=1 TO m.liTXT
                IF lii>1
                   m.loCMSG.ID=lcID+"_"+LTRIM(STR(m.lii,11))
                ENDIF
                loCMsg.Body=m.laTXT(m.lii)
                =DODEFAULT(m.loCMSG,m.liType,m.liInterval)
            NEXT
         ENDIF
      ELSE
         RETURN DODEFAULT(m.loMSG,m.liType,m.liInterval)
      ENDIF
   ENDPROC

   PROCEDURE SubjectToQP(lcSubject)
      LOCAL lii,liCount,lcPom
      LOCAL ARRAY laRows(1)
      lcPom=ToQP(lcSubject)
      IF !lcPom==lcSubject
         liCount=ALINES(laRows,lcPom)
         lcSubject=""
         FOR lii=1 TO liCount
             lcSubject="=?utf-8?q?"+laRows(lii)+"?="+CRLF
         NEXT
      ENDIF
      RETURN lcSubject
   ENDPROC

   PROCEDURE toSMTP(loSP)
      LOCAL loXX,loXML,lii,loSMTP
      loSMTP=CREATEOBJECT("_tosmtp")

      loXML=m.loSP.oJCP.oXML

      loSMTP.oSP=loSP
      loSMTP.ID=NVL(loXML.documentElement.GetAttribute("id"),"")
      loSMTP.From=loSP.Conf
      loSMTP.To=loSP.ReplyFrom

      loXX=m.loXML.documentElement.selectNodes("*[local-name()='subject']")
      IF loXX.Length>0
         loSMTP.Subject=loXX.Item(0).Text
      ENDIF
   
      loSMTP.Body=loSP.cBody

      loXX=m.loXML.documentElement.selectNodes("*[local-name()='html']")
      IF loSP.iHTML=1
         lcHTML=loXX.Item(0).XML
         lii=AT("<",lcHTML,2)
         loSMTP.html=STUFF(lcHTML,lii,0,[<head><meta content="text/html; charset=utf-8" http-equiv="Content-Type" /></head>])
      ENDIF

      =This._toSMTP(loSMTP)

   ENDPROC

   PROCEDURE MSGtoSMTP(loMSG)
      LOCAL loSMTP,lcNick,lcUNick,lcConf
      loSMTP=CREATEOBJECT("_tosmtp")

      loSP=CREATEOBJECT("_serviceParam")
      loSP.oJC=m.This

      loSP.Type=_jbm_Normal

      lcConf=loMSG.From && Posl to samotn konfera
      lcNick=""
      IF AT("/",m.lcFrom)>0 && Je to od nkoho z konfery lcType=="groupchat"
         lcConf=LEFT(m.lcFrom,AT("/",m.lcFrom)-1)
         lcNick=SUBST(m.lcFrom,AT("/",m.lcFrom)+1)
      ENDIF
      lcUNick=UPPER(m.lcNick)

      loSP.ReplyFrom=loMSG.To
      loSP.ReplyTo=m.lcFrom
      loSP.From=loMSG.From
      loSP.Conf=m.lcConf
      loSP.Nick=m.lcNick
      loSP.UNick=m.lcUNick

      loSMTP.oSP=m.loSP
      
      loSMTP.ID=loMSG.ID
      loSMTP.From=loMSG.From
      loSMTP.To=loMSG.To

      loSMTP.Subject=loMSG.Subject
      loSMTP.Body=loMSG.Body
      loSMTP.html=[<html xmlns="http://www.w3.org/TR/xhtml-basic">]+;
                  [<head><meta content="text/html; charset=utf-8" http-equiv="Content-Type" /></head>]+;
                  [<body>]+loMSG.html+[</body></html>]

      =This._toSMTP(loSMTP)
   ENDPROC

   PROCEDURE _toSMTP(loSMTP)
      LOCAL loThread,lcKey,lcFrom,lcTo,lcSubject,lcHTML
      lcKey=SYS(2015)+":"+SYS(2015)+":"+SYS(2015)

      lcFrom=CHRTRAN(loSMTP.From,"@","%")
      IF !EMPTY(This.SMTP_From)
         liy=ATC("%namereply%",This.SMTP_From)
         IF liy>0
            lcFrom=STUFF(This.SMTP_From,liy,LEN("%namereply%"),CHRTRAN(loSMTP.oSP.Conf,"@","%"))
         ELSE
            lcFrom=This.SMTP_From
         ENDIF
      ENDIF

      liy=ATC("%dnsreply%",lcFrom)
      DO CASE

         CASE !EMPTY(This.SMTP_DNSReply) AND EMPTY(This.SMTP_From)
              lcFrom=lcFrom+"@"+This.SMTP_DNSReply

         CASE !EMPTY(This.SMTP_DNSReply) AND !EMPTY(This.SMTP_From) AND liy>0
              lcFrom=STUFF(lcFrom,liy,LEN("%dnsreply%"),This.SMTP_DNSReply)

      ENDCASE

      lcTo=CHRTRAN(LEFT(loSMTP.To,AT("@",loSMTP.To)-1),"%","@")

      lcSubject=""
      IF LEN(loSMTP.Subject)>0
         lcSubject=This.SubjectToQP(loSMTP.Subject)
      ENDIF

      loThread=CREATEOBJECT("_thr_smtp")
      loThread.oSP=m.loSMTP.oSP
      loThread.Header="RSET"+CRLF+;
                      "MAIL FROM: "+lcFrom+CRLF+;
                      "RCPT TO: "+lcTo+CRLF+;
                      "DATA"

      lcTZ=REPLICATE(CHR(0),172)
      =GetTimeZoneInformation(@lcTZ)

*                    "Message-ID: <"+IIF(EMPTY(m.loSMTP.ID),SYS(2015)+"."+SYS(2015), m.loSMTP.ID)+SUBST(lcFrom,AT("@",lcFrom))+">"+CRLF+;
*


      loThread.Body="MIME-Version: 1.0"+CRLF+;
                    "To: "+lcTo+CRLF+;
                    "From: "+lcFrom+CRLF+;
                    "X-Mailer: VisualFoxPro-Jabber-SMTP-Transport"+CRLF+;
                    "Subject: "+IIF(LEN(lcSubject)>0,lcSubject,"")+CRLF+;
                    "Date: "+SUBSTR(_days, (DOW(DATE(),0)-1)*3+1,3 )+", "+;
                             CHRTRAN(STR(DOW(DATE(),0),2)," ","0")+" "+;
                             SUBSTR(_months, (MONTH(DATE())-1)*3+1,3 )+" "+;
                             STR(YEAR(DATE()),4)+" "+TIME()+" +"+;
                             CHRTRAN(STR(ABS(C4ToL(LEFT(lcTZ,4))/60),2)+"  "," ","0")+CRLF

      DO CASE
         CASE !EMPTY(loSMTP.Body) AND !EMPTY(loSMTP.html)
              loThread.Body=loThread.Body+;
                            [Content-type: multipart/alternative; boundary="]+lcKey+["]+CRLF+;
                            CRLF+;
                            "--"+lcKey+CRLF+;
                            "Content-Type: text/plain; charset=utf-8"+CRLF+;
                            "Content-Transfer-Encoding: 8bit"+CRLF+;
                            "Content-Description: Jabber text message"+CRLF+;
                            CRLF+;
                            loSMTP.Body+CRLF+;
                            CRLF+;
                            "--"+lcKey+CRLF+;
                            "Content-Type: text/html; charset=utf-8"+CRLF+;
                            "Content-Transfer-Encoding: 8bit"+CRLF+;
                            "Content-Description: Jabber html message"+CRLF+;
                            CRLF+;
                            loSMTP.html+CRLF+;
                            ""+CRLF+;
                            "--"+lcKey+"--"+CRLF+;
                            ""+CRLF+;
                            "."+CRLF+CRLF


         CASE !EMPTY(loSMTP.Body) AND EMPTY(loSMTP.html)
              loThread.Body=loThread.Body+;
                            "Content-Type: text/plain; charset=utf-8"+CRLF+;
                            "Content-Transfer-Encoding: 8bit"+CRLF+;
                            "Content-Description: Jabber text message"+CRLF+;
                            CRLF+;
                            loSMTP.Body+CRLF+;
                            CRLF+;
                            "."+CRLF+CRLF

         CASE EMPTY(loSMTP.Body) AND !EMPTY(loSMTP.html)
              loThread.Body=loThread.Body+;
                            "Content-Type: text/html; charset=utf-8"+CRLF+;
                            "Content-Transfer-Encoding: 8bit"+CRLF+;
                            "Content-Description: Jabber html message"+CRLF+;
                            CRLF+;
                            loSMTP.html+CRLF+;
                            CRLF+;
                            "."+CRLF+CRLF

      ENDCASE
      =This.tmrThreads.AddThread(loThread)
   ENDPROC


   PROCEDURE GetMessage(loJCP) && Pijmut zprvy
      * loJCP - Jabber client process

      LOCAL lcFrom, loBody,lcBody,lii,lcNick,lcUNick,lcConf,lihtml,lcData,lcHTML,;
            liIDJID,liCIDJID,loXX,lcLang,liLang,lcType,loXML,;
            liType,loMsg,liErr,loSP,loX,lcXX900

      loSP=CREATEOBJECT("_serviceParam")
      loSP.oJCP=m.loJCP
      loSP.oJC=m.This

      * Jde o zprvu (message/chat/chatgroup)
      loXML=m.loJCP.oXML

      lcType=NVL(m.loXML.documentElement.GetAttribute("type"),"")
      lcFrom=NVL(loXML.documentElement.GetAttribute("from"),"")

      liIDJID=This.GetIDJID(@m.lcFrom)

      loSP.IDJID=liIDJID


*<message from='hauz@conference.jabber.cz' to='FoxBot@njs.netlab.cz' type='normal'>
*<body>You have been kicked from the room hauz@conference.jabber.cz. Reason: vypadni</body>
*<x xmlns='http://jabber.org/protocol/muc#user'><status code='307'/></x></message>


      IF m.lcType="error"
         liErr="-1"
         loXX=m.loXML.documentElement.selectNodes("*[local-name()='error']")
         IF m.loXX.length>0 &&
            liErr=m.loXX.Item(0).GetAttribute("code")
            DEBUGOUT "ERR: "+m.liErr+" "+m.loXX.Item(0).Text
         ENDIF
         loJCP.nError=VAL(m.liErr)
      ENDIF

      loMsg=CREATEOBJECT("_jbmessage")
      loMsg.ID=loJCP.ID && Pevezmi ID

      liType=IIF(lcType=="groupchat",_jbm_GroupChat,IIF(lcType=="chat",_jbm_Chat,_jbm_Normal))
      loSP.Type=m.liType

      lcConf=m.lcFrom && Posl to samotn konfera
      lcNick=""
      IF AT("/",m.lcFrom)>0 && Je to od nkoho z konfery lcType=="groupchat"
         lcConf=LEFT(m.lcFrom,AT("/",m.lcFrom)-1)
         lcNick=SUBST(m.lcFrom,AT("/",m.lcFrom)+1)
      ENDIF
      lcUNick=UPPER(m.lcNick)
      liCIDJID=m.This.GetIDJID(@m.lcConf)

      lcLang=loXML.documentElement.GetAttribute("xml:lang")
      lcLang=NVL(m.lcLang,m.This.DefLang)
      SELE (m.This.ALANGC)
      liLang=IIF(SEEK(PADR(m.lcLang,10)),LID,1029) && Locale ID

      m.loSP.ReplyFrom=loXML.documentElement.GetAttribute("to")
      m.loSP.ReplyTo=IIF(liType=_jbm_GroupChat,m.lcConf,m.lcFrom)
      m.loSP.RIDJID=IIF(liType=_jbm_GroupChat,m.liCIDJID,m.liIDJID)
      m.loSP.From=m.lcFrom
      m.loSP.Conf=m.lcConf
      m.loSP.Nick=m.lcNick
      m.loSP.UNick=m.lcUNick
      m.loSP.CIDJID=m.liCIDJID
      m.loSP.Lang=m.lcLang

      * veker texty peve na DBCS
      lcBody=""
      lihtml=0
      STORE .NULL. To loX,loBody

      loXX=m.loXML.documentElement.selectNodes("*[local-name()='x' and namespace-uri()='jabber:x:delay']")
      IF m.loXX.length>0 &&
         IF Stamp2DT(m.loXX.Item(0).GetAttribute("stamp"))<DATETIME()
            RETURN
         ENDIF
      ENDIF

      loXX=m.loXML.documentElement.selectNodes("*[local-name()='html']")
      IF m.loXX.length>0 &&
         lihtml=1
      ENDIF

      loXX=m.loXML.documentElement.selectNodes("*[local-name()='body']")
      IF m.loXX.length>0 &&
         loBody=m.loXX.Item(0)
         lcBody=LTRIM(HTMLStringTranStr(m.loBody.text))
      ENDIF

      loXX=m.loXML.documentElement.selectNodes("*[local-name()='thread']")
      IF m.loXX.length>0
         loMsg.Thread=loXX.Item(0).Text && Pevezmi Thread
      ENDIF

      loSP.cBody=m.lcBody
      loSP.oBody=m.loBody
      loSP.iHTML=m.liHTML


      IF This.iMode=1 AND ATC("%",loSP.ReplyFrom)>0
         This.toSMTP(m.loSP)
         RETURN
      ENDIF


      This.Services.RunAll(_Serv_Group_Command,m.loSP)

      =IIF(!EMPTY(This.cGUI) AND TYPE(This.cGUI+".Name")="C",EVAL(This.cGUI+".GetMessage(loJCP)"),.T.)

      loMsg.From=m.loSP.ReplyFrom

      IF m.loSP.ParseCommand()

        loMsg.To=m.lcConf && Pjemce
          
        DO CASE
           CASE m.loSP.iWords=0
                loMsg.Body=[Please, specify command,]+m.lcNick
                m.This.SendMessage(@m.loMsg,liType,0)

           CASE m.loSP.iWords=3 AND m.loSP.aUWords(1)=="RESTART" AND m.loSP.aUWords(2)=="SERVICES"
                m.This.AddSpy(@loSP,_cmd_RESTART_SERVICES,0,"","")
                m.This.Services.Reload(VAL(m.laWords(3)))

           CASE m.loSP.aUWords(1)=="SET" AND m.loSP.aUWords(2)=="DECS" AND m.loSP.iWords=3
                m.This.AddSpy(@loSP,_cmd_SET_DECS,0,m.loSP.aWords(3),"")
                This.SetDeCSLang(IIF(m.loSP.Type=_jbm_GroupChat,m.loSP.CIDJID,m.loSP.IDJID), m.loSP.aUWords(3)="1")


           CASE m.loSP.iWords=3 AND m.loSP.aUWords(1)=="START" AND m.loSP.aUWords(2)=="SERVICE"
                m.This.AddSpy(@loSP,_cmd_START_SERVICE,0,m.loSP.aWords(3),"")
                =This.Services.Start(m.loSP.aWords(3))

           CASE m.loSP.iWords=3 AND m.loSP.aUWords(1)=="STOP" AND m.loSP.aUWords(2)=="SERVICE"
                m.This.AddSpy(@loSP,_cmd_STOP_SERVICE,0,m.loSP.aWords(3),"")
                =This.Services.Stop(m.loSP.aWords(3))

           CASE m.loSP.iWords=3 AND m.loSP.aUWords(1)=="PAUSE" AND m.loSP.aUWords(2)=="SERVICE"
                m.This.AddSpy(@loSP,_cmd_PAUSE_SERVICE,0,m.loSP.aWords(3),"")
                =This.Services.Pause(m.loSP.aWords(3))

           CASE m.loSP.iWords=3 AND m.loSP.aUWords(1)=="RESUME" AND m.loSP.aUWords(2)=="SERVICE"
                m.This.AddSpy(@loSP,_cmd_RESUME_SERVICE,0,m.loSP.aWords(3),"")
                =This.Services.Resume(m.loSP.aWords(3))

           CASE m.loSP.iWords=3 AND m.loSP.aUWords(1)=="RESTART" AND m.loSP.aUWords(2)=="SERVICE"
                m.This.AddSpy(@loSP,_cmd_RESTART_SERVICE,0,m.loSP.aWords(3),"")
                =This.Services.Restart(m.loSP.aWords(3))

           CASE m.loSP.iWords=1 AND m.loSP.aUWords(1)=="STATUS"
                m.This.AddSpy(@loSP,_cmd_STATUS,0,"","")
                loMsg=CREATEOBJECT("_jbmessage")
                loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
                loMsg.To=m.loSP.ReplyTo && Pjemce
                loSers=m.This.Services
                lcPom=""
                liMax=0
                FOR lii=1 TO loSers.iServices
                    loSer=loSers.aServicesO(m.lii)
                    liMax=MAX(LEN(ALLT(m.loSer.Info.XX901)),m.liMax)
                NEXT

                FOR lii=1 TO loSers.iServices
                    loSer=loSers.aServicesO(m.lii)
                    lcPom=lcPom+;
                          PADR(loSer.Name,10)+" "+PADR(LTRIM(loSer.Info.XX901),m.liMax)+" "+;
                          IIF(loSer.State=_Serv_Start_Panic,"Panic",;
                          IIF(loSer.State=_Serv_Start_Failed,"Failed",;
                          IIF(loSer.State=_Serv_Start_Disabled,"Disabled",;
                          IIF(loSer.State=_Serv_Start_Stop,"Stop",;
                          IIF(loSer.State=_Serv_Start_Pause,"Pause",;
                          IIF(loSer.State=_Serv_Start_Running,"Running","Unknown"))))))+CRLF
                NEXT

                loMsg.Body=STRCONV(lcPom,9)
                loMsg.HTML=[<span style='font-family: Courier New;'>]+;
                         STRCONV(STRTRAN(m.lcPom,CRLF,"<br />"),9)+[</span>]
                m.This.SendMessage(@m.loMsg,m.loSP.Type,0)


           CASE m.loSP.iWords=1 AND m.loSP.aUWords(1)=="HELP"
                m.This.AddSpy(@loSP,_cmd_HELP,0,"","")
                loMsg=CREATEOBJECT("_jbmessage")
                loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
                loMsg.To=m.loSP.ReplyTo && Pjemce

                STORE "" TO lcPom,lcHTML
                SELE (m.This.ACommands)
                SCAN ALL
                     lcPom=m.lcPom+[!]+ALLT(XX401)+" - "+ALLT(XX402)+CRLF
                     lcHTML=m.lcHTML+[<span style="font-weight: bold;">!]+StrTranHTMLString(ALLT(XX401))+"</span> - "+StrTranHTMLString(ALLT(XX402))+"<br />"
                ENDSCAN
                loMsg.Body=lcPom+[In room's conference you must all command's direct to foxbot: FoxBot: !Command]
                loMsg.HTML=lcHTML+[In room's conference you must all command's direct to foxbot: FoxBot: !Command]
                m.This.SendMessage(@m.loMsg,m.loSP.Type,0)

           CASE m.loSP.iWords=1 AND m.loSP.aUWords(1)=="LIST"
                m.This.AddSpy(@loSP,_cmd_LIST,0,"","")
                loMsg=CREATEOBJECT("_jbmessage")
                loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
                loMsg.To=m.loSP.ReplyTo && Pjemce

                STORE "" TO lcPom,lcHTML
                SELE (m.This.ACommands)
                SCAN ALL
                     lcPom=m.lcPom+ALLT(XX401)+", "
                ENDSCAN
                loMsg.Body=LEFT(m.lcPom,LEN(m.lcPom)-2)+CRLF+[In room's conference you must all command's direct to foxbot: FoxBot: !Command]
                m.This.SendMessage(@m.loMsg,m.loSP.Type,0)

           CASE BETWEEN(m.loSP.iWords,2,4) AND m.loSP.aUWords(1)=="SHUT" AND m.loSP.aUWords(2)=="UP"
                * SHUT UP              - Silent mode z [current from] na all service
                * SHUT UP #service     - Silent mode z [current from] na service
                * SHUT UP ALL          - Silent mode z [all from] na all service
                * SHUT UP ALL #service - Silent mode z [all from] na service

                SELE (m.This.ASILENT)
                SET ORDER TO "XXI000"

                IF m.loSP.iWords>=3 AND m.loSP.aUWords(3)=="ALL"
                   lcXX900=IIF(m.loSP.iWords=3,SPACE(10),m.This.Services.CheckXX900(SUBST(m.loSP.aWords(4),2)))
                   lii=-1
                   m.This.AddSpy(@loSP,_cmd_SHUT_UP_ALL,0,lcXX900,"")
                ELSE
                   lcXX900=IIF(m.loSP.iWords=2,SPACE(10),m.This.Services.CheckXX900(SUBST(m.loSP.aWords(3),2)))
                   m.This.AddSpy(@loSP,_cmd_SHUT_UP,0,lcXX900,"")
                   lii=m.loSP.RIDJID
                ENDIF

                IF !SEEK(lcXX900+BINTOC(lii))
                   INSERT INTO (m.This.ASILENT) (IDJID,XX900,XX102) VALUES (lii,lcXX900,1)
                ELSE
                   REPL XX102 WITH 1
                ENDIF

           CASE BETWEEN(m.loSP.iWords,2,4) AND m.loSP.aUWords(1)=="SPEAK" AND m.loSP.aUWords(2)=="UP"
                * SPEAK UP              - !Silent mode z [current from] na all service
                * SPEAK UP #service     - !Silent mode z [current from] na service
                * SPEAK UP ALL          - !Silent mode z [all from] na all service
                * SPEAK UP ALL #service - !Silent mode z [all from] na service

                SELE (m.This.ASILENT)
                SET ORDER TO "XXI000"

                IF m.loSP.iWords>=3 AND m.loSP.aUWords(3)=="ALL"
                   lcXX900=IIF(m.loSP.iWords=3,SPACE(10),m.This.Services.CheckXX900(SUBST(m.loSP.aWords(4),2)))
                   lii=-1
                   m.This.AddSpy(@loSP,_cmd_SPEAK_UP_ALL,0,lcXX900,"")
                ELSE
                   lcXX900=IIF(m.loSP.iWords=2,SPACE(10),m.This.Services.CheckXX900(SUBST(m.loSP.aWords(3),2)))
                   m.This.AddSpy(@loSP,_cmd_SPEAK_UP,0,lcXX900,"")
                   lii=m.loSP.RIDJID
                ENDIF

                IF !SEEK(lcXX900+BINTOC(lii))
                   INSERT INTO (m.This.ASILENT) (IDJID,XX900,XX102) VALUES (lii,lcXX900,0)
                ELSE
                   REPL XX102 WITH 0
                ENDIF

        ENDCASE
      ENDIF
   ENDPROC


   PROCEDURE GetSilentMode(liIDJID,lcXX900) && Vrt, pznak tichho mdu
      LOCAL liSele,llSM
      liSele=SELE()
      lcXX900=m.This.Services.CheckXX900(lcXX900)
      SELE (m.This.ASILENT)
      SET ORDER TO "XXI000"
      llSM=.F.
      DO CASE
         * test na globln silent mode
         CASE SEEK(SPACE(10)+BINTOC(-1)) AND XX102=1
              llSM=.T.

         * test na silent mode vech service z konkrtnho vstupu
         CASE SEEK(SPACE(10)+BINTOC(liIDJID)) AND XX102=1
              llSM=.T.

         * test na silent mode service vech vstup
         CASE SEEK(lcXX900+BINTOC(-1)) AND XX102=1
              llSM=.T.

         * test na silent mode service konkrtnho vstupu
         CASE SEEK(lcXX900+BINTOC(liIDJID)) AND XX102=1
              llSM=.T.

      ENDCASE
      SELE (m.liSele)
      RETURN llSM
   ENDPROC

   PROCEDURE IsConf(lcJID) && Vrt, zda je to konference
      * lcJID     - JID konference
      LOCAL liSele,llSeek
      liSele=SELE()
      SELE (m.This.AJID)
      SET ORDER TO "XXI001"
      IF LEN(m.lcJID)>240
         SET KEY TO (m.lcJID)
         LOCATE FOR JID==m.lcJID
         llSeek=FOUND()
         SET KEY TO
      ELSE
         llSeek=SEEK(m.lcJID)
      ENDIF
      SELE (m.liSele)
      RETURN IIF(m.llSeek, BITTEST(EVAL(m.This.AJID+".STATUS"),0),.F.)
   ENDPROC



   PROCEDURE SetJIDFlag(lcJID,liBit,liFlag) && Nastav pznak JID
      * lcJID  - JID 
      * liBit  - Bit
      * liFlag - Flag (0 - reset, 1 - set)
      LOCAL liSele,llSeek
      liSele=SELE()
      SELE (m.This.AJID)
      SET ORDER TO "XXI001"
      IF LEN(m.lcJID)>240
         SET KEY TO (m.lcJID)
         LOCATE FOR JID==m.lcJID
         llSeek=FOUND()
         SET KEY TO
      ELSE
         llSeek=SEEK(m.lcJID)
      ENDIF
      IF m.llSeek AND IIF(BITTEST(STATUS,liBit),1,0)#liFlag
         REPL STATUS WITH IIF(liFlag=0,BITCLEAR(STATUS,liBit),BITSET(STATUS,liBit))
      ENDIF
      SELE (liSele)
   ENDPROC


   PROCEDURE GetJIDFlag(lcJID,liBit) && Vrt pznak JID
      * lcJID     - JID konference
      * liBit  - Bit
      LOCAL liSele,llSeek
      liSele=SELE()
      SELE (m.This.AJID)
      SET ORDER TO "XXI001"
      IF LEN(m.lcJID)>240
         SET KEY TO (m.lcJID)
         LOCATE FOR JID==m.lcJID
         llSeek=FOUND()
         SET KEY TO
      ELSE
         llSeek=SEEK(m.lcJID)
      ENDIF
      SELE (m.liSele)
      RETURN IIF(m.llSeek, BITTEST(EVAL(m.This.AJID+".STATUS"),liBit),.F.)
   ENDPROC


   PROCEDURE SetVolumeVoice(liVolume,liDVolume)
      * liVolume  - 
      * liDVolume - 

      LOCAL loServ
      loServ=This.Services.GetService("SPEEKING  ")
      IF ISNULL(m.loServ)
         RETURN .F.
      ENDIF
      =loServ.SetVolumeVoice(This,liVolume,liDVolume)
   ENDPROC


   PROCEDURE GetCommandID(lcCommand) && Vrt ID pkazu
      LOCAL llSeek
      SELE (m.This.ACommands)
      IF LEN(m.lcCommand)>240
         SET KEY TO (m.lcCommand)
         LOCATE FOR XX401==m.lcCommand
         llSeek=FOUND()
         SET KEY TO
      ELSE
         llSeek=SEEK(m.lcCommand)
         llSeek=llSeek AND LEN(m.lcCommand)==LEN(XX401)
      ENDIF
      RETURN IIF(llSeek,XX400I,-2000000001)
   ENDPROC


   PROCEDURE GetPresence(loJCP) && Pijmut presence
      * loJCP - Jabber client process
      LOCAL lcFrom,lcConf,lcNick,loXXX,loXML,loSP,liRet,llConf,lcType,llSeek,lii,loXX
      liRet=DODEFAULT(m.loJCP)

      loXML=m.loJCP.oXML
      lcFrom=m.loXML.documentElement.GetAttribute("from")
      IF AT("/",m.lcFrom)>0 && Je to od nkoho z konfery
         lcConf=LEFT(m.lcFrom,AT("/",m.lcFrom)-1)
         lcNick=SUBST(m.lcFrom,AT("/",m.lcFrom)+1)
      ELSE
         lcConf=m.lcFrom && Posl to samotn konfera
         lcNick=""
      ENDIF

      loSP=CREATEOBJECT("_serviceParam")
      loSP.oJCP=m.loJCP
      loSP.oJC=m.This

      m.loSP.ReplyFrom=loXML.documentElement.GetAttribute("to")
      m.loSP.From=m.lcFrom
      m.loSP.Conf=m.lcConf
      m.loSP.Nick=m.lcNick

      m.loSP.IDJID=m.This.GetIDJID(@m.lcFrom)
      m.loSP.CIDJID=m.This.GetIDJID(@m.lcConf)

      IF m.liRet=_JC_P_Free && Nebylo to zpracovno
         loXX=m.loXML.documentElement.selectNodes("*[local-name()='x' and namespace-uri()='http://jabber.org/protocol/muc#user']")
         IF m.loXX.length>0
            llConf=.T.
         ENDIF
         loSP.lConf=llConf

         IF This.Services.RunAll(_Serv_Group_Command,m.loSP)=_Serv_Run_Processed
            liRet=_JC_P_Processed
         ENDIF

         IF m.loJCP.Status#_JC_P_Trackly
            =IIF(!EMPTY(This.cGUI) AND TYPE(This.cGUI+".Name")="C",EVAL(This.cGUI+".Presence(loJCP)"),.T.)
         ENDIF
      ENDIF


      IF This.iMode=1 && komponenta
         lcType=m.loXML.documentElement.GetAttribute("type")
         IF ISNULL(lcType)
            loXXX=m.loXML.documentElement.selectNodes("*[local-name()='status']")
            lcType=IIF(m.loXXX.length=0,.NULL.," ") && Pokud je to logon
         ENDIF
         DO CASE

            CASE m.liRet=_JC_P_Processed AND ;
                (ISNULL(lcType) OR  !ISNULL(lcType) AND lcType="probe") && Log On/probe
                 * Pidat do internho seznamu
                 SELECT (m.This.ACJID)
                 SET ORDER TO "XXI001"

                 IF LEN(m.lcFrom)>240
                    SET KEY TO (m.lcFrom)
                    LOCATE FOR JID==m.lcFrom
                    llSeek=FOUND()
                    SET KEY TO
                 ELSE
                    llSeek=SEEK(m.lcFrom)
                    llSeek=llSeek AND LEN(m.lcFrom)==LEN(JID)
                 ENDIF
                 IF !llSeek
                    SET ORDER TO "XXI002"
                    IF SEEK(.T.)
                       RECALL NEXT 1
                       REPLACE JID WITH m.lcFrom
                    ELSE
                       INSERT INTO (m.This.ACJID) (JID) VALUES (m.lcFrom)
                    ENDIF
                 ENDIF


            CASE liRet=_JC_P_Processed AND !ISNULL(lcType) AND lcType="unavailable" && Log out
                 lii=m.This.AddRemoConf(-1,m.This.AConf,m.lcConf,m.This.DefNick,.NULL.)
                 IF ISNULL(lii) OR lii=0
                    * odebrat z internho seznamu
                    SELECT (m.This.ACJID)
                    SET ORDER TO "XXI001"

                    IF LEN(m.lcFrom)>240
                       SET KEY TO (m.lcFrom)
                       LOCATE FOR JID==m.lcFrom
                       llSeek=FOUND()
                       SET KEY TO
                    ELSE
                       llSeek=SEEK(m.lcFrom)
                       llSeek=llSeek AND LEN(m.lcFrom)==LEN(JID)
                    ENDIF

                    IF llSeek
                       DELE NEXT 1
                    ENDIF
                 ENDIF
         ENDCASE
      ENDIF
 
      RETURN m.liRet
   ENDPROC


   PROCEDURE GetIQ(loJCP) && Pijmut Info/query
      * loJCP - Jabber client process
      LOCAL liRet
      liRet=DODEFAULT(m.loJCP)

      RETURN liRet
   ENDPROC

  
   PROCEDURE Connected() && Dolo ke kompletnmu pihlen k JS
      LOCAL lcAlias,lcAlias2,loSP,lcData
*      Co je to tady za bordel???
*!*	      IF RECC(This.AConf)>0
*!*	         lcAlias2=SYS(2015)
*!*	         =CopyCursor(This.AConf,@m.lcAlias2,.T.,.T.)
*!*	         SELE (m.lcAlias2)
*!*	         INDEX ON LEFT(JID,240) TAG XXI000 FOR !DELE()
*!*	      ENDIF

      =DODEFAULT() && Voln pvodn metody


      IF This.iMode=1 && komponenta
         SELECT (m.This.ACJID)
         SET ORDER TO "XXI002"
         SCAN ALL
              lcData=[<presence from="]+m.This.ReplyFrom+;
                     [" to="]+JID+["><status>Online</status></presence>]
              This.SendData(@m.lcData,0)

              SELECT (m.This.ACJID)
         ENDSCAN
      ENDIF

      This.Services.Load() && Load all services


      loSP=CREATEOBJECT("_serviceParam")
      loSP.oJC=m.This
      =This.Services.Connected(m.loSP)
      This.tmrThreads.Enabled=.T.

      =This.AddCommand(_cmd_RESTART_SERVICES,"RESTART SERVICES","")
      =This.AddCommand(_cmd_SET_DECS,"SET DECS","")
      =This.AddCommand(_cmd_START_SERVICE,"START SERVICE","")
      =This.AddCommand(_cmd_STOP_SERVICE,"STOP SERVICE","")
      =This.AddCommand(_cmd_PAUSE_SERVICE,"PAUSE SERVICE","")
      =This.AddCommand(_cmd_RESUME_SERVICE,"RESUME SERVICE","")
      =This.AddCommand(_cmd_RESTART_SERVICE,"RESTART SERVICE","")
      =This.AddCommand(_cmd_STATUS,"STATUS","")
      =This.AddCommand(_cmd_HELP,"HELP","Return list all commands")
      =This.AddCommand(_cmd_LIST,"LIST","Return list all commands")
      =This.AddCommand(_cmd_SHUT_UP,"SHUT UP","")
      =This.AddCommand(_cmd_SHUT_UP_ALL,"SHUT UP ALL","")
      =This.AddCommand(_cmd_SPEAK_UP,"SPEAK UP","")
      =This.AddCommand(_cmd_SPEAK_UP_ALL,"SPEAK UP ALL","")


   ENDPROC

   PROCEDURE JoinedToConf(loJCP,lcConf,lcNick) && Pihlen do konference - potvrzeno
      =This.SetJIDFlag(lcConf,0,1)
      =IIF(!EMPTY(This.cGUI) AND TYPE(This.cGUI+".Name")="C",EVAL(This.cGUI+".Joined(loJCP)"),.T.)
   ENDPROC

   PROCEDURE LeavedFromConf(loJCP,lcConf,lcNick) && Odhlen z konference - potvrzeno
       =IIF(!EMPTY(This.cGUI) AND TYPE(This.cGUI+".Name")="C",EVAL(This.cGUI+".Leaved(loJCP)"),.T.)
   ENDPROC

   PROCEDURE BrowseResult(m.loJCP)
      LOCAL loSP
      =IIF(!EMPTY(This.cGUI) AND TYPE(This.cGUI+".Name")="C",EVAL(This.cGUI+".Browse(loJCP)"),.T.)

      loSP=CREATEOBJECT("_serviceParam")
      loSP.oJCP=m.loJCP
      loSP.oJC=m.This
      loSP.ReplyFrom=m.loJCP.oXML.documentElement.GetAttribute("to")
      =This.Services.BrowseResult(m.loSP)
   ENDPROC

   PROCEDURE RosterResult(m.loJCP)
   ENDPROC

   PROCEDURE FilterResult(m.loJCP)
   ENDPROC

ENDDEFINE


**************************************************
DEFINE CLASS _services AS custom
   Name="_services"

   iServices=0 && Count of Services
   DIME aServicesO(1),aServicesC(1)

   PROCEDURE CheckXX900(lcXX900)
      RETURN PADR(UPPER(lcXX900),10)
   ENDPROC
  
   PROCEDURE _Add(lcXX900,loService) && Add service to internal list
      * lcXX900   - Code of service
      * loService - Object of service
      
      LOCAL lii,liy
      STORE ASCAN(m.This.aServicesC,m.lcXX900) TO lii,liy
      IF m.lii=0
         STORE m.This.iServices+1 TO This.iServices,lii
         DIME This.aServicesO(m.lii),This.aServicesC(m.lii)
         This.aServicesC(m.lii)=m.lcXX900
         This.aServicesO(m.lii)=loService
      ENDIF
      RETURN IIF(liy=0,.F.,.T.)
   ENDPROC
   

   PROCEDURE Start(lcXX900) && Start service
      * lcXX900 - Code of service
      lcXX900=m.This.CheckXX900(m.lcXX900)

      LOCAL lii
      loService=This.CreateService(lcXX900,1)
      IF ISNULL(m.loService)
         RETURN
      ENDIF
      lii=ASCAN(m.This.aServicesC,m.lcXX900) && Find service in Array
      IF m.lii>0 && Sluba je zaveden
         m.This.aServicesO(m.lii)=m.loService && Pak ji pepi
      ELSE
         =m.This._Add(XX900,m.loService)
      ENDIF
      loService.State=IIF(XX902=0,_Serv_Start_Disabled,;
                      IIF(loService.Start(m.This.Parent),_Serv_Start_Running,_Serv_Start_Failed))
   ENDPROC

   PROCEDURE Stop(lcXX900) && Stop service
      * lcXX900 - Code of service
      lcXX900=m.This.CheckXX900(m.lcXX900)
      LOCAL lii,lcPom
      lii=ASCAN(m.This.aServicesC,m.lcXX900)
      IF m.lii>0 AND INLIST(m.This.aServicesO(m.lii).State,_Serv_Start_Running,_Serv_Start_Failed)
         =This.aServicesO(m.lii).Stop(This.Parent)
         lcPom=This.aServicesO(m.lii).Class
         This.aServicesO(m.lii)=m.This.CreateService(lcXX900,0)
         This.aServicesO(m.lii).State=_Serv_Start_Stop
         CLEAR CLASS (m.lcPom)
         CLEAR PROGRAM
      ENDIF
   ENDPROC

   PROCEDURE Pause(lcXX900) && Pause service
      * lcXX900 - Code of service
      lcXX900=m.This.CheckXX900(m.lcXX900)
      LOCAL lii
      lii=ASCAN(m.This.aServicesC,m.lcXX900)
      IF m.lii>0 AND m.This.aServicesO(m.lii).State=_Serv_Start_Running
         =This.aServicesO(m.lii).Stop(This.Parent)
         m.This.aServicesO(m.lii).State=_Serv_Start_Pause
      ENDIF
   ENDPROC

   PROCEDURE Resume(lcXX900) && Resume service
      * lcXX900 - Code of service
      lcXX900=m.This.CheckXX900(m.lcXX900)

      LOCAL lii
      lii=ASCAN(m.This.aServicesC,m.lcXX900)
      IF m.lii>0 AND m.This.aServicesO(m.lii).State=_Serv_Start_Pause
         This.aServicesO(m.lii).State=IIF(m.This.aServicesO(m.lii).Start(m.This.Parent),_Serv_Start_Running,_Serv_Start_Failed)
      ENDIF
   ENDPROC

   PROCEDURE Restart(lcXX900) && Restart service
      * lcXX900 - Code of service
      lcXX900=m.This.CheckXX900(m.lcXX900)
      This.Stop(m.lcXX900)
      This.Start(m.lcXX900)
   ENDPROC


   PROCEDURE GetService(lcXX900) && Get service interface
      * lcXX900 - Code of service
      lcXX900=m.This.CheckXX900(m.lcXX900)
      LOCAL lii
      lii=ASCAN(m.This.aServicesC,m.lcXX900)
      RETURN IIF(m.lii=0,.NULL.,m.This.aServicesO(m.lii))
   ENDPROC

   PROCEDURE RunAll(lcXX904,loSP) && Run all services
      * lcXX904 - Group of services
      * loSP    - Service parameter
      LOCAL lii,liRet
      SELE (m.This.Parent.aServices)
      SET ORDER TO "XXI9033"
      =SEEK(m.lcXX904)

      liRet=_Serv_Run_Free
      SCAN WHILE XX904==m.lcXX904 AND liRet#_Serv_Run_Processed
           lii=ASCAN(m.This.aServicesC,XX900)

           IF m.This.aServicesO(m.lii).State=_Serv_Start_Running
              m.This.aServicesO(m.lii).oSP=m.loSP
              liRet=m.This.aServicesO(m.lii).Run(m.loSP)
              m.This.aServicesO(m.lii).oSP=.NULL.
           ENDIF

           SELE (m.This.Parent.aServices)
      ENDSCAN

      RETURN m.liRet
   ENDPROC


   PROCEDURE Load(liReload)
      * liReload - Type or reload
      LOCAL loJC,loService,lii,liy
      LOCAL ARRAY laServs(1)
      loJC=This.Parent
      liReload=IIF(PCOUNT()=1,m.liReload,_Serv_Reload_Hard)

      SELE (loJC.AServices)
      GO TOP
      SET ORDER TO "XXI9033"
      DIME laServs(RECC(),1)
      COPY TO ARRAY laServs FIELDS XX900
      FOR liy=1 TO RECC()
          IF liReload=_Serv_Reload_Hard
             =m.This.Start(laServs(m.liy))
          ELSE
             lii=ASCAN(m.This.aServicesC,XX900)
             m.This.aServicesO(m.lii).Resume(m.This.Parent)
          ENDIF
      NEXT
      RETURN .T.
   ENDPROC


   PROCEDURE Reload(liReload)
      * liReload - Type or reload
      LOCAL lii
      FOR lii=1 TO m.This.iServices
          =IIF(m.This.aServicesO(m.lii).State=_Serv_Start_Running,;
               IIF(m.liReload=_Serv_Reload_Hard,m.This.aServicesO(m.lii).Stop(m.This.Parent),m.This.aServicesO(m.lii).Pause(m.This.Parent)),.F.)
          IF m.liReload=_Serv_Reload_Hard
             STORE .NULL. TO m.This.aServicesO(m.lii),m.This.aServicesC(m.lii)
          ENDIF
      NEXT
      IF m.liReload=_Serv_Reload_Hard
         m.This.iServices=0
         DIME m.This.aServicesO(1),m.This.aServicesC(1)
      ENDIF 
      RETURN m.This.Load(liReload)
   ENDPROC

   PROCEDURE Unload()
      LOCAL lii
      FOR lii=1 TO m.This.iServices
          IF !ISNULL(m.This.aServicesC(m.lii))
             =IIF(m.This.aServicesO(m.lii).State=_Serv_Start_Running,;
                  m.This.aServicesO(m.lii).Stop(m.This.Parent),.T.)
             STORE .NULL. TO m.This.aServicesO(m.lii),m.This.aServicesC(m.lii)
          ENDIF
      NEXT
      This.iServices=0
   ENDPROC

   PROCEDURE CreateService(lcXX900,liService)
      LOCAL loService,luCatch,lcService

      SELE (This.Parent.AServices)
      SET ORDER TO "XXI9030"
      IF !SEEK(m.lcXX900)
         RETURN .NULL.
      ENDIF
      lcService=IIF(liService=0 OR XX902=0,"",XX910)
      loService=.NULL.
      IF !EMPTY(m.lcService)
         lcService=FULLPATH(ALLT(m.lcService),m.This.Parent.MainPath+"services\")
         luCatch=m.This.Parent.SetCatch(.T.)
         DO GetInterface WITH m.loService IN (m.lcService)
         m.This.Parent.SetCatch(m.luCatch) && Zru zachycen chyby
      ENDIF
      IF ISNULL(m.loService)
         loService=CREATEOBJECT("_service")
         loService.State=_Serv_Start_Panic
      ELSE
         loService.MainPath=LEFT(m.lcService,RAT("\",m.lcService))
      ENDIF
      loService.Name=ALLT(m.lcXX900)
      SCATTER NAME loService.Info MEMO
      =loService.AfterInit(m.This.Parent)
      RETURN m.loService
   ENDPROC

   PROCEDURE Connected(loSP) && Run all services
      * loSP    - Service parameter
      LOCAL lii,liRet
      SELE (m.This.Parent.aServices)
      SET ORDER TO "XXI9033"

      liRet=_Serv_Run_Free
      SCAN ALL &&  liRet#_Serv_Run_Processed
           lii=ASCAN(m.This.aServicesC,XX900)

           IF m.This.aServicesO(m.lii).State=_Serv_Start_Running
              m.This.aServicesO(m.lii).oSP=m.loSP
              liRet=m.This.aServicesO(m.lii).Connected(m.loSP)
              m.This.aServicesO(m.lii).oSP=.NULL.
           ENDIF

           SELE (m.This.Parent.aServices)
      ENDSCAN

      RETURN m.liRet
   ENDPROC

   PROCEDURE Disconnect(loSP) && Run all services
      * loSP    - Service parameter
      LOCAL lii,liRet
      IF m.This.iServices=0
         RETURN 0
      ENDIF
      SELE (m.This.Parent.aServices)
      SET ORDER TO "XXI9033"
      SCAN ALL &&  liRet#_Serv_Run_Processed
           lii=ASCAN(m.This.aServicesC,XX900)
           IF m.This.aServicesO(m.lii).State=_Serv_Start_Running
              m.This.aServicesO(m.lii).oSP=m.loSP
              liRet=m.This.aServicesO(m.lii).Disconnect(m.loSP)
              m.This.aServicesO(m.lii).oSP=.NULL.
           ENDIF

           SELE (m.This.Parent.aServices)
      ENDSCAN
      RETURN m.liRet
   ENDPROC

   PROCEDURE Disconnected(loSP) && Run all services
      * loSP    - Service parameter
      LOCAL lii,liRet
      SELE (m.This.Parent.aServices)
      SET ORDER TO "XXI9033"
      SCAN ALL &&  liRet#_Serv_Run_Processed
           lii=ASCAN(m.This.aServicesC,XX900)

           IF lii>0 AND !ISNULL(m.This.aServicesO(m.lii)) AND m.This.aServicesO(m.lii).State=_Serv_Start_Running
              m.This.aServicesO(m.lii).oSP=m.loSP
              liRet=m.This.aServicesO(m.lii).Disconnected(m.loSP)
              m.This.aServicesO(m.lii).oSP=.NULL.
           ENDIF

           SELE (m.This.Parent.aServices)
      ENDSCAN
      RETURN m.liRet
   ENDPROC


   PROCEDURE BrowseResult(loSP) && Run all services
      * loSP    - Service parameter
      LOCAL lii,liRet
      SELE (m.This.Parent.aServices)
      SET ORDER TO "XXI9033"

      liRet=_Serv_Run_Free
      SCAN ALL &&  liRet#_Serv_Run_Processed
           lii=ASCAN(m.This.aServicesC,XX900)

           IF m.This.aServicesO(m.lii).State=_Serv_Start_Running
              m.This.aServicesO(m.lii).oSP=m.loSP
              liRet=m.This.aServicesO(m.lii).BrowseResult(m.loSP)
              m.This.aServicesO(m.lii).oSP=.NULL.
           ENDIF
           SELE (m.This.Parent.aServices)
      ENDSCAN

      RETURN m.liRet
   ENDPROC

ENDDEFINE

**************************************************
DEFINE CLASS _service AS session
   Name="_service"

   MainPath=""
   State=0 && 0 - stop, 1 - start, -2 - disabled, -1 - start failed

   Info=.NULL.
   oSP=.NULL.

   PROCEDURE Init()
      * Set basic SETs for private session
      SET EXACT OFF
      SET TALK OFF
      SET DELE OFF
      SET SAFETY OFF
      SET COLLATE TO "MACHINE"
      SET DECI TO 4
      SET POINT TO "."
      SET BLOCKSIZE TO 1 && For memo pole
      SET CENTURY ON
      SET HOURS TO 24
   ENDPROC

   PROCEDURE Destroy()
   ENDPROC

   PROCEDURE AfterInit(loJC)
      * loJC - Object reference to jabber object
   ENDPROC

   PROCEDURE OpenSources(loJC)
      * loJC - Object reference to jabber object
   ENDPROC

   PROCEDURE CloseSources(loJC)
      * loJC - Object reference to jabber object
   ENDPROC

   PROCEDURE Start(loJC)
      * loJC - Object reference to jabber object
      IF !m.This.OpenSources(m.loJC)
         RETURN .F.
      ENDIF
   ENDPROC

   PROCEDURE Stop(loJC)
      * loJC - Object reference to jabber object
      This.CloseSources(m.loJC)
   ENDPROC

   PROCEDURE Run(loSP)
      * loSP - Object reference to service parameter
      LOCAL lcNodeName
      lcNodeName=loSP.oJCP.oXML.documentElement.nodename

      * Info/query
      IF lcNodeName=="iq"
         RETURN m.This.GetIQ(m.loSP)
      ENDIF

      * Presence
      IF lcNodeName=="presence"
         RETURN m.This.GetPresence(m.loSP)
      ENDIF

      * Jde o zprvu (message/chat/chatgroup)
      IF lcNodeName=="message"
         RETURN m.This.GetMessage(m.loSP)
      ENDIF

      * Jde o handshake
      IF lcNodeName=="handshake"
         RETURN m.This.GetHandshake(m.loSP)
      ENDIF

      IF lcNodeName=="stream:stream"
         RETURN m.This.GetStream(m.loSP)
      ENDIF

      RETURN _Serv_Run_Free 
   ENDPROC


   PROCEDURE GetIQ(m.loSP)
      RETURN _Serv_Run_Free 
   ENDPROC

   PROCEDURE GetPresence(m.loSP)
      RETURN _Serv_Run_Free 
   ENDPROC

   PROCEDURE GetMessage(m.loSP)
      RETURN _Serv_Run_Free 
   ENDPROC

   PROCEDURE GetHandshake(m.loSP)
      RETURN _Serv_Run_Free 
   ENDPROC

   PROCEDURE GetStream(m.loSP)
      RETURN _Serv_Run_Free 
   ENDPROC

   PROCEDURE Connected(loSP)
      * loSP - Object reference to service parameter
   ENDPROC

   PROCEDURE Disconnected(loSP)
      * loSP - Object reference to service parameter
   ENDPROC

   PROCEDURE Disconnect(loSP)
      * loSP - Object reference to service parameter
   ENDPROC

   PROCEDURE BrowseResult(loSP)
      * loSP - Object reference to service parameter
   ENDPROC

ENDDEFINE




**************************************************
DEFINE CLASS _serviceParam AS custom
   Name="_serviceParam"

   PROTECTED _Analysed,_IsCommand

   oJCP=.NULL. &&  Jabber client process
   oJC=.NULL. &&  Jabber client
   iWords=0
   DIME aWords(1),aUWords(1)

   Type=0

   From=""
   Conf=""
   ReplyFrom=""
   ReplyTo=""
   Nick=""
   UNick=""
   RIDJID=0
   CIDJID=0
   IDJID=0
   Lang=0

   oBody=.NULL.
   iHTML=0

   lConf=.F.
   cBody=""
   cBodyC=""


   PROCEDURE ParseCommand()
      * Zpracuj ve co nen od RoBota
      IF This._Analysed
         RETURN m.This._IsCommand
      ENDIF
      This._Analysed=.T.
      LOCAL lcPom,llCommand,lcUNick,liLen
      LOCAL ARRAY laWords(1),laUWords(1)
      lcUNick=UPPER(m.This.oJC.DefNick)
      liLen=LEN(m.lcUNick)+1

      IF !m.This.UNick==lcUNick AND;
         (UPPER(LEFT(LTRIM(m.This.cBody),m.liLen))==m.lcUNick+":" OR !m.This.Type=_jbm_GroupChat)

         lcPom=IIF(m.This.Type=_jbm_GroupChat OR UPPER(LEFT(LTRIM(m.This.cBody),m.liLen))==m.lcUNick+":",LTRIM(SUBST(m.This.cBody,m.liLen+1)),m.This.cBody) && odfiltruj nick


         IF LEFT(lcPom,1)="!" && Pkaz
            STORE SUBST(lcPom,2) TO lcPom,This.cBodyC
   
            liWords=AWords(@m.lcPom," "+CHR(9)+CHR(13)+CHR(10),@laWords)
            =CopyArrayU(@laWords,@laUWords)

            This.iWords=m.liWords
            DIME This.aWords(m.liWords)This.aUWords(m.liWords)
            =ACOPY(laWords,This.aWords)
            =ACOPY(laUWords,This.aUWords)
            This._IsCommand=.T.
            RETURN .T.
          ENDIF
       ENDIF   
       RETURN .F.
   ENDPROC

ENDDEFINE


****************************************************************
*
****************************************************************
DEFINE CLASS _tmrThreadsbot AS _tmrThreads

   PROCEDURE Error(nError,cMethod,nLine) && Chybov rutina
      * nError  - slo chyby
      * cMethod - Nzev metody ve kter dolo k chyb
      * nLine   - slo dku na kterm dolo k chyb

       DEBUGOUT This.Class+":: "+PROGRAM(PROGRAM(-1)-1)+":"+cMethod+":"+LTRIM(STR(nLine,11))+" "+MESSAGE()
       =This.Parent.Error(nError,cMethod,nLine)
   ENDPROC
ENDDEFINE


****************************************************************
PROCEDURE GetInterface(loo) && Virtual function
ENDPROC

****************************************************************
*
****************************************************************
DEFINE CLASS _tosmtp AS custom
   Name="_tosmtp"
   
   From=""
   To=""
   Subject=""
   
   Body=""
   html=""

   ID=""

   oSP=.NULL.   
ENDDEFINE
